/*
 * Validations API Endpoint
 *
 * L2 data validation from WI DPI.
 *
 * The version of the OpenAPI document: 1.0.0
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Net.Mime;
using EdFi.OdsApi.Sdk.Client;
using EdFi.OdsApi.Sdk.Client.Auth;
using EdFi.OdsApi.Sdk.Models.Validations;

namespace EdFi.OdsApi.Sdk.Api.Validations
{

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IValidationRulesApiSync : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Retrieves specific resources using the resource&#39;s property values (using the \&quot;Get\&quot; pattern).
        /// </summary>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional)</param>
        /// <param name="limit"> (optional)</param>
        /// <param name="id"> (optional)</param>
        /// <param name="ruleIdentifier">The unique Id for a validation rule. (optional)</param>
        /// <param name="ruleSource">The source or origin of the rule. (optional)</param>
        /// <param name="ruleStatus">The current status of if the rule. Examples are &#39;Active&#39;, &#39;Under Analysis&#39;, &#39;Inactive&#39;, &#39;Deprecated&#39;. (optional)</param>
        /// <param name="category">A category for the type of validation rule.  Examples might be &#39;Student Demographics&#39;, &#39;Special Education&#39;, or &#39;Attendance&#39; (optional)</param>
        /// <param name="severityDescriptor">Whether the validation rule is a &#39;Warning&#39;, &#39;Minor Validation Error&#39;, &#39;Major Validation Error&#39; or other value standardized by the API (optional)</param>
        /// <param name="externalRuleId">Refers back to a unique identifier for this rule in another system (such as a state-maintained repository of validation rules) (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>List&lt;ValidationRule&gt;</returns>
        List<ValidationRule> EdFiXvalidationsValidationRulesGet(int? offset = default(int?), int? limit = default(int?), string? id = default(string?), string? ruleIdentifier = default(string?), string? ruleSource = default(string?), string? ruleStatus = default(string?), string? category = default(string?), string? severityDescriptor = default(string?), string? externalRuleId = default(string?), int operationIndex = 0);

        /// <summary>
        /// Retrieves specific resources using the resource&#39;s property values (using the \&quot;Get\&quot; pattern).
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional)</param>
        /// <param name="limit"> (optional)</param>
        /// <param name="id"> (optional)</param>
        /// <param name="ruleIdentifier">The unique Id for a validation rule. (optional)</param>
        /// <param name="ruleSource">The source or origin of the rule. (optional)</param>
        /// <param name="ruleStatus">The current status of if the rule. Examples are &#39;Active&#39;, &#39;Under Analysis&#39;, &#39;Inactive&#39;, &#39;Deprecated&#39;. (optional)</param>
        /// <param name="category">A category for the type of validation rule.  Examples might be &#39;Student Demographics&#39;, &#39;Special Education&#39;, or &#39;Attendance&#39; (optional)</param>
        /// <param name="severityDescriptor">Whether the validation rule is a &#39;Warning&#39;, &#39;Minor Validation Error&#39;, &#39;Major Validation Error&#39; or other value standardized by the API (optional)</param>
        /// <param name="externalRuleId">Refers back to a unique identifier for this rule in another system (such as a state-maintained repository of validation rules) (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of List&lt;ValidationRule&gt;</returns>
        ApiResponse<List<ValidationRule>> EdFiXvalidationsValidationRulesGetWithHttpInfo(int? offset = default(int?), int? limit = default(int?), string? id = default(string?), string? ruleIdentifier = default(string?), string? ruleSource = default(string?), string? ruleStatus = default(string?), string? category = default(string?), string? severityDescriptor = default(string?), string? externalRuleId = default(string?), int operationIndex = 0);
        /// <summary>
        /// Retrieves a specific resource using the resource&#39;s identifier (using the \&quot;Get By Id\&quot; pattern).
        /// </summary>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">A resource identifier that uniquely identifies the resource.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ValidationRule</returns>
        ValidationRule EdFiXvalidationsValidationRulesIdGet(string id, int operationIndex = 0);

        /// <summary>
        /// Retrieves a specific resource using the resource&#39;s identifier (using the \&quot;Get By Id\&quot; pattern).
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">A resource identifier that uniquely identifies the resource.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of ValidationRule</returns>
        ApiResponse<ValidationRule> EdFiXvalidationsValidationRulesIdGetWithHttpInfo(string id, int operationIndex = 0);
        #endregion Synchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IValidationRulesApiAsync : IApiAccessor
    {
        #region Asynchronous Operations
        /// <summary>
        /// Retrieves specific resources using the resource&#39;s property values (using the \&quot;Get\&quot; pattern).
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional)</param>
        /// <param name="limit"> (optional)</param>
        /// <param name="id"> (optional)</param>
        /// <param name="ruleIdentifier">The unique Id for a validation rule. (optional)</param>
        /// <param name="ruleSource">The source or origin of the rule. (optional)</param>
        /// <param name="ruleStatus">The current status of if the rule. Examples are &#39;Active&#39;, &#39;Under Analysis&#39;, &#39;Inactive&#39;, &#39;Deprecated&#39;. (optional)</param>
        /// <param name="category">A category for the type of validation rule.  Examples might be &#39;Student Demographics&#39;, &#39;Special Education&#39;, or &#39;Attendance&#39; (optional)</param>
        /// <param name="severityDescriptor">Whether the validation rule is a &#39;Warning&#39;, &#39;Minor Validation Error&#39;, &#39;Major Validation Error&#39; or other value standardized by the API (optional)</param>
        /// <param name="externalRuleId">Refers back to a unique identifier for this rule in another system (such as a state-maintained repository of validation rules) (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of List&lt;ValidationRule&gt;</returns>
        System.Threading.Tasks.Task<List<ValidationRule>> EdFiXvalidationsValidationRulesGetAsync(int? offset = default(int?), int? limit = default(int?), string? id = default(string?), string? ruleIdentifier = default(string?), string? ruleSource = default(string?), string? ruleStatus = default(string?), string? category = default(string?), string? severityDescriptor = default(string?), string? externalRuleId = default(string?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Retrieves specific resources using the resource&#39;s property values (using the \&quot;Get\&quot; pattern).
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional)</param>
        /// <param name="limit"> (optional)</param>
        /// <param name="id"> (optional)</param>
        /// <param name="ruleIdentifier">The unique Id for a validation rule. (optional)</param>
        /// <param name="ruleSource">The source or origin of the rule. (optional)</param>
        /// <param name="ruleStatus">The current status of if the rule. Examples are &#39;Active&#39;, &#39;Under Analysis&#39;, &#39;Inactive&#39;, &#39;Deprecated&#39;. (optional)</param>
        /// <param name="category">A category for the type of validation rule.  Examples might be &#39;Student Demographics&#39;, &#39;Special Education&#39;, or &#39;Attendance&#39; (optional)</param>
        /// <param name="severityDescriptor">Whether the validation rule is a &#39;Warning&#39;, &#39;Minor Validation Error&#39;, &#39;Major Validation Error&#39; or other value standardized by the API (optional)</param>
        /// <param name="externalRuleId">Refers back to a unique identifier for this rule in another system (such as a state-maintained repository of validation rules) (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (List&lt;ValidationRule&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<ValidationRule>>> EdFiXvalidationsValidationRulesGetWithHttpInfoAsync(int? offset = default(int?), int? limit = default(int?), string? id = default(string?), string? ruleIdentifier = default(string?), string? ruleSource = default(string?), string? ruleStatus = default(string?), string? category = default(string?), string? severityDescriptor = default(string?), string? externalRuleId = default(string?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Retrieves a specific resource using the resource&#39;s identifier (using the \&quot;Get By Id\&quot; pattern).
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">A resource identifier that uniquely identifies the resource.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ValidationRule</returns>
        System.Threading.Tasks.Task<ValidationRule> EdFiXvalidationsValidationRulesIdGetAsync(string id, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Retrieves a specific resource using the resource&#39;s identifier (using the \&quot;Get By Id\&quot; pattern).
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">A resource identifier that uniquely identifies the resource.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (ValidationRule)</returns>
        System.Threading.Tasks.Task<ApiResponse<ValidationRule>> EdFiXvalidationsValidationRulesIdGetWithHttpInfoAsync(string id, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IValidationRulesApi : IValidationRulesApiSync, IValidationRulesApiAsync
    {

    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class ValidationRulesApi : IValidationRulesApi
    {
        private EdFi.OdsApi.Sdk.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="ValidationRulesApi"/> class.
        /// </summary>
        /// <returns></returns>
        public ValidationRulesApi() : this((string)null)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ValidationRulesApi"/> class.
        /// </summary>
        /// <returns></returns>
        public ValidationRulesApi(string basePath)
        {
            this.Configuration = EdFi.OdsApi.Sdk.Client.Configuration.MergeConfigurations(
                EdFi.OdsApi.Sdk.Client.GlobalConfiguration.Instance,
                new EdFi.OdsApi.Sdk.Client.Configuration { BasePath = basePath }
            );
            this.Client = new EdFi.OdsApi.Sdk.Client.ApiClient(this.Configuration.BasePath);
            this.AsynchronousClient = new EdFi.OdsApi.Sdk.Client.ApiClient(this.Configuration.BasePath);
            this.ExceptionFactory = EdFi.OdsApi.Sdk.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ValidationRulesApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public ValidationRulesApi(EdFi.OdsApi.Sdk.Client.Configuration configuration)
        {
            if (configuration == null) throw new ArgumentNullException("configuration");

            this.Configuration = EdFi.OdsApi.Sdk.Client.Configuration.MergeConfigurations(
                EdFi.OdsApi.Sdk.Client.GlobalConfiguration.Instance,
                configuration
            );
            this.Client = new EdFi.OdsApi.Sdk.Client.ApiClient(this.Configuration.BasePath);
            this.AsynchronousClient = new EdFi.OdsApi.Sdk.Client.ApiClient(this.Configuration.BasePath);
            ExceptionFactory = EdFi.OdsApi.Sdk.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ValidationRulesApi"/> class
        /// using a Configuration object and client instance.
        /// </summary>
        /// <param name="client">The client interface for synchronous API access.</param>
        /// <param name="asyncClient">The client interface for asynchronous API access.</param>
        /// <param name="configuration">The configuration object.</param>
        public ValidationRulesApi(EdFi.OdsApi.Sdk.Client.ISynchronousClient client, EdFi.OdsApi.Sdk.Client.IAsynchronousClient asyncClient, EdFi.OdsApi.Sdk.Client.IReadableConfiguration configuration)
        {
            if (client == null) throw new ArgumentNullException("client");
            if (asyncClient == null) throw new ArgumentNullException("asyncClient");
            if (configuration == null) throw new ArgumentNullException("configuration");

            this.Client = client;
            this.AsynchronousClient = asyncClient;
            this.Configuration = configuration;
            this.ExceptionFactory = EdFi.OdsApi.Sdk.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// The client for accessing this underlying API asynchronously.
        /// </summary>
        public EdFi.OdsApi.Sdk.Client.IAsynchronousClient AsynchronousClient { get; set; }

        /// <summary>
        /// The client for accessing this underlying API synchronously.
        /// </summary>
        public EdFi.OdsApi.Sdk.Client.ISynchronousClient Client { get; set; }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public string GetBasePath()
        {
            return this.Configuration.BasePath;
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public EdFi.OdsApi.Sdk.Client.IReadableConfiguration Configuration { get; set; }

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public EdFi.OdsApi.Sdk.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Retrieves specific resources using the resource&#39;s property values (using the \&quot;Get\&quot; pattern). 
        /// </summary>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional)</param>
        /// <param name="limit"> (optional)</param>
        /// <param name="id"> (optional)</param>
        /// <param name="ruleIdentifier">The unique Id for a validation rule. (optional)</param>
        /// <param name="ruleSource">The source or origin of the rule. (optional)</param>
        /// <param name="ruleStatus">The current status of if the rule. Examples are &#39;Active&#39;, &#39;Under Analysis&#39;, &#39;Inactive&#39;, &#39;Deprecated&#39;. (optional)</param>
        /// <param name="category">A category for the type of validation rule.  Examples might be &#39;Student Demographics&#39;, &#39;Special Education&#39;, or &#39;Attendance&#39; (optional)</param>
        /// <param name="severityDescriptor">Whether the validation rule is a &#39;Warning&#39;, &#39;Minor Validation Error&#39;, &#39;Major Validation Error&#39; or other value standardized by the API (optional)</param>
        /// <param name="externalRuleId">Refers back to a unique identifier for this rule in another system (such as a state-maintained repository of validation rules) (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>List&lt;ValidationRule&gt;</returns>
        public List<ValidationRule> EdFiXvalidationsValidationRulesGet(int? offset = default(int?), int? limit = default(int?), string? id = default(string?), string? ruleIdentifier = default(string?), string? ruleSource = default(string?), string? ruleStatus = default(string?), string? category = default(string?), string? severityDescriptor = default(string?), string? externalRuleId = default(string?), int operationIndex = 0)
        {
            EdFi.OdsApi.Sdk.Client.ApiResponse<List<ValidationRule>> localVarResponse = EdFiXvalidationsValidationRulesGetWithHttpInfo(offset, limit, id, ruleIdentifier, ruleSource, ruleStatus, category, severityDescriptor, externalRuleId);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieves specific resources using the resource&#39;s property values (using the \&quot;Get\&quot; pattern). 
        /// </summary>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional)</param>
        /// <param name="limit"> (optional)</param>
        /// <param name="id"> (optional)</param>
        /// <param name="ruleIdentifier">The unique Id for a validation rule. (optional)</param>
        /// <param name="ruleSource">The source or origin of the rule. (optional)</param>
        /// <param name="ruleStatus">The current status of if the rule. Examples are &#39;Active&#39;, &#39;Under Analysis&#39;, &#39;Inactive&#39;, &#39;Deprecated&#39;. (optional)</param>
        /// <param name="category">A category for the type of validation rule.  Examples might be &#39;Student Demographics&#39;, &#39;Special Education&#39;, or &#39;Attendance&#39; (optional)</param>
        /// <param name="severityDescriptor">Whether the validation rule is a &#39;Warning&#39;, &#39;Minor Validation Error&#39;, &#39;Major Validation Error&#39; or other value standardized by the API (optional)</param>
        /// <param name="externalRuleId">Refers back to a unique identifier for this rule in another system (such as a state-maintained repository of validation rules) (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of List&lt;ValidationRule&gt;</returns>
        public EdFi.OdsApi.Sdk.Client.ApiResponse<List<ValidationRule>> EdFiXvalidationsValidationRulesGetWithHttpInfo(int? offset = default(int?), int? limit = default(int?), string? id = default(string?), string? ruleIdentifier = default(string?), string? ruleSource = default(string?), string? ruleStatus = default(string?), string? category = default(string?), string? severityDescriptor = default(string?), string? externalRuleId = default(string?), int operationIndex = 0)
        {
            EdFi.OdsApi.Sdk.Client.RequestOptions localVarRequestOptions = new EdFi.OdsApi.Sdk.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = EdFi.OdsApi.Sdk.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = EdFi.OdsApi.Sdk.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            if (offset != null)
            {
                localVarRequestOptions.QueryParameters.Add(EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToMultiMap("", "offset", offset));
            }
            if (limit != null)
            {
                localVarRequestOptions.QueryParameters.Add(EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToMultiMap("", "limit", limit));
            }
            if (id != null)
            {
                localVarRequestOptions.QueryParameters.Add(EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToMultiMap("", "id", id));
            }
            if (ruleIdentifier != null)
            {
                localVarRequestOptions.QueryParameters.Add(EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToMultiMap("", "ruleIdentifier", ruleIdentifier));
            }
            if (ruleSource != null)
            {
                localVarRequestOptions.QueryParameters.Add(EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToMultiMap("", "ruleSource", ruleSource));
            }
            if (ruleStatus != null)
            {
                localVarRequestOptions.QueryParameters.Add(EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToMultiMap("", "ruleStatus", ruleStatus));
            }
            if (category != null)
            {
                localVarRequestOptions.QueryParameters.Add(EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToMultiMap("", "category", category));
            }
            if (severityDescriptor != null)
            {
                localVarRequestOptions.QueryParameters.Add(EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToMultiMap("", "severityDescriptor", severityDescriptor));
            }
            if (externalRuleId != null)
            {
                localVarRequestOptions.QueryParameters.Add(EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToMultiMap("", "externalRuleId", externalRuleId));
            }

            localVarRequestOptions.Operation = "ValidationRulesApi.EdFiXvalidationsValidationRulesGet";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (oauth2_client_credentials) required
            // oauth required
            if (!localVarRequestOptions.HeaderParameters.ContainsKey("Authorization"))
            {
                if (!string.IsNullOrEmpty(this.Configuration.AccessToken))
                {
                    localVarRequestOptions.HeaderParameters.Add("Authorization", "Bearer " + this.Configuration.AccessToken);
                }
                else if (!string.IsNullOrEmpty(this.Configuration.OAuthTokenUrl) &&
                         !string.IsNullOrEmpty(this.Configuration.OAuthClientId) &&
                         !string.IsNullOrEmpty(this.Configuration.OAuthClientSecret) &&
                         this.Configuration.OAuthFlow != null)
                {
                    localVarRequestOptions.OAuth = true;
                }
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<List<ValidationRule>>("/ed-fi-xvalidations/validationRules", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("EdFiXvalidationsValidationRulesGet", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Retrieves specific resources using the resource&#39;s property values (using the \&quot;Get\&quot; pattern). 
        /// </summary>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional)</param>
        /// <param name="limit"> (optional)</param>
        /// <param name="id"> (optional)</param>
        /// <param name="ruleIdentifier">The unique Id for a validation rule. (optional)</param>
        /// <param name="ruleSource">The source or origin of the rule. (optional)</param>
        /// <param name="ruleStatus">The current status of if the rule. Examples are &#39;Active&#39;, &#39;Under Analysis&#39;, &#39;Inactive&#39;, &#39;Deprecated&#39;. (optional)</param>
        /// <param name="category">A category for the type of validation rule.  Examples might be &#39;Student Demographics&#39;, &#39;Special Education&#39;, or &#39;Attendance&#39; (optional)</param>
        /// <param name="severityDescriptor">Whether the validation rule is a &#39;Warning&#39;, &#39;Minor Validation Error&#39;, &#39;Major Validation Error&#39; or other value standardized by the API (optional)</param>
        /// <param name="externalRuleId">Refers back to a unique identifier for this rule in another system (such as a state-maintained repository of validation rules) (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of List&lt;ValidationRule&gt;</returns>
        public async System.Threading.Tasks.Task<List<ValidationRule>> EdFiXvalidationsValidationRulesGetAsync(int? offset = default(int?), int? limit = default(int?), string? id = default(string?), string? ruleIdentifier = default(string?), string? ruleSource = default(string?), string? ruleStatus = default(string?), string? category = default(string?), string? severityDescriptor = default(string?), string? externalRuleId = default(string?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            EdFi.OdsApi.Sdk.Client.ApiResponse<List<ValidationRule>> localVarResponse = await EdFiXvalidationsValidationRulesGetWithHttpInfoAsync(offset, limit, id, ruleIdentifier, ruleSource, ruleStatus, category, severityDescriptor, externalRuleId, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieves specific resources using the resource&#39;s property values (using the \&quot;Get\&quot; pattern). 
        /// </summary>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional)</param>
        /// <param name="limit"> (optional)</param>
        /// <param name="id"> (optional)</param>
        /// <param name="ruleIdentifier">The unique Id for a validation rule. (optional)</param>
        /// <param name="ruleSource">The source or origin of the rule. (optional)</param>
        /// <param name="ruleStatus">The current status of if the rule. Examples are &#39;Active&#39;, &#39;Under Analysis&#39;, &#39;Inactive&#39;, &#39;Deprecated&#39;. (optional)</param>
        /// <param name="category">A category for the type of validation rule.  Examples might be &#39;Student Demographics&#39;, &#39;Special Education&#39;, or &#39;Attendance&#39; (optional)</param>
        /// <param name="severityDescriptor">Whether the validation rule is a &#39;Warning&#39;, &#39;Minor Validation Error&#39;, &#39;Major Validation Error&#39; or other value standardized by the API (optional)</param>
        /// <param name="externalRuleId">Refers back to a unique identifier for this rule in another system (such as a state-maintained repository of validation rules) (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (List&lt;ValidationRule&gt;)</returns>
        public async System.Threading.Tasks.Task<EdFi.OdsApi.Sdk.Client.ApiResponse<List<ValidationRule>>> EdFiXvalidationsValidationRulesGetWithHttpInfoAsync(int? offset = default(int?), int? limit = default(int?), string? id = default(string?), string? ruleIdentifier = default(string?), string? ruleSource = default(string?), string? ruleStatus = default(string?), string? category = default(string?), string? severityDescriptor = default(string?), string? externalRuleId = default(string?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {

            EdFi.OdsApi.Sdk.Client.RequestOptions localVarRequestOptions = new EdFi.OdsApi.Sdk.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = EdFi.OdsApi.Sdk.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = EdFi.OdsApi.Sdk.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            if (offset != null)
            {
                localVarRequestOptions.QueryParameters.Add(EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToMultiMap("", "offset", offset));
            }
            if (limit != null)
            {
                localVarRequestOptions.QueryParameters.Add(EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToMultiMap("", "limit", limit));
            }
            if (id != null)
            {
                localVarRequestOptions.QueryParameters.Add(EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToMultiMap("", "id", id));
            }
            if (ruleIdentifier != null)
            {
                localVarRequestOptions.QueryParameters.Add(EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToMultiMap("", "ruleIdentifier", ruleIdentifier));
            }
            if (ruleSource != null)
            {
                localVarRequestOptions.QueryParameters.Add(EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToMultiMap("", "ruleSource", ruleSource));
            }
            if (ruleStatus != null)
            {
                localVarRequestOptions.QueryParameters.Add(EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToMultiMap("", "ruleStatus", ruleStatus));
            }
            if (category != null)
            {
                localVarRequestOptions.QueryParameters.Add(EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToMultiMap("", "category", category));
            }
            if (severityDescriptor != null)
            {
                localVarRequestOptions.QueryParameters.Add(EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToMultiMap("", "severityDescriptor", severityDescriptor));
            }
            if (externalRuleId != null)
            {
                localVarRequestOptions.QueryParameters.Add(EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToMultiMap("", "externalRuleId", externalRuleId));
            }

            localVarRequestOptions.Operation = "ValidationRulesApi.EdFiXvalidationsValidationRulesGet";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (oauth2_client_credentials) required
            // oauth required
            if (!localVarRequestOptions.HeaderParameters.ContainsKey("Authorization"))
            {
                if (!string.IsNullOrEmpty(this.Configuration.AccessToken))
                {
                    localVarRequestOptions.HeaderParameters.Add("Authorization", "Bearer " + this.Configuration.AccessToken);
                }
                else if (!string.IsNullOrEmpty(this.Configuration.OAuthTokenUrl) &&
                         !string.IsNullOrEmpty(this.Configuration.OAuthClientId) &&
                         !string.IsNullOrEmpty(this.Configuration.OAuthClientSecret) &&
                         this.Configuration.OAuthFlow != null)
                {
                    localVarRequestOptions.OAuth = true;
                }
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<List<ValidationRule>>("/ed-fi-xvalidations/validationRules", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("EdFiXvalidationsValidationRulesGet", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Retrieves a specific resource using the resource&#39;s identifier (using the \&quot;Get By Id\&quot; pattern). 
        /// </summary>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">A resource identifier that uniquely identifies the resource.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ValidationRule</returns>
        public ValidationRule EdFiXvalidationsValidationRulesIdGet(string id, int operationIndex = 0)
        {
            EdFi.OdsApi.Sdk.Client.ApiResponse<ValidationRule> localVarResponse = EdFiXvalidationsValidationRulesIdGetWithHttpInfo(id);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieves a specific resource using the resource&#39;s identifier (using the \&quot;Get By Id\&quot; pattern). 
        /// </summary>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">A resource identifier that uniquely identifies the resource.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of ValidationRule</returns>
        public EdFi.OdsApi.Sdk.Client.ApiResponse<ValidationRule> EdFiXvalidationsValidationRulesIdGetWithHttpInfo(string id, int operationIndex = 0)
        {
            // verify the required parameter 'id' is set
            if (id == null)
            {
                throw new EdFi.OdsApi.Sdk.Client.ApiException(400, "Missing required parameter 'id' when calling ValidationRulesApi->EdFiXvalidationsValidationRulesIdGet");
            }

            EdFi.OdsApi.Sdk.Client.RequestOptions localVarRequestOptions = new EdFi.OdsApi.Sdk.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = EdFi.OdsApi.Sdk.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = EdFi.OdsApi.Sdk.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("id", EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToString(id)); // path parameter

            localVarRequestOptions.Operation = "ValidationRulesApi.EdFiXvalidationsValidationRulesIdGet";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (oauth2_client_credentials) required
            // oauth required
            if (!localVarRequestOptions.HeaderParameters.ContainsKey("Authorization"))
            {
                if (!string.IsNullOrEmpty(this.Configuration.AccessToken))
                {
                    localVarRequestOptions.HeaderParameters.Add("Authorization", "Bearer " + this.Configuration.AccessToken);
                }
                else if (!string.IsNullOrEmpty(this.Configuration.OAuthTokenUrl) &&
                         !string.IsNullOrEmpty(this.Configuration.OAuthClientId) &&
                         !string.IsNullOrEmpty(this.Configuration.OAuthClientSecret) &&
                         this.Configuration.OAuthFlow != null)
                {
                    localVarRequestOptions.OAuth = true;
                }
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<ValidationRule>("/ed-fi-xvalidations/validationRules/{id}", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("EdFiXvalidationsValidationRulesIdGet", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Retrieves a specific resource using the resource&#39;s identifier (using the \&quot;Get By Id\&quot; pattern). 
        /// </summary>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">A resource identifier that uniquely identifies the resource.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ValidationRule</returns>
        public async System.Threading.Tasks.Task<ValidationRule> EdFiXvalidationsValidationRulesIdGetAsync(string id, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            EdFi.OdsApi.Sdk.Client.ApiResponse<ValidationRule> localVarResponse = await EdFiXvalidationsValidationRulesIdGetWithHttpInfoAsync(id, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieves a specific resource using the resource&#39;s identifier (using the \&quot;Get By Id\&quot; pattern). 
        /// </summary>
        /// <exception cref="EdFi.OdsApi.Sdk.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">A resource identifier that uniquely identifies the resource.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (ValidationRule)</returns>
        public async System.Threading.Tasks.Task<EdFi.OdsApi.Sdk.Client.ApiResponse<ValidationRule>> EdFiXvalidationsValidationRulesIdGetWithHttpInfoAsync(string id, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            // verify the required parameter 'id' is set
            if (id == null)
            {
                throw new EdFi.OdsApi.Sdk.Client.ApiException(400, "Missing required parameter 'id' when calling ValidationRulesApi->EdFiXvalidationsValidationRulesIdGet");
            }


            EdFi.OdsApi.Sdk.Client.RequestOptions localVarRequestOptions = new EdFi.OdsApi.Sdk.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = EdFi.OdsApi.Sdk.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = EdFi.OdsApi.Sdk.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("id", EdFi.OdsApi.Sdk.Client.ClientUtils.ParameterToString(id)); // path parameter

            localVarRequestOptions.Operation = "ValidationRulesApi.EdFiXvalidationsValidationRulesIdGet";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (oauth2_client_credentials) required
            // oauth required
            if (!localVarRequestOptions.HeaderParameters.ContainsKey("Authorization"))
            {
                if (!string.IsNullOrEmpty(this.Configuration.AccessToken))
                {
                    localVarRequestOptions.HeaderParameters.Add("Authorization", "Bearer " + this.Configuration.AccessToken);
                }
                else if (!string.IsNullOrEmpty(this.Configuration.OAuthTokenUrl) &&
                         !string.IsNullOrEmpty(this.Configuration.OAuthClientId) &&
                         !string.IsNullOrEmpty(this.Configuration.OAuthClientSecret) &&
                         this.Configuration.OAuthFlow != null)
                {
                    localVarRequestOptions.OAuth = true;
                }
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<ValidationRule>("/ed-fi-xvalidations/validationRules/{id}", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("EdFiXvalidationsValidationRulesIdGet", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

    }
}
