/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.EnrollmentComposites
{
    /// <summary>
    /// StudentStudentEducationOrganizationAssociationStudentEducationOrganizationAssociationLanguage
    /// </summary>
    [DataContract(Name = "student_studentEducationOrganizationAssociation_studentEducationOrganizationAssociationLanguage")]
    public partial class StudentStudentEducationOrganizationAssociationStudentEducationOrganizationAssociationLanguage : IEquatable<StudentStudentEducationOrganizationAssociationStudentEducationOrganizationAssociationLanguage>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="StudentStudentEducationOrganizationAssociationStudentEducationOrganizationAssociationLanguage" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected StudentStudentEducationOrganizationAssociationStudentEducationOrganizationAssociationLanguage() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="StudentStudentEducationOrganizationAssociationStudentEducationOrganizationAssociationLanguage" /> class.
        /// </summary>
        /// <param name="languageDescriptor">A specification of which written or spoken communication is being used. (required).</param>
        public StudentStudentEducationOrganizationAssociationStudentEducationOrganizationAssociationLanguage(string languageDescriptor = default(string))
        {
            // to ensure "languageDescriptor" is required (not null)
            if (languageDescriptor == null)
            {
                throw new ArgumentNullException("languageDescriptor is a required property for StudentStudentEducationOrganizationAssociationStudentEducationOrganizationAssociationLanguage and cannot be null");
            }
            this.LanguageDescriptor = languageDescriptor;
        }

        /// <summary>
        /// A specification of which written or spoken communication is being used.
        /// </summary>
        /// <value>A specification of which written or spoken communication is being used.</value>
        [DataMember(Name = "languageDescriptor", IsRequired = true, EmitDefaultValue = true)]
        public string LanguageDescriptor { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class StudentStudentEducationOrganizationAssociationStudentEducationOrganizationAssociationLanguage {\n");
            sb.Append("  LanguageDescriptor: ").Append(LanguageDescriptor).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as StudentStudentEducationOrganizationAssociationStudentEducationOrganizationAssociationLanguage);
        }

        /// <summary>
        /// Returns true if StudentStudentEducationOrganizationAssociationStudentEducationOrganizationAssociationLanguage instances are equal
        /// </summary>
        /// <param name="input">Instance of StudentStudentEducationOrganizationAssociationStudentEducationOrganizationAssociationLanguage to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(StudentStudentEducationOrganizationAssociationStudentEducationOrganizationAssociationLanguage input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.LanguageDescriptor == input.LanguageDescriptor ||
                    (this.LanguageDescriptor != null &&
                    this.LanguageDescriptor.Equals(input.LanguageDescriptor))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.LanguageDescriptor != null)
                {
                    hashCode = (hashCode * 59) + this.LanguageDescriptor.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // LanguageDescriptor (string) maxLength
            if (this.LanguageDescriptor != null && this.LanguageDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for LanguageDescriptor, length must be less than 306.", new [] { "LanguageDescriptor" });
            }

            yield break;
        }
    }

}
