/*
 * Identity API Endpoints
 *
 * The identity management API is used to access a native identity system if one exists in the enterprise. The endpoints provide client applications with the ability to find and (optionally) create unique person identifiers that can be used with Student, Staff, and Parent resources. The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 2
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Identities
{
    /// <summary>
    /// IdentityCreateRequest
    /// </summary>
    [DataContract(Name = "IdentityCreateRequest")]
    public partial class IdentityCreateRequest : IEquatable<IdentityCreateRequest>, IValidatableObject
    {
        /// <summary>
        /// Defines GenerationCodeSuffix
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum GenerationCodeSuffixEnum
        {
            /// <summary>
            /// Enum I for value: I
            /// </summary>
            [EnumMember(Value = "I")]
            I = 1,

            /// <summary>
            /// Enum II for value: II
            /// </summary>
            [EnumMember(Value = "II")]
            II = 2,

            /// <summary>
            /// Enum III for value: III
            /// </summary>
            [EnumMember(Value = "III")]
            III = 3,

            /// <summary>
            /// Enum IV for value: IV
            /// </summary>
            [EnumMember(Value = "IV")]
            IV = 4,

            /// <summary>
            /// Enum V for value: V
            /// </summary>
            [EnumMember(Value = "V")]
            V = 5,

            /// <summary>
            /// Enum VI for value: VI
            /// </summary>
            [EnumMember(Value = "VI")]
            VI = 6,

            /// <summary>
            /// Enum VII for value: VII
            /// </summary>
            [EnumMember(Value = "VII")]
            VII = 7,

            /// <summary>
            /// Enum VIII for value: VIII
            /// </summary>
            [EnumMember(Value = "VIII")]
            VIII = 8,

            /// <summary>
            /// Enum IX for value: IX
            /// </summary>
            [EnumMember(Value = "IX")]
            IX = 9,

            /// <summary>
            /// Enum X for value: X
            /// </summary>
            [EnumMember(Value = "X")]
            X = 10,

            /// <summary>
            /// Enum XI for value: XI
            /// </summary>
            [EnumMember(Value = "XI")]
            XI = 11,

            /// <summary>
            /// Enum XII for value: XII
            /// </summary>
            [EnumMember(Value = "XII")]
            XII = 12,

            /// <summary>
            /// Enum XIII for value: XIII
            /// </summary>
            [EnumMember(Value = "XIII")]
            XIII = 13,

            /// <summary>
            /// Enum XIV for value: XIV
            /// </summary>
            [EnumMember(Value = "XIV")]
            XIV = 14,

            /// <summary>
            /// Enum XV for value: XV
            /// </summary>
            [EnumMember(Value = "XV")]
            XV = 15,

            /// <summary>
            /// Enum Sr for value: Sr
            /// </summary>
            [EnumMember(Value = "Sr")]
            Sr = 16,

            /// <summary>
            /// Enum Jr for value: Jr
            /// </summary>
            [EnumMember(Value = "Jr")]
            Jr = 17,

            /// <summary>
            /// Enum SJ for value: SJ
            /// </summary>
            [EnumMember(Value = "SJ")]
            SJ = 18

        }


        /// <summary>
        /// Gets or Sets GenerationCodeSuffix
        /// </summary>
        [DataMember(Name = "GenerationCodeSuffix", EmitDefaultValue = false)]
        public GenerationCodeSuffixEnum? GenerationCodeSuffix { get; set; }
        /// <summary>
        /// Defines SexType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum SexTypeEnum
        {
            /// <summary>
            /// Enum M for value: M
            /// </summary>
            [EnumMember(Value = "M")]
            M = 1,

            /// <summary>
            /// Enum F for value: F
            /// </summary>
            [EnumMember(Value = "F")]
            F = 2,

            /// <summary>
            /// Enum X for value: X
            /// </summary>
            [EnumMember(Value = "X")]
            X = 3

        }


        /// <summary>
        /// Gets or Sets SexType
        /// </summary>
        [DataMember(Name = "SexType", EmitDefaultValue = false)]
        public SexTypeEnum? SexType { get; set; }
        /// <summary>
        /// Defines RaceCodes
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum RaceCodesEnum
        {
            /// <summary>
            /// Enum A for value: A
            /// </summary>
            [EnumMember(Value = "A")]
            A = 1,

            /// <summary>
            /// Enum I for value: I
            /// </summary>
            [EnumMember(Value = "I")]
            I = 2,

            /// <summary>
            /// Enum P for value: P
            /// </summary>
            [EnumMember(Value = "P")]
            P = 3,

            /// <summary>
            /// Enum B for value: B
            /// </summary>
            [EnumMember(Value = "B")]
            B = 4,

            /// <summary>
            /// Enum W for value: W
            /// </summary>
            [EnumMember(Value = "W")]
            W = 5

        }



        /// <summary>
        /// A &#x3D; Asian, I &#x3D; American Indian or Alaska Native, P &#x3D; Native Hawaiian or Other Pacific Islander, B &#x3D; Black or African American, W &#x3D; White
        /// </summary>
        /// <value>A &#x3D; Asian, I &#x3D; American Indian or Alaska Native, P &#x3D; Native Hawaiian or Other Pacific Islander, B &#x3D; Black or African American, W &#x3D; White</value>
        [DataMember(Name = "RaceCodes", EmitDefaultValue = false)]
        public List<RaceCodesEnum> RaceCodes { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="IdentityCreateRequest" /> class.
        /// </summary>
        /// <param name="birthDate">birthDate.</param>
        /// <param name="birthLocation">birthLocation.</param>
        /// <param name="birthOrder">birthOrder.</param>
        /// <param name="firstName">firstName.</param>
        /// <param name="generationCodeSuffix">generationCodeSuffix.</param>
        /// <param name="lastSurname">lastSurname.</param>
        /// <param name="middleName">middleName.</param>
        /// <param name="sexType">sexType.</param>
        /// <param name="searchKey">searchKey.</param>
        /// <param name="raceCodes">A &#x3D; Asian, I &#x3D; American Indian or Alaska Native, P &#x3D; Native Hawaiian or Other Pacific Islander, B &#x3D; Black or African American, W &#x3D; White.</param>
        /// <param name="multipleBirthIndicator">multipleBirthIndicator.</param>
        /// <param name="isHispanicLatino">isHispanicLatino.</param>
        /// <param name="locals">locals.</param>
        /// <param name="names">Other names.</param>
        /// <param name="parentGuardianNames">At least one &#39;Parent/Guardian&#39; record is required for each person record when they have a &#39;Local Person ID Key Type&#39; that equals &#39;Student&#39;.</param>
        public IdentityCreateRequest(DateTime birthDate = default(DateTime), Location birthLocation = default(Location), int birthOrder = default(int), string firstName = default(string), GenerationCodeSuffixEnum? generationCodeSuffix = default(GenerationCodeSuffixEnum?), string lastSurname = default(string), string middleName = default(string), SexTypeEnum? sexType = default(SexTypeEnum?), Guid searchKey = default(Guid), List<RaceCodesEnum> raceCodes = default(List<RaceCodesEnum>), bool multipleBirthIndicator = default(bool), bool isHispanicLatino = default(bool), List<Local> locals = default(List<Local>), List<Name> names = default(List<Name>), List<ParentGuardianName> parentGuardianNames = default(List<ParentGuardianName>))
        {
            this.BirthDate = birthDate;
            this.BirthLocation = birthLocation;
            this.BirthOrder = birthOrder;
            this.FirstName = firstName;
            this.GenerationCodeSuffix = generationCodeSuffix;
            this.LastSurname = lastSurname;
            this.MiddleName = middleName;
            this.SexType = sexType;
            this.SearchKey = searchKey;
            this.RaceCodes = raceCodes;
            this.MultipleBirthIndicator = multipleBirthIndicator;
            this.IsHispanicLatino = isHispanicLatino;
            this.Locals = locals;
            this.Names = names;
            this.ParentGuardianNames = parentGuardianNames;
        }

        /// <summary>
        /// Gets or Sets BirthDate
        /// </summary>
        [DataMember(Name = "BirthDate", EmitDefaultValue = false)]
        public DateTime BirthDate { get; set; }

        /// <summary>
        /// Gets or Sets BirthLocation
        /// </summary>
        [DataMember(Name = "BirthLocation", EmitDefaultValue = false)]
        public Location BirthLocation { get; set; }

        /// <summary>
        /// Gets or Sets BirthOrder
        /// </summary>
        [DataMember(Name = "BirthOrder", EmitDefaultValue = false)]
        public int BirthOrder { get; set; }

        /// <summary>
        /// Gets or Sets FirstName
        /// </summary>
        [DataMember(Name = "FirstName", EmitDefaultValue = false)]
        public string FirstName { get; set; }

        /// <summary>
        /// Gets or Sets LastSurname
        /// </summary>
        [DataMember(Name = "LastSurname", EmitDefaultValue = false)]
        public string LastSurname { get; set; }

        /// <summary>
        /// Gets or Sets MiddleName
        /// </summary>
        [DataMember(Name = "MiddleName", EmitDefaultValue = false)]
        public string MiddleName { get; set; }

        /// <summary>
        /// Gets or Sets SearchKey
        /// </summary>
        [DataMember(Name = "SearchKey", EmitDefaultValue = false)]
        public Guid SearchKey { get; set; }

        /// <summary>
        /// Gets or Sets MultipleBirthIndicator
        /// </summary>
        [DataMember(Name = "MultipleBirthIndicator", EmitDefaultValue = true)]
        public bool MultipleBirthIndicator { get; set; }

        /// <summary>
        /// Gets or Sets IsHispanicLatino
        /// </summary>
        [DataMember(Name = "IsHispanicLatino", EmitDefaultValue = true)]
        public bool IsHispanicLatino { get; set; }

        /// <summary>
        /// Gets or Sets Locals
        /// </summary>
        [DataMember(Name = "Locals", EmitDefaultValue = false)]
        public List<Local> Locals { get; set; }

        /// <summary>
        /// Other names
        /// </summary>
        /// <value>Other names</value>
        [DataMember(Name = "Names", EmitDefaultValue = false)]
        public List<Name> Names { get; set; }

        /// <summary>
        /// At least one &#39;Parent/Guardian&#39; record is required for each person record when they have a &#39;Local Person ID Key Type&#39; that equals &#39;Student&#39;
        /// </summary>
        /// <value>At least one &#39;Parent/Guardian&#39; record is required for each person record when they have a &#39;Local Person ID Key Type&#39; that equals &#39;Student&#39;</value>
        [DataMember(Name = "ParentGuardianNames", EmitDefaultValue = false)]
        public List<ParentGuardianName> ParentGuardianNames { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class IdentityCreateRequest {\n");
            sb.Append("  BirthDate: ").Append(BirthDate).Append("\n");
            sb.Append("  BirthLocation: ").Append(BirthLocation).Append("\n");
            sb.Append("  BirthOrder: ").Append(BirthOrder).Append("\n");
            sb.Append("  FirstName: ").Append(FirstName).Append("\n");
            sb.Append("  GenerationCodeSuffix: ").Append(GenerationCodeSuffix).Append("\n");
            sb.Append("  LastSurname: ").Append(LastSurname).Append("\n");
            sb.Append("  MiddleName: ").Append(MiddleName).Append("\n");
            sb.Append("  SexType: ").Append(SexType).Append("\n");
            sb.Append("  SearchKey: ").Append(SearchKey).Append("\n");
            sb.Append("  RaceCodes: ").Append(RaceCodes).Append("\n");
            sb.Append("  MultipleBirthIndicator: ").Append(MultipleBirthIndicator).Append("\n");
            sb.Append("  IsHispanicLatino: ").Append(IsHispanicLatino).Append("\n");
            sb.Append("  Locals: ").Append(Locals).Append("\n");
            sb.Append("  Names: ").Append(Names).Append("\n");
            sb.Append("  ParentGuardianNames: ").Append(ParentGuardianNames).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as IdentityCreateRequest);
        }

        /// <summary>
        /// Returns true if IdentityCreateRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of IdentityCreateRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(IdentityCreateRequest input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.BirthDate == input.BirthDate ||
                    (this.BirthDate != null &&
                    this.BirthDate.Equals(input.BirthDate))
                ) && 
                (
                    this.BirthLocation == input.BirthLocation ||
                    (this.BirthLocation != null &&
                    this.BirthLocation.Equals(input.BirthLocation))
                ) && 
                (
                    this.BirthOrder == input.BirthOrder ||
                    this.BirthOrder.Equals(input.BirthOrder)
                ) && 
                (
                    this.FirstName == input.FirstName ||
                    (this.FirstName != null &&
                    this.FirstName.Equals(input.FirstName))
                ) && 
                (
                    this.GenerationCodeSuffix == input.GenerationCodeSuffix ||
                    this.GenerationCodeSuffix.Equals(input.GenerationCodeSuffix)
                ) && 
                (
                    this.LastSurname == input.LastSurname ||
                    (this.LastSurname != null &&
                    this.LastSurname.Equals(input.LastSurname))
                ) && 
                (
                    this.MiddleName == input.MiddleName ||
                    (this.MiddleName != null &&
                    this.MiddleName.Equals(input.MiddleName))
                ) && 
                (
                    this.SexType == input.SexType ||
                    this.SexType.Equals(input.SexType)
                ) && 
                (
                    this.SearchKey == input.SearchKey ||
                    (this.SearchKey != null &&
                    this.SearchKey.Equals(input.SearchKey))
                ) && 
                (
                    this.RaceCodes == input.RaceCodes ||
                    this.RaceCodes.SequenceEqual(input.RaceCodes)
                ) && 
                (
                    this.MultipleBirthIndicator == input.MultipleBirthIndicator ||
                    this.MultipleBirthIndicator.Equals(input.MultipleBirthIndicator)
                ) && 
                (
                    this.IsHispanicLatino == input.IsHispanicLatino ||
                    this.IsHispanicLatino.Equals(input.IsHispanicLatino)
                ) && 
                (
                    this.Locals == input.Locals ||
                    this.Locals != null &&
                    input.Locals != null &&
                    this.Locals.SequenceEqual(input.Locals)
                ) && 
                (
                    this.Names == input.Names ||
                    this.Names != null &&
                    input.Names != null &&
                    this.Names.SequenceEqual(input.Names)
                ) && 
                (
                    this.ParentGuardianNames == input.ParentGuardianNames ||
                    this.ParentGuardianNames != null &&
                    input.ParentGuardianNames != null &&
                    this.ParentGuardianNames.SequenceEqual(input.ParentGuardianNames)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BirthDate != null)
                {
                    hashCode = (hashCode * 59) + this.BirthDate.GetHashCode();
                }
                if (this.BirthLocation != null)
                {
                    hashCode = (hashCode * 59) + this.BirthLocation.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.BirthOrder.GetHashCode();
                if (this.FirstName != null)
                {
                    hashCode = (hashCode * 59) + this.FirstName.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.GenerationCodeSuffix.GetHashCode();
                if (this.LastSurname != null)
                {
                    hashCode = (hashCode * 59) + this.LastSurname.GetHashCode();
                }
                if (this.MiddleName != null)
                {
                    hashCode = (hashCode * 59) + this.MiddleName.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.SexType.GetHashCode();
                if (this.SearchKey != null)
                {
                    hashCode = (hashCode * 59) + this.SearchKey.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.RaceCodes.GetHashCode();
                hashCode = (hashCode * 59) + this.MultipleBirthIndicator.GetHashCode();
                hashCode = (hashCode * 59) + this.IsHispanicLatino.GetHashCode();
                if (this.Locals != null)
                {
                    hashCode = (hashCode * 59) + this.Locals.GetHashCode();
                }
                if (this.Names != null)
                {
                    hashCode = (hashCode * 59) + this.Names.GetHashCode();
                }
                if (this.ParentGuardianNames != null)
                {
                    hashCode = (hashCode * 59) + this.ParentGuardianNames.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
