/*
 * Identity API Endpoints
 *
 * The identity management API is used to access a native identity system if one exists in the enterprise. The endpoints provide client applications with the ability to find and (optionally) create unique person identifiers that can be used with Student, Staff, and Parent resources. The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 2
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Identities
{
    /// <summary>
    /// IdentitySearchRequest
    /// </summary>
    [DataContract(Name = "IdentitySearchRequest")]
    public partial class IdentitySearchRequest : IEquatable<IdentitySearchRequest>, IValidatableObject
    {
        /// <summary>
        /// Defines GenerationCodeSuffix
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum GenerationCodeSuffixEnum
        {
            /// <summary>
            /// Enum I for value: I
            /// </summary>
            [EnumMember(Value = "I")]
            I = 1,

            /// <summary>
            /// Enum II for value: II
            /// </summary>
            [EnumMember(Value = "II")]
            II = 2,

            /// <summary>
            /// Enum III for value: III
            /// </summary>
            [EnumMember(Value = "III")]
            III = 3,

            /// <summary>
            /// Enum IV for value: IV
            /// </summary>
            [EnumMember(Value = "IV")]
            IV = 4,

            /// <summary>
            /// Enum V for value: V
            /// </summary>
            [EnumMember(Value = "V")]
            V = 5,

            /// <summary>
            /// Enum VI for value: VI
            /// </summary>
            [EnumMember(Value = "VI")]
            VI = 6,

            /// <summary>
            /// Enum VII for value: VII
            /// </summary>
            [EnumMember(Value = "VII")]
            VII = 7,

            /// <summary>
            /// Enum VIII for value: VIII
            /// </summary>
            [EnumMember(Value = "VIII")]
            VIII = 8,

            /// <summary>
            /// Enum IX for value: IX
            /// </summary>
            [EnumMember(Value = "IX")]
            IX = 9,

            /// <summary>
            /// Enum X for value: X
            /// </summary>
            [EnumMember(Value = "X")]
            X = 10,

            /// <summary>
            /// Enum XI for value: XI
            /// </summary>
            [EnumMember(Value = "XI")]
            XI = 11,

            /// <summary>
            /// Enum XII for value: XII
            /// </summary>
            [EnumMember(Value = "XII")]
            XII = 12,

            /// <summary>
            /// Enum XIII for value: XIII
            /// </summary>
            [EnumMember(Value = "XIII")]
            XIII = 13,

            /// <summary>
            /// Enum XIV for value: XIV
            /// </summary>
            [EnumMember(Value = "XIV")]
            XIV = 14,

            /// <summary>
            /// Enum XV for value: XV
            /// </summary>
            [EnumMember(Value = "XV")]
            XV = 15,

            /// <summary>
            /// Enum Sr for value: Sr
            /// </summary>
            [EnumMember(Value = "Sr")]
            Sr = 16,

            /// <summary>
            /// Enum Jr for value: Jr
            /// </summary>
            [EnumMember(Value = "Jr")]
            Jr = 17,

            /// <summary>
            /// Enum SJ for value: SJ
            /// </summary>
            [EnumMember(Value = "SJ")]
            SJ = 18

        }


        /// <summary>
        /// Gets or Sets GenerationCodeSuffix
        /// </summary>
        [DataMember(Name = "GenerationCodeSuffix", EmitDefaultValue = false)]
        public GenerationCodeSuffixEnum? GenerationCodeSuffix { get; set; }
        /// <summary>
        /// Defines SexType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum SexTypeEnum
        {
            /// <summary>
            /// Enum M for value: M
            /// </summary>
            [EnumMember(Value = "M")]
            M = 1,

            /// <summary>
            /// Enum F for value: F
            /// </summary>
            [EnumMember(Value = "F")]
            F = 2,

            /// <summary>
            /// Enum X for value: X
            /// </summary>
            [EnumMember(Value = "X")]
            X = 3

        }


        /// <summary>
        /// Gets or Sets SexType
        /// </summary>
        [DataMember(Name = "SexType", EmitDefaultValue = false)]
        public SexTypeEnum? SexType { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="IdentitySearchRequest" /> class.
        /// </summary>
        /// <param name="birthDate">birthDate.</param>
        /// <param name="birthLocation">birthLocation.</param>
        /// <param name="birthOrder">birthOrder.</param>
        /// <param name="firstName">firstName.</param>
        /// <param name="generationCodeSuffix">generationCodeSuffix.</param>
        /// <param name="lastSurname">lastSurname.</param>
        /// <param name="middleName">middleName.</param>
        /// <param name="sexType">sexType.</param>
        /// <param name="uniqueId">uniqueId.</param>
        /// <param name="localPersonId">A string uniquely identifying the student for the Vendor Software.</param>
        /// <param name="educationOrganizationId">This field helps determine if Email and LocalPersonId should be returned for ApiKeys that are associated to more than one Education Organization. ~95% of the time an ApiKey is associated with one Education Organization, so this field can be omitted. If this field is omitted, or is not valid, or is not authorized for the associated ApiKey - then the default EducationOrganizationId associated with the ApiKey will be used to determine if the Email and LocalPersonId should be returned. The fields Email and LocalPersonId are  only returned if they are associated with final determining EducationOrganizationId..</param>
        public IdentitySearchRequest(DateTime birthDate = default(DateTime), Location birthLocation = default(Location), int birthOrder = default(int), string firstName = default(string), GenerationCodeSuffixEnum? generationCodeSuffix = default(GenerationCodeSuffixEnum?), string lastSurname = default(string), string middleName = default(string), SexTypeEnum? sexType = default(SexTypeEnum?), string uniqueId = default(string), string localPersonId = default(string), int educationOrganizationId = default(int))
        {
            this.BirthDate = birthDate;
            this.BirthLocation = birthLocation;
            this.BirthOrder = birthOrder;
            this.FirstName = firstName;
            this.GenerationCodeSuffix = generationCodeSuffix;
            this.LastSurname = lastSurname;
            this.MiddleName = middleName;
            this.SexType = sexType;
            this.UniqueId = uniqueId;
            this.LocalPersonId = localPersonId;
            this.EducationOrganizationId = educationOrganizationId;
        }

        /// <summary>
        /// Gets or Sets BirthDate
        /// </summary>
        [DataMember(Name = "BirthDate", EmitDefaultValue = false)]
        public DateTime BirthDate { get; set; }

        /// <summary>
        /// Gets or Sets BirthLocation
        /// </summary>
        [DataMember(Name = "BirthLocation", EmitDefaultValue = false)]
        public Location BirthLocation { get; set; }

        /// <summary>
        /// Gets or Sets BirthOrder
        /// </summary>
        [DataMember(Name = "BirthOrder", EmitDefaultValue = false)]
        public int BirthOrder { get; set; }

        /// <summary>
        /// Gets or Sets FirstName
        /// </summary>
        [DataMember(Name = "FirstName", EmitDefaultValue = false)]
        public string FirstName { get; set; }

        /// <summary>
        /// Gets or Sets LastSurname
        /// </summary>
        [DataMember(Name = "LastSurname", EmitDefaultValue = false)]
        public string LastSurname { get; set; }

        /// <summary>
        /// Gets or Sets MiddleName
        /// </summary>
        [DataMember(Name = "MiddleName", EmitDefaultValue = false)]
        public string MiddleName { get; set; }

        /// <summary>
        /// Gets or Sets UniqueId
        /// </summary>
        [DataMember(Name = "UniqueId", EmitDefaultValue = false)]
        public string UniqueId { get; set; }

        /// <summary>
        /// A string uniquely identifying the student for the Vendor Software
        /// </summary>
        /// <value>A string uniquely identifying the student for the Vendor Software</value>
        [DataMember(Name = "LocalPersonId", EmitDefaultValue = false)]
        public string LocalPersonId { get; set; }

        /// <summary>
        /// This field helps determine if Email and LocalPersonId should be returned for ApiKeys that are associated to more than one Education Organization. ~95% of the time an ApiKey is associated with one Education Organization, so this field can be omitted. If this field is omitted, or is not valid, or is not authorized for the associated ApiKey - then the default EducationOrganizationId associated with the ApiKey will be used to determine if the Email and LocalPersonId should be returned. The fields Email and LocalPersonId are  only returned if they are associated with final determining EducationOrganizationId.
        /// </summary>
        /// <value>This field helps determine if Email and LocalPersonId should be returned for ApiKeys that are associated to more than one Education Organization. ~95% of the time an ApiKey is associated with one Education Organization, so this field can be omitted. If this field is omitted, or is not valid, or is not authorized for the associated ApiKey - then the default EducationOrganizationId associated with the ApiKey will be used to determine if the Email and LocalPersonId should be returned. The fields Email and LocalPersonId are  only returned if they are associated with final determining EducationOrganizationId.</value>
        [DataMember(Name = "EducationOrganizationId", EmitDefaultValue = false)]
        public int EducationOrganizationId { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class IdentitySearchRequest {\n");
            sb.Append("  BirthDate: ").Append(BirthDate).Append("\n");
            sb.Append("  BirthLocation: ").Append(BirthLocation).Append("\n");
            sb.Append("  BirthOrder: ").Append(BirthOrder).Append("\n");
            sb.Append("  FirstName: ").Append(FirstName).Append("\n");
            sb.Append("  GenerationCodeSuffix: ").Append(GenerationCodeSuffix).Append("\n");
            sb.Append("  LastSurname: ").Append(LastSurname).Append("\n");
            sb.Append("  MiddleName: ").Append(MiddleName).Append("\n");
            sb.Append("  SexType: ").Append(SexType).Append("\n");
            sb.Append("  UniqueId: ").Append(UniqueId).Append("\n");
            sb.Append("  LocalPersonId: ").Append(LocalPersonId).Append("\n");
            sb.Append("  EducationOrganizationId: ").Append(EducationOrganizationId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as IdentitySearchRequest);
        }

        /// <summary>
        /// Returns true if IdentitySearchRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of IdentitySearchRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(IdentitySearchRequest input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.BirthDate == input.BirthDate ||
                    (this.BirthDate != null &&
                    this.BirthDate.Equals(input.BirthDate))
                ) && 
                (
                    this.BirthLocation == input.BirthLocation ||
                    (this.BirthLocation != null &&
                    this.BirthLocation.Equals(input.BirthLocation))
                ) && 
                (
                    this.BirthOrder == input.BirthOrder ||
                    this.BirthOrder.Equals(input.BirthOrder)
                ) && 
                (
                    this.FirstName == input.FirstName ||
                    (this.FirstName != null &&
                    this.FirstName.Equals(input.FirstName))
                ) && 
                (
                    this.GenerationCodeSuffix == input.GenerationCodeSuffix ||
                    this.GenerationCodeSuffix.Equals(input.GenerationCodeSuffix)
                ) && 
                (
                    this.LastSurname == input.LastSurname ||
                    (this.LastSurname != null &&
                    this.LastSurname.Equals(input.LastSurname))
                ) && 
                (
                    this.MiddleName == input.MiddleName ||
                    (this.MiddleName != null &&
                    this.MiddleName.Equals(input.MiddleName))
                ) && 
                (
                    this.SexType == input.SexType ||
                    this.SexType.Equals(input.SexType)
                ) && 
                (
                    this.UniqueId == input.UniqueId ||
                    (this.UniqueId != null &&
                    this.UniqueId.Equals(input.UniqueId))
                ) && 
                (
                    this.LocalPersonId == input.LocalPersonId ||
                    (this.LocalPersonId != null &&
                    this.LocalPersonId.Equals(input.LocalPersonId))
                ) && 
                (
                    this.EducationOrganizationId == input.EducationOrganizationId ||
                    this.EducationOrganizationId.Equals(input.EducationOrganizationId)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BirthDate != null)
                {
                    hashCode = (hashCode * 59) + this.BirthDate.GetHashCode();
                }
                if (this.BirthLocation != null)
                {
                    hashCode = (hashCode * 59) + this.BirthLocation.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.BirthOrder.GetHashCode();
                if (this.FirstName != null)
                {
                    hashCode = (hashCode * 59) + this.FirstName.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.GenerationCodeSuffix.GetHashCode();
                if (this.LastSurname != null)
                {
                    hashCode = (hashCode * 59) + this.LastSurname.GetHashCode();
                }
                if (this.MiddleName != null)
                {
                    hashCode = (hashCode * 59) + this.MiddleName.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.SexType.GetHashCode();
                if (this.UniqueId != null)
                {
                    hashCode = (hashCode * 59) + this.UniqueId.GetHashCode();
                }
                if (this.LocalPersonId != null)
                {
                    hashCode = (hashCode * 59) + this.LocalPersonId.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.EducationOrganizationId.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
