/*
 * Immunizations API
 *
 * The WI Department of Public Instruction in conjunction with the WI Department of Health Services is working to facilitate the retrieval of HL7 immunization data from the WI Immunization Registry via the EdFi API.
 *
 * The version of the OpenAPI document: v1
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Immunizations
{
    /// <summary>
    /// ImmunizationsExtendedTelephoneNumber
    /// </summary>
    [DataContract(Name = "ImmunizationsExtendedTelephoneNumber")]
    public partial class ImmunizationsExtendedTelephoneNumber : IEquatable<ImmunizationsExtendedTelephoneNumber>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ImmunizationsExtendedTelephoneNumber" /> class.
        /// </summary>
        /// <param name="useCode">useCode.</param>
        /// <param name="equitpmentType">equitpmentType.</param>
        /// <param name="emailAddress">emailAddress.</param>
        /// <param name="areaCode">areaCode.</param>
        /// <param name="localNumber">localNumber.</param>
        /// <param name="extension">extension.</param>
        public ImmunizationsExtendedTelephoneNumber(string useCode = default(string), string equitpmentType = default(string), string emailAddress = default(string), string areaCode = default(string), string localNumber = default(string), string extension = default(string))
        {
            this.UseCode = useCode;
            this.EquitpmentType = equitpmentType;
            this.EmailAddress = emailAddress;
            this.AreaCode = areaCode;
            this.LocalNumber = localNumber;
            this.Extension = extension;
        }

        /// <summary>
        /// Gets or Sets UseCode
        /// </summary>
        [DataMember(Name = "useCode", EmitDefaultValue = false)]
        public string UseCode { get; set; }

        /// <summary>
        /// Gets or Sets EquitpmentType
        /// </summary>
        [DataMember(Name = "equitpmentType", EmitDefaultValue = false)]
        public string EquitpmentType { get; set; }

        /// <summary>
        /// Gets or Sets EmailAddress
        /// </summary>
        [DataMember(Name = "emailAddress", EmitDefaultValue = false)]
        public string EmailAddress { get; set; }

        /// <summary>
        /// Gets or Sets AreaCode
        /// </summary>
        [DataMember(Name = "areaCode", EmitDefaultValue = false)]
        public string AreaCode { get; set; }

        /// <summary>
        /// Gets or Sets LocalNumber
        /// </summary>
        [DataMember(Name = "localNumber", EmitDefaultValue = false)]
        public string LocalNumber { get; set; }

        /// <summary>
        /// Gets or Sets Extension
        /// </summary>
        [DataMember(Name = "extension", EmitDefaultValue = false)]
        public string Extension { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ImmunizationsExtendedTelephoneNumber {\n");
            sb.Append("  UseCode: ").Append(UseCode).Append("\n");
            sb.Append("  EquitpmentType: ").Append(EquitpmentType).Append("\n");
            sb.Append("  EmailAddress: ").Append(EmailAddress).Append("\n");
            sb.Append("  AreaCode: ").Append(AreaCode).Append("\n");
            sb.Append("  LocalNumber: ").Append(LocalNumber).Append("\n");
            sb.Append("  Extension: ").Append(Extension).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ImmunizationsExtendedTelephoneNumber);
        }

        /// <summary>
        /// Returns true if ImmunizationsExtendedTelephoneNumber instances are equal
        /// </summary>
        /// <param name="input">Instance of ImmunizationsExtendedTelephoneNumber to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ImmunizationsExtendedTelephoneNumber input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.UseCode == input.UseCode ||
                    (this.UseCode != null &&
                    this.UseCode.Equals(input.UseCode))
                ) && 
                (
                    this.EquitpmentType == input.EquitpmentType ||
                    (this.EquitpmentType != null &&
                    this.EquitpmentType.Equals(input.EquitpmentType))
                ) && 
                (
                    this.EmailAddress == input.EmailAddress ||
                    (this.EmailAddress != null &&
                    this.EmailAddress.Equals(input.EmailAddress))
                ) && 
                (
                    this.AreaCode == input.AreaCode ||
                    (this.AreaCode != null &&
                    this.AreaCode.Equals(input.AreaCode))
                ) && 
                (
                    this.LocalNumber == input.LocalNumber ||
                    (this.LocalNumber != null &&
                    this.LocalNumber.Equals(input.LocalNumber))
                ) && 
                (
                    this.Extension == input.Extension ||
                    (this.Extension != null &&
                    this.Extension.Equals(input.Extension))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.UseCode != null)
                {
                    hashCode = (hashCode * 59) + this.UseCode.GetHashCode();
                }
                if (this.EquitpmentType != null)
                {
                    hashCode = (hashCode * 59) + this.EquitpmentType.GetHashCode();
                }
                if (this.EmailAddress != null)
                {
                    hashCode = (hashCode * 59) + this.EmailAddress.GetHashCode();
                }
                if (this.AreaCode != null)
                {
                    hashCode = (hashCode * 59) + this.AreaCode.GetHashCode();
                }
                if (this.LocalNumber != null)
                {
                    hashCode = (hashCode * 59) + this.LocalNumber.GetHashCode();
                }
                if (this.Extension != null)
                {
                    hashCode = (hashCode * 59) + this.Extension.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
