/*
 * Immunizations API
 *
 * The WI Department of Public Instruction in conjunction with the WI Department of Health Services is working to facilitate the retrieval of HL7 immunization data from the WI Immunization Registry via the EdFi API.
 *
 * The version of the OpenAPI document: v1
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Immunizations
{
    /// <summary>
    /// The WiR internal student identification.
    /// </summary>
    [DataContract(Name = "ImmunizationsPatientIdentifier")]
    public partial class ImmunizationsPatientIdentifier : IEquatable<ImmunizationsPatientIdentifier>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ImmunizationsPatientIdentifier" /> class.
        /// </summary>
        /// <param name="id">The WiR student identifier..</param>
        /// <param name="assigningAuthority">The authority issuing the student identifier..</param>
        /// <param name="identifierTypeCode">The type of student identifier..</param>
        /// <param name="name">name.</param>
        /// <param name="mothersMaidenName">mothersMaidenName.</param>
        /// <param name="birthDate">The student&#39;s birthdate..</param>
        /// <param name="sex">The student&#39;s sex..</param>
        /// <param name="race">race.</param>
        /// <param name="address">address.</param>
        /// <param name="multipleBirthIndicator">The multiple birth indicator for the student..</param>
        /// <param name="birthOrder">The birth order of the student..</param>
        /// <param name="extendedTelephoneNumber">extendedTelephoneNumber.</param>
        public ImmunizationsPatientIdentifier(string id = default(string), string assigningAuthority = default(string), string identifierTypeCode = default(string), ImmunizationsName name = default(ImmunizationsName), ImmunizationsMaidenName mothersMaidenName = default(ImmunizationsMaidenName), DateTime birthDate = default(DateTime), string sex = default(string), string race = default(string), ImmunizationsAddress address = default(ImmunizationsAddress), bool multipleBirthIndicator = default(bool), string birthOrder = default(string), ImmunizationsExtendedTelephoneNumber extendedTelephoneNumber = default(ImmunizationsExtendedTelephoneNumber))
        {
            this.Id = id;
            this.AssigningAuthority = assigningAuthority;
            this.IdentifierTypeCode = identifierTypeCode;
            this.Name = name;
            this.MothersMaidenName = mothersMaidenName;
            this.BirthDate = birthDate;
            this.Sex = sex;
            this.Race = race;
            this.Address = address;
            this.MultipleBirthIndicator = multipleBirthIndicator;
            this.BirthOrder = birthOrder;
            this.ExtendedTelephoneNumber = extendedTelephoneNumber;
        }

        /// <summary>
        /// The WiR student identifier.
        /// </summary>
        /// <value>The WiR student identifier.</value>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public string Id { get; set; }

        /// <summary>
        /// The authority issuing the student identifier.
        /// </summary>
        /// <value>The authority issuing the student identifier.</value>
        [DataMember(Name = "assigningAuthority", EmitDefaultValue = false)]
        public string AssigningAuthority { get; set; }

        /// <summary>
        /// The type of student identifier.
        /// </summary>
        /// <value>The type of student identifier.</value>
        [DataMember(Name = "identifierTypeCode", EmitDefaultValue = false)]
        public string IdentifierTypeCode { get; set; }

        /// <summary>
        /// Gets or Sets Name
        /// </summary>
        [DataMember(Name = "name", EmitDefaultValue = false)]
        public ImmunizationsName Name { get; set; }

        /// <summary>
        /// Gets or Sets MothersMaidenName
        /// </summary>
        [DataMember(Name = "mothersMaidenName", EmitDefaultValue = false)]
        public ImmunizationsMaidenName MothersMaidenName { get; set; }

        /// <summary>
        /// The student&#39;s birthdate.
        /// </summary>
        /// <value>The student&#39;s birthdate.</value>
        [DataMember(Name = "birthDate", EmitDefaultValue = false)]
        public DateTime BirthDate { get; set; }

        /// <summary>
        /// The student&#39;s sex.
        /// </summary>
        /// <value>The student&#39;s sex.</value>
        [DataMember(Name = "sex", EmitDefaultValue = false)]
        public string Sex { get; set; }

        /// <summary>
        /// Gets or Sets Race
        /// </summary>
        [DataMember(Name = "race", EmitDefaultValue = false)]
        public string Race { get; set; }

        /// <summary>
        /// Gets or Sets Address
        /// </summary>
        [DataMember(Name = "address", EmitDefaultValue = false)]
        public ImmunizationsAddress Address { get; set; }

        /// <summary>
        /// The multiple birth indicator for the student.
        /// </summary>
        /// <value>The multiple birth indicator for the student.</value>
        [DataMember(Name = "multipleBirthIndicator", EmitDefaultValue = true)]
        public bool MultipleBirthIndicator { get; set; }

        /// <summary>
        /// The birth order of the student.
        /// </summary>
        /// <value>The birth order of the student.</value>
        [DataMember(Name = "birthOrder", EmitDefaultValue = false)]
        public string BirthOrder { get; set; }

        /// <summary>
        /// Gets or Sets ExtendedTelephoneNumber
        /// </summary>
        [DataMember(Name = "extendedTelephoneNumber", EmitDefaultValue = false)]
        public ImmunizationsExtendedTelephoneNumber ExtendedTelephoneNumber { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ImmunizationsPatientIdentifier {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  AssigningAuthority: ").Append(AssigningAuthority).Append("\n");
            sb.Append("  IdentifierTypeCode: ").Append(IdentifierTypeCode).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  MothersMaidenName: ").Append(MothersMaidenName).Append("\n");
            sb.Append("  BirthDate: ").Append(BirthDate).Append("\n");
            sb.Append("  Sex: ").Append(Sex).Append("\n");
            sb.Append("  Race: ").Append(Race).Append("\n");
            sb.Append("  Address: ").Append(Address).Append("\n");
            sb.Append("  MultipleBirthIndicator: ").Append(MultipleBirthIndicator).Append("\n");
            sb.Append("  BirthOrder: ").Append(BirthOrder).Append("\n");
            sb.Append("  ExtendedTelephoneNumber: ").Append(ExtendedTelephoneNumber).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ImmunizationsPatientIdentifier);
        }

        /// <summary>
        /// Returns true if ImmunizationsPatientIdentifier instances are equal
        /// </summary>
        /// <param name="input">Instance of ImmunizationsPatientIdentifier to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ImmunizationsPatientIdentifier input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.AssigningAuthority == input.AssigningAuthority ||
                    (this.AssigningAuthority != null &&
                    this.AssigningAuthority.Equals(input.AssigningAuthority))
                ) && 
                (
                    this.IdentifierTypeCode == input.IdentifierTypeCode ||
                    (this.IdentifierTypeCode != null &&
                    this.IdentifierTypeCode.Equals(input.IdentifierTypeCode))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.MothersMaidenName == input.MothersMaidenName ||
                    (this.MothersMaidenName != null &&
                    this.MothersMaidenName.Equals(input.MothersMaidenName))
                ) && 
                (
                    this.BirthDate == input.BirthDate ||
                    (this.BirthDate != null &&
                    this.BirthDate.Equals(input.BirthDate))
                ) && 
                (
                    this.Sex == input.Sex ||
                    (this.Sex != null &&
                    this.Sex.Equals(input.Sex))
                ) && 
                (
                    this.Race == input.Race ||
                    (this.Race != null &&
                    this.Race.Equals(input.Race))
                ) && 
                (
                    this.Address == input.Address ||
                    (this.Address != null &&
                    this.Address.Equals(input.Address))
                ) && 
                (
                    this.MultipleBirthIndicator == input.MultipleBirthIndicator ||
                    this.MultipleBirthIndicator.Equals(input.MultipleBirthIndicator)
                ) && 
                (
                    this.BirthOrder == input.BirthOrder ||
                    (this.BirthOrder != null &&
                    this.BirthOrder.Equals(input.BirthOrder))
                ) && 
                (
                    this.ExtendedTelephoneNumber == input.ExtendedTelephoneNumber ||
                    (this.ExtendedTelephoneNumber != null &&
                    this.ExtendedTelephoneNumber.Equals(input.ExtendedTelephoneNumber))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                {
                    hashCode = (hashCode * 59) + this.Id.GetHashCode();
                }
                if (this.AssigningAuthority != null)
                {
                    hashCode = (hashCode * 59) + this.AssigningAuthority.GetHashCode();
                }
                if (this.IdentifierTypeCode != null)
                {
                    hashCode = (hashCode * 59) + this.IdentifierTypeCode.GetHashCode();
                }
                if (this.Name != null)
                {
                    hashCode = (hashCode * 59) + this.Name.GetHashCode();
                }
                if (this.MothersMaidenName != null)
                {
                    hashCode = (hashCode * 59) + this.MothersMaidenName.GetHashCode();
                }
                if (this.BirthDate != null)
                {
                    hashCode = (hashCode * 59) + this.BirthDate.GetHashCode();
                }
                if (this.Sex != null)
                {
                    hashCode = (hashCode * 59) + this.Sex.GetHashCode();
                }
                if (this.Race != null)
                {
                    hashCode = (hashCode * 59) + this.Race.GetHashCode();
                }
                if (this.Address != null)
                {
                    hashCode = (hashCode * 59) + this.Address.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.MultipleBirthIndicator.GetHashCode();
                if (this.BirthOrder != null)
                {
                    hashCode = (hashCode * 59) + this.BirthOrder.GetHashCode();
                }
                if (this.ExtendedTelephoneNumber != null)
                {
                    hashCode = (hashCode * 59) + this.ExtendedTelephoneNumber.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
