/*
 * Immunizations API
 *
 * The WI Department of Public Instruction in conjunction with the WI Department of Health Services is working to facilitate the retrieval of HL7 immunization data from the WI Immunization Registry via the EdFi API.
 *
 * The version of the OpenAPI document: v1
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Immunizations
{
    /// <summary>
    /// ImmunizationsPharmacyTreatmentAdministration
    /// </summary>
    [DataContract(Name = "ImmunizationsPharmacyTreatmentAdministration")]
    public partial class ImmunizationsPharmacyTreatmentAdministration : IEquatable<ImmunizationsPharmacyTreatmentAdministration>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ImmunizationsPharmacyTreatmentAdministration" /> class.
        /// </summary>
        /// <param name="administeredDate">The date the treatment was administered..</param>
        /// <param name="administeredCode">administeredCode.</param>
        /// <param name="waiver">The student&#39;s reason for not getting the treatment..</param>
        public ImmunizationsPharmacyTreatmentAdministration(DateTime administeredDate = default(DateTime), ImmunizationsCodedElement administeredCode = default(ImmunizationsCodedElement), string waiver = default(string))
        {
            this.AdministeredDate = administeredDate;
            this.AdministeredCode = administeredCode;
            this.Waiver = waiver;
        }

        /// <summary>
        /// The date the treatment was administered.
        /// </summary>
        /// <value>The date the treatment was administered.</value>
        [DataMember(Name = "administeredDate", EmitDefaultValue = false)]
        public DateTime AdministeredDate { get; set; }

        /// <summary>
        /// Gets or Sets AdministeredCode
        /// </summary>
        [DataMember(Name = "administeredCode", EmitDefaultValue = false)]
        public ImmunizationsCodedElement AdministeredCode { get; set; }

        /// <summary>
        /// The student&#39;s reason for not getting the treatment.
        /// </summary>
        /// <value>The student&#39;s reason for not getting the treatment.</value>
        [DataMember(Name = "waiver", EmitDefaultValue = false)]
        public string Waiver { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ImmunizationsPharmacyTreatmentAdministration {\n");
            sb.Append("  AdministeredDate: ").Append(AdministeredDate).Append("\n");
            sb.Append("  AdministeredCode: ").Append(AdministeredCode).Append("\n");
            sb.Append("  Waiver: ").Append(Waiver).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ImmunizationsPharmacyTreatmentAdministration);
        }

        /// <summary>
        /// Returns true if ImmunizationsPharmacyTreatmentAdministration instances are equal
        /// </summary>
        /// <param name="input">Instance of ImmunizationsPharmacyTreatmentAdministration to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ImmunizationsPharmacyTreatmentAdministration input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.AdministeredDate == input.AdministeredDate ||
                    (this.AdministeredDate != null &&
                    this.AdministeredDate.Equals(input.AdministeredDate))
                ) && 
                (
                    this.AdministeredCode == input.AdministeredCode ||
                    (this.AdministeredCode != null &&
                    this.AdministeredCode.Equals(input.AdministeredCode))
                ) && 
                (
                    this.Waiver == input.Waiver ||
                    (this.Waiver != null &&
                    this.Waiver.Equals(input.Waiver))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.AdministeredDate != null)
                {
                    hashCode = (hashCode * 59) + this.AdministeredDate.GetHashCode();
                }
                if (this.AdministeredCode != null)
                {
                    hashCode = (hashCode * 59) + this.AdministeredCode.GetHashCode();
                }
                if (this.Waiver != null)
                {
                    hashCode = (hashCode * 59) + this.Waiver.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
