/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Profiles.WiDpi.AssessmentRoster
{
    /// <summary>
    /// WiStudentSchoolAssociationExtensionReadable
    /// </summary>
    [DataContract(Name = "wi_studentSchoolAssociationExtension_readable")]
    public partial class WiStudentSchoolAssociationExtensionReadable : IEquatable<WiStudentSchoolAssociationExtensionReadable>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="WiStudentSchoolAssociationExtensionReadable" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected WiStudentSchoolAssociationExtensionReadable() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="WiStudentSchoolAssociationExtensionReadable" /> class.
        /// </summary>
        /// <param name="enrollmentTypeDescriptor">enrollmentTypeDescriptor (required).</param>
        /// <param name="privateSchoolChoiceProgramParticipant">privateSchoolChoiceProgramParticipant.</param>
        public WiStudentSchoolAssociationExtensionReadable(string enrollmentTypeDescriptor = default(string), bool? privateSchoolChoiceProgramParticipant = default(bool?))
        {
            // to ensure "enrollmentTypeDescriptor" is required (not null)
            if (enrollmentTypeDescriptor == null)
            {
                throw new ArgumentNullException("enrollmentTypeDescriptor is a required property for WiStudentSchoolAssociationExtensionReadable and cannot be null");
            }
            this.EnrollmentTypeDescriptor = enrollmentTypeDescriptor;
            this.PrivateSchoolChoiceProgramParticipant = privateSchoolChoiceProgramParticipant;
        }

        /// <summary>
        /// Gets or Sets EnrollmentTypeDescriptor
        /// </summary>
        [DataMember(Name = "enrollmentTypeDescriptor", IsRequired = true, EmitDefaultValue = true)]
        public string EnrollmentTypeDescriptor { get; set; }

        /// <summary>
        /// Gets or Sets PrivateSchoolChoiceProgramParticipant
        /// </summary>
        [DataMember(Name = "privateSchoolChoiceProgramParticipant", EmitDefaultValue = true)]
        public bool? PrivateSchoolChoiceProgramParticipant { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class WiStudentSchoolAssociationExtensionReadable {\n");
            sb.Append("  EnrollmentTypeDescriptor: ").Append(EnrollmentTypeDescriptor).Append("\n");
            sb.Append("  PrivateSchoolChoiceProgramParticipant: ").Append(PrivateSchoolChoiceProgramParticipant).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as WiStudentSchoolAssociationExtensionReadable);
        }

        /// <summary>
        /// Returns true if WiStudentSchoolAssociationExtensionReadable instances are equal
        /// </summary>
        /// <param name="input">Instance of WiStudentSchoolAssociationExtensionReadable to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(WiStudentSchoolAssociationExtensionReadable input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.EnrollmentTypeDescriptor == input.EnrollmentTypeDescriptor ||
                    (this.EnrollmentTypeDescriptor != null &&
                    this.EnrollmentTypeDescriptor.Equals(input.EnrollmentTypeDescriptor))
                ) && 
                (
                    this.PrivateSchoolChoiceProgramParticipant == input.PrivateSchoolChoiceProgramParticipant ||
                    (this.PrivateSchoolChoiceProgramParticipant != null &&
                    this.PrivateSchoolChoiceProgramParticipant.Equals(input.PrivateSchoolChoiceProgramParticipant))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.EnrollmentTypeDescriptor != null)
                {
                    hashCode = (hashCode * 59) + this.EnrollmentTypeDescriptor.GetHashCode();
                }
                if (this.PrivateSchoolChoiceProgramParticipant != null)
                {
                    hashCode = (hashCode * 59) + this.PrivateSchoolChoiceProgramParticipant.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // EnrollmentTypeDescriptor (string) maxLength
            if (this.EnrollmentTypeDescriptor != null && this.EnrollmentTypeDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for EnrollmentTypeDescriptor, length must be less than 306.", new [] { "EnrollmentTypeDescriptor" });
            }

            yield break;
        }
    }

}
