/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiCalendarDateCalendarEvent
    /// </summary>
    [DataContract(Name = "edFi_calendarDateCalendarEvent")]
    public partial class EdFiCalendarDateCalendarEvent : IEquatable<EdFiCalendarDateCalendarEvent>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiCalendarDateCalendarEvent" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiCalendarDateCalendarEvent() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiCalendarDateCalendarEvent" /> class.
        /// </summary>
        /// <param name="calendarEventDescriptor">The type of scheduled or unscheduled event for the day. (required).</param>
        public EdFiCalendarDateCalendarEvent(string calendarEventDescriptor = default(string))
        {
            // to ensure "calendarEventDescriptor" is required (not null)
            if (calendarEventDescriptor == null)
            {
                throw new ArgumentNullException("calendarEventDescriptor is a required property for EdFiCalendarDateCalendarEvent and cannot be null");
            }
            this.CalendarEventDescriptor = calendarEventDescriptor;
        }

        /// <summary>
        /// The type of scheduled or unscheduled event for the day.
        /// </summary>
        /// <value>The type of scheduled or unscheduled event for the day.</value>
        [DataMember(Name = "calendarEventDescriptor", IsRequired = true, EmitDefaultValue = true)]
        public string CalendarEventDescriptor { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiCalendarDateCalendarEvent {\n");
            sb.Append("  CalendarEventDescriptor: ").Append(CalendarEventDescriptor).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiCalendarDateCalendarEvent);
        }

        /// <summary>
        /// Returns true if EdFiCalendarDateCalendarEvent instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiCalendarDateCalendarEvent to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiCalendarDateCalendarEvent input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.CalendarEventDescriptor == input.CalendarEventDescriptor ||
                    (this.CalendarEventDescriptor != null &&
                    this.CalendarEventDescriptor.Equals(input.CalendarEventDescriptor))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CalendarEventDescriptor != null)
                {
                    hashCode = (hashCode * 59) + this.CalendarEventDescriptor.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // CalendarEventDescriptor (string) maxLength
            if (this.CalendarEventDescriptor != null && this.CalendarEventDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for CalendarEventDescriptor, length must be less than 306.", new [] { "CalendarEventDescriptor" });
            }

            yield break;
        }
    }

}
