/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiCourseCompetencyLevel
    /// </summary>
    [DataContract(Name = "edFi_courseCompetencyLevel")]
    public partial class EdFiCourseCompetencyLevel : IEquatable<EdFiCourseCompetencyLevel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiCourseCompetencyLevel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiCourseCompetencyLevel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiCourseCompetencyLevel" /> class.
        /// </summary>
        /// <param name="competencyLevelDescriptor">The competency levels defined to rate the student for the course. (required).</param>
        public EdFiCourseCompetencyLevel(string competencyLevelDescriptor = default(string))
        {
            // to ensure "competencyLevelDescriptor" is required (not null)
            if (competencyLevelDescriptor == null)
            {
                throw new ArgumentNullException("competencyLevelDescriptor is a required property for EdFiCourseCompetencyLevel and cannot be null");
            }
            this.CompetencyLevelDescriptor = competencyLevelDescriptor;
        }

        /// <summary>
        /// The competency levels defined to rate the student for the course.
        /// </summary>
        /// <value>The competency levels defined to rate the student for the course.</value>
        [DataMember(Name = "competencyLevelDescriptor", IsRequired = true, EmitDefaultValue = true)]
        public string CompetencyLevelDescriptor { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiCourseCompetencyLevel {\n");
            sb.Append("  CompetencyLevelDescriptor: ").Append(CompetencyLevelDescriptor).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiCourseCompetencyLevel);
        }

        /// <summary>
        /// Returns true if EdFiCourseCompetencyLevel instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiCourseCompetencyLevel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiCourseCompetencyLevel input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.CompetencyLevelDescriptor == input.CompetencyLevelDescriptor ||
                    (this.CompetencyLevelDescriptor != null &&
                    this.CompetencyLevelDescriptor.Equals(input.CompetencyLevelDescriptor))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CompetencyLevelDescriptor != null)
                {
                    hashCode = (hashCode * 59) + this.CompetencyLevelDescriptor.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // CompetencyLevelDescriptor (string) maxLength
            if (this.CompetencyLevelDescriptor != null && this.CompetencyLevelDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for CompetencyLevelDescriptor, length must be less than 306.", new [] { "CompetencyLevelDescriptor" });
            }

            yield break;
        }
    }

}
