/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiCourseTranscriptEarnedAdditionalCredits
    /// </summary>
    [DataContract(Name = "edFi_courseTranscriptEarnedAdditionalCredits")]
    public partial class EdFiCourseTranscriptEarnedAdditionalCredits : IEquatable<EdFiCourseTranscriptEarnedAdditionalCredits>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiCourseTranscriptEarnedAdditionalCredits" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiCourseTranscriptEarnedAdditionalCredits() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiCourseTranscriptEarnedAdditionalCredits" /> class.
        /// </summary>
        /// <param name="additionalCreditTypeDescriptor">The type of credits or units of value awarded for the completion of a course. (required).</param>
        /// <param name="credits">The value of credits or units of value awarded for the completion of a course (required).</param>
        public EdFiCourseTranscriptEarnedAdditionalCredits(string additionalCreditTypeDescriptor = default(string), double credits = default(double))
        {
            // to ensure "additionalCreditTypeDescriptor" is required (not null)
            if (additionalCreditTypeDescriptor == null)
            {
                throw new ArgumentNullException("additionalCreditTypeDescriptor is a required property for EdFiCourseTranscriptEarnedAdditionalCredits and cannot be null");
            }
            this.AdditionalCreditTypeDescriptor = additionalCreditTypeDescriptor;
            this.Credits = credits;
        }

        /// <summary>
        /// The type of credits or units of value awarded for the completion of a course.
        /// </summary>
        /// <value>The type of credits or units of value awarded for the completion of a course.</value>
        [DataMember(Name = "additionalCreditTypeDescriptor", IsRequired = true, EmitDefaultValue = true)]
        public string AdditionalCreditTypeDescriptor { get; set; }

        /// <summary>
        /// The value of credits or units of value awarded for the completion of a course
        /// </summary>
        /// <value>The value of credits or units of value awarded for the completion of a course</value>
        [DataMember(Name = "credits", IsRequired = true, EmitDefaultValue = true)]
        public double Credits { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiCourseTranscriptEarnedAdditionalCredits {\n");
            sb.Append("  AdditionalCreditTypeDescriptor: ").Append(AdditionalCreditTypeDescriptor).Append("\n");
            sb.Append("  Credits: ").Append(Credits).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiCourseTranscriptEarnedAdditionalCredits);
        }

        /// <summary>
        /// Returns true if EdFiCourseTranscriptEarnedAdditionalCredits instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiCourseTranscriptEarnedAdditionalCredits to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiCourseTranscriptEarnedAdditionalCredits input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.AdditionalCreditTypeDescriptor == input.AdditionalCreditTypeDescriptor ||
                    (this.AdditionalCreditTypeDescriptor != null &&
                    this.AdditionalCreditTypeDescriptor.Equals(input.AdditionalCreditTypeDescriptor))
                ) && 
                (
                    this.Credits == input.Credits ||
                    this.Credits.Equals(input.Credits)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.AdditionalCreditTypeDescriptor != null)
                {
                    hashCode = (hashCode * 59) + this.AdditionalCreditTypeDescriptor.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.Credits.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // AdditionalCreditTypeDescriptor (string) maxLength
            if (this.AdditionalCreditTypeDescriptor != null && this.AdditionalCreditTypeDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for AdditionalCreditTypeDescriptor, length must be less than 306.", new [] { "AdditionalCreditTypeDescriptor" });
            }

            yield break;
        }
    }

}
