/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiCredentialEndorsement
    /// </summary>
    [DataContract(Name = "edFi_credentialEndorsement")]
    public partial class EdFiCredentialEndorsement : IEquatable<EdFiCredentialEndorsement>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiCredentialEndorsement" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiCredentialEndorsement() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiCredentialEndorsement" /> class.
        /// </summary>
        /// <param name="credentialEndorsement">Endorsements are attachments to teaching certificates and indicate areas of specialization. (required).</param>
        public EdFiCredentialEndorsement(string credentialEndorsement = default(string))
        {
            // to ensure "credentialEndorsement" is required (not null)
            if (credentialEndorsement == null)
            {
                throw new ArgumentNullException("credentialEndorsement is a required property for EdFiCredentialEndorsement and cannot be null");
            }
            this.CredentialEndorsement = credentialEndorsement;
        }

        /// <summary>
        /// Endorsements are attachments to teaching certificates and indicate areas of specialization.
        /// </summary>
        /// <value>Endorsements are attachments to teaching certificates and indicate areas of specialization.</value>
        [DataMember(Name = "credentialEndorsement", IsRequired = true, EmitDefaultValue = true)]
        public string CredentialEndorsement { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiCredentialEndorsement {\n");
            sb.Append("  CredentialEndorsement: ").Append(CredentialEndorsement).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiCredentialEndorsement);
        }

        /// <summary>
        /// Returns true if EdFiCredentialEndorsement instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiCredentialEndorsement to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiCredentialEndorsement input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.CredentialEndorsement == input.CredentialEndorsement ||
                    (this.CredentialEndorsement != null &&
                    this.CredentialEndorsement.Equals(input.CredentialEndorsement))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CredentialEndorsement != null)
                {
                    hashCode = (hashCode * 59) + this.CredentialEndorsement.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // CredentialEndorsement (string) maxLength
            if (this.CredentialEndorsement != null && this.CredentialEndorsement.Length > 255)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for CredentialEndorsement, length must be less than 255.", new [] { "CredentialEndorsement" });
            }

            yield break;
        }
    }

}
