/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiDescriptorMappingModelEntity
    /// </summary>
    [DataContract(Name = "edFi_descriptorMappingModelEntity")]
    public partial class EdFiDescriptorMappingModelEntity : IEquatable<EdFiDescriptorMappingModelEntity>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiDescriptorMappingModelEntity" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiDescriptorMappingModelEntity() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiDescriptorMappingModelEntity" /> class.
        /// </summary>
        /// <param name="modelEntityDescriptor">The resources for which the descriptor mapping applies. If empty, the mapping is assumed to be applicable to all resources in which the descriptor appears. (required).</param>
        public EdFiDescriptorMappingModelEntity(string modelEntityDescriptor = default(string))
        {
            // to ensure "modelEntityDescriptor" is required (not null)
            if (modelEntityDescriptor == null)
            {
                throw new ArgumentNullException("modelEntityDescriptor is a required property for EdFiDescriptorMappingModelEntity and cannot be null");
            }
            this.ModelEntityDescriptor = modelEntityDescriptor;
        }

        /// <summary>
        /// The resources for which the descriptor mapping applies. If empty, the mapping is assumed to be applicable to all resources in which the descriptor appears.
        /// </summary>
        /// <value>The resources for which the descriptor mapping applies. If empty, the mapping is assumed to be applicable to all resources in which the descriptor appears.</value>
        [DataMember(Name = "modelEntityDescriptor", IsRequired = true, EmitDefaultValue = true)]
        public string ModelEntityDescriptor { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiDescriptorMappingModelEntity {\n");
            sb.Append("  ModelEntityDescriptor: ").Append(ModelEntityDescriptor).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiDescriptorMappingModelEntity);
        }

        /// <summary>
        /// Returns true if EdFiDescriptorMappingModelEntity instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiDescriptorMappingModelEntity to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiDescriptorMappingModelEntity input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.ModelEntityDescriptor == input.ModelEntityDescriptor ||
                    (this.ModelEntityDescriptor != null &&
                    this.ModelEntityDescriptor.Equals(input.ModelEntityDescriptor))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ModelEntityDescriptor != null)
                {
                    hashCode = (hashCode * 59) + this.ModelEntityDescriptor.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // ModelEntityDescriptor (string) maxLength
            if (this.ModelEntityDescriptor != null && this.ModelEntityDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ModelEntityDescriptor, length must be less than 306.", new [] { "ModelEntityDescriptor" });
            }

            yield break;
        }
    }

}
