/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiEducationContentDerivativeSourceLearningResourceMetadataURI
    /// </summary>
    [DataContract(Name = "edFi_educationContentDerivativeSourceLearningResourceMetadataURI")]
    public partial class EdFiEducationContentDerivativeSourceLearningResourceMetadataURI : IEquatable<EdFiEducationContentDerivativeSourceLearningResourceMetadataURI>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiEducationContentDerivativeSourceLearningResourceMetadataURI" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiEducationContentDerivativeSourceLearningResourceMetadataURI() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiEducationContentDerivativeSourceLearningResourceMetadataURI" /> class.
        /// </summary>
        /// <param name="derivativeSourceLearningResourceMetadataURI">The URI (typical a URL) pointing to the metadata entry in a LRMI metadata repository, which describes this content item. (required).</param>
        public EdFiEducationContentDerivativeSourceLearningResourceMetadataURI(string derivativeSourceLearningResourceMetadataURI = default(string))
        {
            // to ensure "derivativeSourceLearningResourceMetadataURI" is required (not null)
            if (derivativeSourceLearningResourceMetadataURI == null)
            {
                throw new ArgumentNullException("derivativeSourceLearningResourceMetadataURI is a required property for EdFiEducationContentDerivativeSourceLearningResourceMetadataURI and cannot be null");
            }
            this.DerivativeSourceLearningResourceMetadataURI = derivativeSourceLearningResourceMetadataURI;
        }

        /// <summary>
        /// The URI (typical a URL) pointing to the metadata entry in a LRMI metadata repository, which describes this content item.
        /// </summary>
        /// <value>The URI (typical a URL) pointing to the metadata entry in a LRMI metadata repository, which describes this content item.</value>
        [DataMember(Name = "derivativeSourceLearningResourceMetadataURI", IsRequired = true, EmitDefaultValue = true)]
        public string DerivativeSourceLearningResourceMetadataURI { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiEducationContentDerivativeSourceLearningResourceMetadataURI {\n");
            sb.Append("  DerivativeSourceLearningResourceMetadataURI: ").Append(DerivativeSourceLearningResourceMetadataURI).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiEducationContentDerivativeSourceLearningResourceMetadataURI);
        }

        /// <summary>
        /// Returns true if EdFiEducationContentDerivativeSourceLearningResourceMetadataURI instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiEducationContentDerivativeSourceLearningResourceMetadataURI to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiEducationContentDerivativeSourceLearningResourceMetadataURI input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.DerivativeSourceLearningResourceMetadataURI == input.DerivativeSourceLearningResourceMetadataURI ||
                    (this.DerivativeSourceLearningResourceMetadataURI != null &&
                    this.DerivativeSourceLearningResourceMetadataURI.Equals(input.DerivativeSourceLearningResourceMetadataURI))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.DerivativeSourceLearningResourceMetadataURI != null)
                {
                    hashCode = (hashCode * 59) + this.DerivativeSourceLearningResourceMetadataURI.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // DerivativeSourceLearningResourceMetadataURI (string) maxLength
            if (this.DerivativeSourceLearningResourceMetadataURI != null && this.DerivativeSourceLearningResourceMetadataURI.Length > 255)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for DerivativeSourceLearningResourceMetadataURI, length must be less than 255.", new [] { "DerivativeSourceLearningResourceMetadataURI" });
            }

            yield break;
        }
    }

}
