/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiEducationContentReference
    /// </summary>
    [DataContract(Name = "edFi_educationContentReference")]
    public partial class EdFiEducationContentReference : IEquatable<EdFiEducationContentReference>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiEducationContentReference" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiEducationContentReference() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiEducationContentReference" /> class.
        /// </summary>
        /// <param name="contentIdentifier">A unique identifier for the education content. (required).</param>
        /// <param name="link">link.</param>
        public EdFiEducationContentReference(string contentIdentifier = default(string), Link link = default(Link))
        {
            // to ensure "contentIdentifier" is required (not null)
            if (contentIdentifier == null)
            {
                throw new ArgumentNullException("contentIdentifier is a required property for EdFiEducationContentReference and cannot be null");
            }
            this.ContentIdentifier = contentIdentifier;
            this.Link = link;
        }

        /// <summary>
        /// A unique identifier for the education content.
        /// </summary>
        /// <value>A unique identifier for the education content.</value>
        [DataMember(Name = "contentIdentifier", IsRequired = true, EmitDefaultValue = true)]
        public string ContentIdentifier { get; set; }

        /// <summary>
        /// Gets or Sets Link
        /// </summary>
        [DataMember(Name = "link", EmitDefaultValue = false)]
        public Link Link { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiEducationContentReference {\n");
            sb.Append("  ContentIdentifier: ").Append(ContentIdentifier).Append("\n");
            sb.Append("  Link: ").Append(Link).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiEducationContentReference);
        }

        /// <summary>
        /// Returns true if EdFiEducationContentReference instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiEducationContentReference to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiEducationContentReference input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.ContentIdentifier == input.ContentIdentifier ||
                    (this.ContentIdentifier != null &&
                    this.ContentIdentifier.Equals(input.ContentIdentifier))
                ) && 
                (
                    this.Link == input.Link ||
                    (this.Link != null &&
                    this.Link.Equals(input.Link))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ContentIdentifier != null)
                {
                    hashCode = (hashCode * 59) + this.ContentIdentifier.GetHashCode();
                }
                if (this.Link != null)
                {
                    hashCode = (hashCode * 59) + this.Link.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // ContentIdentifier (string) maxLength
            if (this.ContentIdentifier != null && this.ContentIdentifier.Length > 225)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ContentIdentifier, length must be less than 225.", new [] { "ContentIdentifier" });
            }

            yield break;
        }
    }

}
