/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiGeneralStudentProgramAssociationProgramParticipationStatus
    /// </summary>
    [DataContract(Name = "edFi_generalStudentProgramAssociationProgramParticipationStatus")]
    public partial class EdFiGeneralStudentProgramAssociationProgramParticipationStatus : IEquatable<EdFiGeneralStudentProgramAssociationProgramParticipationStatus>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiGeneralStudentProgramAssociationProgramParticipationStatus" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiGeneralStudentProgramAssociationProgramParticipationStatus() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiGeneralStudentProgramAssociationProgramParticipationStatus" /> class.
        /// </summary>
        /// <param name="participationStatusDescriptor">The student&#39;s program participation status. (required).</param>
        /// <param name="statusBeginDate">The date the student&#39;s program participation status began. (required).</param>
        /// <param name="designatedBy">The person, organization, or department that designated the participation status..</param>
        /// <param name="statusEndDate">The date the student&#39;s program participation status ended..</param>
        public EdFiGeneralStudentProgramAssociationProgramParticipationStatus(string participationStatusDescriptor = default(string), DateTime statusBeginDate = default(DateTime), string designatedBy = default(string), DateTime? statusEndDate = default(DateTime?))
        {
            // to ensure "participationStatusDescriptor" is required (not null)
            if (participationStatusDescriptor == null)
            {
                throw new ArgumentNullException("participationStatusDescriptor is a required property for EdFiGeneralStudentProgramAssociationProgramParticipationStatus and cannot be null");
            }
            this.ParticipationStatusDescriptor = participationStatusDescriptor;
            this.StatusBeginDate = statusBeginDate;
            this.DesignatedBy = designatedBy;
            this.StatusEndDate = statusEndDate;
        }

        /// <summary>
        /// The student&#39;s program participation status.
        /// </summary>
        /// <value>The student&#39;s program participation status.</value>
        [DataMember(Name = "participationStatusDescriptor", IsRequired = true, EmitDefaultValue = true)]
        public string ParticipationStatusDescriptor { get; set; }

        /// <summary>
        /// The date the student&#39;s program participation status began.
        /// </summary>
        /// <value>The date the student&#39;s program participation status began.</value>
        [DataMember(Name = "statusBeginDate", IsRequired = true, EmitDefaultValue = true)]
        [JsonConverter(typeof(OpenAPIDateConverter))]
        public DateTime StatusBeginDate { get; set; }

        /// <summary>
        /// The person, organization, or department that designated the participation status.
        /// </summary>
        /// <value>The person, organization, or department that designated the participation status.</value>
        [DataMember(Name = "designatedBy", EmitDefaultValue = true)]
        public string DesignatedBy { get; set; }

        /// <summary>
        /// The date the student&#39;s program participation status ended.
        /// </summary>
        /// <value>The date the student&#39;s program participation status ended.</value>
        [DataMember(Name = "statusEndDate", EmitDefaultValue = true)]
        [JsonConverter(typeof(OpenAPIDateConverter))]
        public DateTime? StatusEndDate { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiGeneralStudentProgramAssociationProgramParticipationStatus {\n");
            sb.Append("  ParticipationStatusDescriptor: ").Append(ParticipationStatusDescriptor).Append("\n");
            sb.Append("  StatusBeginDate: ").Append(StatusBeginDate).Append("\n");
            sb.Append("  DesignatedBy: ").Append(DesignatedBy).Append("\n");
            sb.Append("  StatusEndDate: ").Append(StatusEndDate).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiGeneralStudentProgramAssociationProgramParticipationStatus);
        }

        /// <summary>
        /// Returns true if EdFiGeneralStudentProgramAssociationProgramParticipationStatus instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiGeneralStudentProgramAssociationProgramParticipationStatus to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiGeneralStudentProgramAssociationProgramParticipationStatus input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.ParticipationStatusDescriptor == input.ParticipationStatusDescriptor ||
                    (this.ParticipationStatusDescriptor != null &&
                    this.ParticipationStatusDescriptor.Equals(input.ParticipationStatusDescriptor))
                ) && 
                (
                    this.StatusBeginDate == input.StatusBeginDate ||
                    (this.StatusBeginDate != null &&
                    this.StatusBeginDate.Equals(input.StatusBeginDate))
                ) && 
                (
                    this.DesignatedBy == input.DesignatedBy ||
                    (this.DesignatedBy != null &&
                    this.DesignatedBy.Equals(input.DesignatedBy))
                ) && 
                (
                    this.StatusEndDate == input.StatusEndDate ||
                    (this.StatusEndDate != null &&
                    this.StatusEndDate.Equals(input.StatusEndDate))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ParticipationStatusDescriptor != null)
                {
                    hashCode = (hashCode * 59) + this.ParticipationStatusDescriptor.GetHashCode();
                }
                if (this.StatusBeginDate != null)
                {
                    hashCode = (hashCode * 59) + this.StatusBeginDate.GetHashCode();
                }
                if (this.DesignatedBy != null)
                {
                    hashCode = (hashCode * 59) + this.DesignatedBy.GetHashCode();
                }
                if (this.StatusEndDate != null)
                {
                    hashCode = (hashCode * 59) + this.StatusEndDate.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // ParticipationStatusDescriptor (string) maxLength
            if (this.ParticipationStatusDescriptor != null && this.ParticipationStatusDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ParticipationStatusDescriptor, length must be less than 306.", new [] { "ParticipationStatusDescriptor" });
            }

            // DesignatedBy (string) maxLength
            if (this.DesignatedBy != null && this.DesignatedBy.Length > 60)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for DesignatedBy, length must be less than 60.", new [] { "DesignatedBy" });
            }

            yield break;
        }
    }

}
