/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiPostSecondaryInstitutionMediumOfInstruction
    /// </summary>
    [DataContract(Name = "edFi_postSecondaryInstitutionMediumOfInstruction")]
    public partial class EdFiPostSecondaryInstitutionMediumOfInstruction : IEquatable<EdFiPostSecondaryInstitutionMediumOfInstruction>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiPostSecondaryInstitutionMediumOfInstruction" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiPostSecondaryInstitutionMediumOfInstruction() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiPostSecondaryInstitutionMediumOfInstruction" /> class.
        /// </summary>
        /// <param name="mediumOfInstructionDescriptor">The categories in which an institution serves the students. (required).</param>
        public EdFiPostSecondaryInstitutionMediumOfInstruction(string mediumOfInstructionDescriptor = default(string))
        {
            // to ensure "mediumOfInstructionDescriptor" is required (not null)
            if (mediumOfInstructionDescriptor == null)
            {
                throw new ArgumentNullException("mediumOfInstructionDescriptor is a required property for EdFiPostSecondaryInstitutionMediumOfInstruction and cannot be null");
            }
            this.MediumOfInstructionDescriptor = mediumOfInstructionDescriptor;
        }

        /// <summary>
        /// The categories in which an institution serves the students.
        /// </summary>
        /// <value>The categories in which an institution serves the students.</value>
        [DataMember(Name = "mediumOfInstructionDescriptor", IsRequired = true, EmitDefaultValue = true)]
        public string MediumOfInstructionDescriptor { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiPostSecondaryInstitutionMediumOfInstruction {\n");
            sb.Append("  MediumOfInstructionDescriptor: ").Append(MediumOfInstructionDescriptor).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiPostSecondaryInstitutionMediumOfInstruction);
        }

        /// <summary>
        /// Returns true if EdFiPostSecondaryInstitutionMediumOfInstruction instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiPostSecondaryInstitutionMediumOfInstruction to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiPostSecondaryInstitutionMediumOfInstruction input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.MediumOfInstructionDescriptor == input.MediumOfInstructionDescriptor ||
                    (this.MediumOfInstructionDescriptor != null &&
                    this.MediumOfInstructionDescriptor.Equals(input.MediumOfInstructionDescriptor))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.MediumOfInstructionDescriptor != null)
                {
                    hashCode = (hashCode * 59) + this.MediumOfInstructionDescriptor.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // MediumOfInstructionDescriptor (string) maxLength
            if (this.MediumOfInstructionDescriptor != null && this.MediumOfInstructionDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for MediumOfInstructionDescriptor, length must be less than 306.", new [] { "MediumOfInstructionDescriptor" });
            }

            yield break;
        }
    }

}
