/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiSectionAttendanceTakenEvent
    /// </summary>
    [DataContract(Name = "edFi_sectionAttendanceTakenEvent")]
    public partial class EdFiSectionAttendanceTakenEvent : IEquatable<EdFiSectionAttendanceTakenEvent>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiSectionAttendanceTakenEvent" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiSectionAttendanceTakenEvent() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiSectionAttendanceTakenEvent" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="calendarDateReference">calendarDateReference (required).</param>
        /// <param name="sectionReference">sectionReference (required).</param>
        /// <param name="staffReference">staffReference.</param>
        /// <param name="eventDate">The date the section attendance taken event was submitted, which could be a different date than the instructional day. (required).</param>
        /// <param name="etag">A unique system-generated value that identifies the version of the resource..</param>
        public EdFiSectionAttendanceTakenEvent(string id = default(string), EdFiCalendarDateReference calendarDateReference = default(EdFiCalendarDateReference), EdFiSectionReference sectionReference = default(EdFiSectionReference), EdFiStaffReference staffReference = default(EdFiStaffReference), DateTime eventDate = default(DateTime), string etag = default(string))
        {
            // to ensure "calendarDateReference" is required (not null)
            if (calendarDateReference == null)
            {
                throw new ArgumentNullException("calendarDateReference is a required property for EdFiSectionAttendanceTakenEvent and cannot be null");
            }
            this.CalendarDateReference = calendarDateReference;
            // to ensure "sectionReference" is required (not null)
            if (sectionReference == null)
            {
                throw new ArgumentNullException("sectionReference is a required property for EdFiSectionAttendanceTakenEvent and cannot be null");
            }
            this.SectionReference = sectionReference;
            this.EventDate = eventDate;
            this.Id = id;
            this.StaffReference = staffReference;
            this.Etag = etag;
        }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or Sets CalendarDateReference
        /// </summary>
        [DataMember(Name = "calendarDateReference", IsRequired = true, EmitDefaultValue = true)]
        public EdFiCalendarDateReference CalendarDateReference { get; set; }

        /// <summary>
        /// Gets or Sets SectionReference
        /// </summary>
        [DataMember(Name = "sectionReference", IsRequired = true, EmitDefaultValue = true)]
        public EdFiSectionReference SectionReference { get; set; }

        /// <summary>
        /// Gets or Sets StaffReference
        /// </summary>
        [DataMember(Name = "staffReference", EmitDefaultValue = false)]
        public EdFiStaffReference StaffReference { get; set; }

        /// <summary>
        /// The date the section attendance taken event was submitted, which could be a different date than the instructional day.
        /// </summary>
        /// <value>The date the section attendance taken event was submitted, which could be a different date than the instructional day.</value>
        [DataMember(Name = "eventDate", IsRequired = true, EmitDefaultValue = true)]
        [JsonConverter(typeof(OpenAPIDateConverter))]
        public DateTime EventDate { get; set; }

        /// <summary>
        /// A unique system-generated value that identifies the version of the resource.
        /// </summary>
        /// <value>A unique system-generated value that identifies the version of the resource.</value>
        [DataMember(Name = "_etag", EmitDefaultValue = false)]
        public string Etag { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiSectionAttendanceTakenEvent {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  CalendarDateReference: ").Append(CalendarDateReference).Append("\n");
            sb.Append("  SectionReference: ").Append(SectionReference).Append("\n");
            sb.Append("  StaffReference: ").Append(StaffReference).Append("\n");
            sb.Append("  EventDate: ").Append(EventDate).Append("\n");
            sb.Append("  Etag: ").Append(Etag).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiSectionAttendanceTakenEvent);
        }

        /// <summary>
        /// Returns true if EdFiSectionAttendanceTakenEvent instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiSectionAttendanceTakenEvent to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiSectionAttendanceTakenEvent input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.CalendarDateReference == input.CalendarDateReference ||
                    (this.CalendarDateReference != null &&
                    this.CalendarDateReference.Equals(input.CalendarDateReference))
                ) && 
                (
                    this.SectionReference == input.SectionReference ||
                    (this.SectionReference != null &&
                    this.SectionReference.Equals(input.SectionReference))
                ) && 
                (
                    this.StaffReference == input.StaffReference ||
                    (this.StaffReference != null &&
                    this.StaffReference.Equals(input.StaffReference))
                ) && 
                (
                    this.EventDate == input.EventDate ||
                    (this.EventDate != null &&
                    this.EventDate.Equals(input.EventDate))
                ) && 
                (
                    this.Etag == input.Etag ||
                    (this.Etag != null &&
                    this.Etag.Equals(input.Etag))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                {
                    hashCode = (hashCode * 59) + this.Id.GetHashCode();
                }
                if (this.CalendarDateReference != null)
                {
                    hashCode = (hashCode * 59) + this.CalendarDateReference.GetHashCode();
                }
                if (this.SectionReference != null)
                {
                    hashCode = (hashCode * 59) + this.SectionReference.GetHashCode();
                }
                if (this.StaffReference != null)
                {
                    hashCode = (hashCode * 59) + this.StaffReference.GetHashCode();
                }
                if (this.EventDate != null)
                {
                    hashCode = (hashCode * 59) + this.EventDate.GetHashCode();
                }
                if (this.Etag != null)
                {
                    hashCode = (hashCode * 59) + this.Etag.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
