/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiSectionCharacteristic
    /// </summary>
    [DataContract(Name = "edFi_sectionCharacteristic")]
    public partial class EdFiSectionCharacteristic : IEquatable<EdFiSectionCharacteristic>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiSectionCharacteristic" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiSectionCharacteristic() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiSectionCharacteristic" /> class.
        /// </summary>
        /// <param name="sectionCharacteristicDescriptor">Reflects important characteristics of the section, such as whether or not attendance is taken and the section is graded. (required).</param>
        public EdFiSectionCharacteristic(string sectionCharacteristicDescriptor = default(string))
        {
            // to ensure "sectionCharacteristicDescriptor" is required (not null)
            if (sectionCharacteristicDescriptor == null)
            {
                throw new ArgumentNullException("sectionCharacteristicDescriptor is a required property for EdFiSectionCharacteristic and cannot be null");
            }
            this.SectionCharacteristicDescriptor = sectionCharacteristicDescriptor;
        }

        /// <summary>
        /// Reflects important characteristics of the section, such as whether or not attendance is taken and the section is graded.
        /// </summary>
        /// <value>Reflects important characteristics of the section, such as whether or not attendance is taken and the section is graded.</value>
        [DataMember(Name = "sectionCharacteristicDescriptor", IsRequired = true, EmitDefaultValue = true)]
        public string SectionCharacteristicDescriptor { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiSectionCharacteristic {\n");
            sb.Append("  SectionCharacteristicDescriptor: ").Append(SectionCharacteristicDescriptor).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiSectionCharacteristic);
        }

        /// <summary>
        /// Returns true if EdFiSectionCharacteristic instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiSectionCharacteristic to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiSectionCharacteristic input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.SectionCharacteristicDescriptor == input.SectionCharacteristicDescriptor ||
                    (this.SectionCharacteristicDescriptor != null &&
                    this.SectionCharacteristicDescriptor.Equals(input.SectionCharacteristicDescriptor))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.SectionCharacteristicDescriptor != null)
                {
                    hashCode = (hashCode * 59) + this.SectionCharacteristicDescriptor.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // SectionCharacteristicDescriptor (string) maxLength
            if (this.SectionCharacteristicDescriptor != null && this.SectionCharacteristicDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SectionCharacteristicDescriptor, length must be less than 306.", new [] { "SectionCharacteristicDescriptor" });
            }

            yield break;
        }
    }

}
