/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiStaffCredential
    /// </summary>
    [DataContract(Name = "edFi_staffCredential")]
    public partial class EdFiStaffCredential : IEquatable<EdFiStaffCredential>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiStaffCredential" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiStaffCredential() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiStaffCredential" /> class.
        /// </summary>
        /// <param name="credentialReference">credentialReference (required).</param>
        public EdFiStaffCredential(EdFiCredentialReference credentialReference = default(EdFiCredentialReference))
        {
            // to ensure "credentialReference" is required (not null)
            if (credentialReference == null)
            {
                throw new ArgumentNullException("credentialReference is a required property for EdFiStaffCredential and cannot be null");
            }
            this.CredentialReference = credentialReference;
        }

        /// <summary>
        /// Gets or Sets CredentialReference
        /// </summary>
        [DataMember(Name = "credentialReference", IsRequired = true, EmitDefaultValue = true)]
        public EdFiCredentialReference CredentialReference { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiStaffCredential {\n");
            sb.Append("  CredentialReference: ").Append(CredentialReference).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiStaffCredential);
        }

        /// <summary>
        /// Returns true if EdFiStaffCredential instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiStaffCredential to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiStaffCredential input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.CredentialReference == input.CredentialReference ||
                    (this.CredentialReference != null &&
                    this.CredentialReference.Equals(input.CredentialReference))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CredentialReference != null)
                {
                    hashCode = (hashCode * 59) + this.CredentialReference.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
