/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiStaffEducationOrganizationAssignmentAssociation
    /// </summary>
    [DataContract(Name = "edFi_staffEducationOrganizationAssignmentAssociation")]
    public partial class EdFiStaffEducationOrganizationAssignmentAssociation : IEquatable<EdFiStaffEducationOrganizationAssignmentAssociation>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiStaffEducationOrganizationAssignmentAssociation" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiStaffEducationOrganizationAssignmentAssociation() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiStaffEducationOrganizationAssignmentAssociation" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="beginDate">Month, day, and year of the start or effective date of a staff member&#39;s employment, contract, or relationship with the education organization. (required).</param>
        /// <param name="staffClassificationDescriptor">The titles of employment, official status, or rank of education staff. (required).</param>
        /// <param name="credentialReference">credentialReference.</param>
        /// <param name="educationOrganizationReference">educationOrganizationReference (required).</param>
        /// <param name="employmentStaffEducationOrganizationEmploymentAssociationReference">employmentStaffEducationOrganizationEmploymentAssociationReference.</param>
        /// <param name="staffReference">staffReference (required).</param>
        /// <param name="endDate">Month, day, and year of the end or termination date of a staff member&#39;s employment, contract, or relationship with the education organization..</param>
        /// <param name="fullTimeEquivalency">The ratio between the hours of work expected in a position and the hours of work normally expected in a full-time position in the same setting..</param>
        /// <param name="orderOfAssignment">Describes whether the assignment is this the staff member&#39;s primary assignment, secondary assignment, etc..</param>
        /// <param name="positionTitle">The descriptive name of an individual&#39;s position..</param>
        /// <param name="etag">A unique system-generated value that identifies the version of the resource..</param>
        public EdFiStaffEducationOrganizationAssignmentAssociation(string id = default(string), DateTime beginDate = default(DateTime), string staffClassificationDescriptor = default(string), EdFiCredentialReference credentialReference = default(EdFiCredentialReference), EdFiEducationOrganizationReference educationOrganizationReference = default(EdFiEducationOrganizationReference), EdFiStaffEducationOrganizationEmploymentAssociationReference employmentStaffEducationOrganizationEmploymentAssociationReference = default(EdFiStaffEducationOrganizationEmploymentAssociationReference), EdFiStaffReference staffReference = default(EdFiStaffReference), DateTime? endDate = default(DateTime?), double? fullTimeEquivalency = default(double?), int? orderOfAssignment = default(int?), string positionTitle = default(string), string etag = default(string))
        {
            this.BeginDate = beginDate;
            // to ensure "staffClassificationDescriptor" is required (not null)
            if (staffClassificationDescriptor == null)
            {
                throw new ArgumentNullException("staffClassificationDescriptor is a required property for EdFiStaffEducationOrganizationAssignmentAssociation and cannot be null");
            }
            this.StaffClassificationDescriptor = staffClassificationDescriptor;
            // to ensure "educationOrganizationReference" is required (not null)
            if (educationOrganizationReference == null)
            {
                throw new ArgumentNullException("educationOrganizationReference is a required property for EdFiStaffEducationOrganizationAssignmentAssociation and cannot be null");
            }
            this.EducationOrganizationReference = educationOrganizationReference;
            // to ensure "staffReference" is required (not null)
            if (staffReference == null)
            {
                throw new ArgumentNullException("staffReference is a required property for EdFiStaffEducationOrganizationAssignmentAssociation and cannot be null");
            }
            this.StaffReference = staffReference;
            this.Id = id;
            this.CredentialReference = credentialReference;
            this.EmploymentStaffEducationOrganizationEmploymentAssociationReference = employmentStaffEducationOrganizationEmploymentAssociationReference;
            this.EndDate = endDate;
            this.FullTimeEquivalency = fullTimeEquivalency;
            this.OrderOfAssignment = orderOfAssignment;
            this.PositionTitle = positionTitle;
            this.Etag = etag;
        }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public string Id { get; set; }

        /// <summary>
        /// Month, day, and year of the start or effective date of a staff member&#39;s employment, contract, or relationship with the education organization.
        /// </summary>
        /// <value>Month, day, and year of the start or effective date of a staff member&#39;s employment, contract, or relationship with the education organization.</value>
        [DataMember(Name = "beginDate", IsRequired = true, EmitDefaultValue = true)]
        [JsonConverter(typeof(OpenAPIDateConverter))]
        public DateTime BeginDate { get; set; }

        /// <summary>
        /// The titles of employment, official status, or rank of education staff.
        /// </summary>
        /// <value>The titles of employment, official status, or rank of education staff.</value>
        [DataMember(Name = "staffClassificationDescriptor", IsRequired = true, EmitDefaultValue = true)]
        public string StaffClassificationDescriptor { get; set; }

        /// <summary>
        /// Gets or Sets CredentialReference
        /// </summary>
        [DataMember(Name = "credentialReference", EmitDefaultValue = false)]
        public EdFiCredentialReference CredentialReference { get; set; }

        /// <summary>
        /// Gets or Sets EducationOrganizationReference
        /// </summary>
        [DataMember(Name = "educationOrganizationReference", IsRequired = true, EmitDefaultValue = true)]
        public EdFiEducationOrganizationReference EducationOrganizationReference { get; set; }

        /// <summary>
        /// Gets or Sets EmploymentStaffEducationOrganizationEmploymentAssociationReference
        /// </summary>
        [DataMember(Name = "employmentStaffEducationOrganizationEmploymentAssociationReference", EmitDefaultValue = false)]
        public EdFiStaffEducationOrganizationEmploymentAssociationReference EmploymentStaffEducationOrganizationEmploymentAssociationReference { get; set; }

        /// <summary>
        /// Gets or Sets StaffReference
        /// </summary>
        [DataMember(Name = "staffReference", IsRequired = true, EmitDefaultValue = true)]
        public EdFiStaffReference StaffReference { get; set; }

        /// <summary>
        /// Month, day, and year of the end or termination date of a staff member&#39;s employment, contract, or relationship with the education organization.
        /// </summary>
        /// <value>Month, day, and year of the end or termination date of a staff member&#39;s employment, contract, or relationship with the education organization.</value>
        [DataMember(Name = "endDate", EmitDefaultValue = true)]
        [JsonConverter(typeof(OpenAPIDateConverter))]
        public DateTime? EndDate { get; set; }

        /// <summary>
        /// The ratio between the hours of work expected in a position and the hours of work normally expected in a full-time position in the same setting.
        /// </summary>
        /// <value>The ratio between the hours of work expected in a position and the hours of work normally expected in a full-time position in the same setting.</value>
        [DataMember(Name = "fullTimeEquivalency", EmitDefaultValue = true)]
        public double? FullTimeEquivalency { get; set; }

        /// <summary>
        /// Describes whether the assignment is this the staff member&#39;s primary assignment, secondary assignment, etc.
        /// </summary>
        /// <value>Describes whether the assignment is this the staff member&#39;s primary assignment, secondary assignment, etc.</value>
        [DataMember(Name = "orderOfAssignment", EmitDefaultValue = true)]
        public int? OrderOfAssignment { get; set; }

        /// <summary>
        /// The descriptive name of an individual&#39;s position.
        /// </summary>
        /// <value>The descriptive name of an individual&#39;s position.</value>
        [DataMember(Name = "positionTitle", EmitDefaultValue = true)]
        public string PositionTitle { get; set; }

        /// <summary>
        /// A unique system-generated value that identifies the version of the resource.
        /// </summary>
        /// <value>A unique system-generated value that identifies the version of the resource.</value>
        [DataMember(Name = "_etag", EmitDefaultValue = false)]
        public string Etag { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiStaffEducationOrganizationAssignmentAssociation {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  BeginDate: ").Append(BeginDate).Append("\n");
            sb.Append("  StaffClassificationDescriptor: ").Append(StaffClassificationDescriptor).Append("\n");
            sb.Append("  CredentialReference: ").Append(CredentialReference).Append("\n");
            sb.Append("  EducationOrganizationReference: ").Append(EducationOrganizationReference).Append("\n");
            sb.Append("  EmploymentStaffEducationOrganizationEmploymentAssociationReference: ").Append(EmploymentStaffEducationOrganizationEmploymentAssociationReference).Append("\n");
            sb.Append("  StaffReference: ").Append(StaffReference).Append("\n");
            sb.Append("  EndDate: ").Append(EndDate).Append("\n");
            sb.Append("  FullTimeEquivalency: ").Append(FullTimeEquivalency).Append("\n");
            sb.Append("  OrderOfAssignment: ").Append(OrderOfAssignment).Append("\n");
            sb.Append("  PositionTitle: ").Append(PositionTitle).Append("\n");
            sb.Append("  Etag: ").Append(Etag).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiStaffEducationOrganizationAssignmentAssociation);
        }

        /// <summary>
        /// Returns true if EdFiStaffEducationOrganizationAssignmentAssociation instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiStaffEducationOrganizationAssignmentAssociation to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiStaffEducationOrganizationAssignmentAssociation input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.BeginDate == input.BeginDate ||
                    (this.BeginDate != null &&
                    this.BeginDate.Equals(input.BeginDate))
                ) && 
                (
                    this.StaffClassificationDescriptor == input.StaffClassificationDescriptor ||
                    (this.StaffClassificationDescriptor != null &&
                    this.StaffClassificationDescriptor.Equals(input.StaffClassificationDescriptor))
                ) && 
                (
                    this.CredentialReference == input.CredentialReference ||
                    (this.CredentialReference != null &&
                    this.CredentialReference.Equals(input.CredentialReference))
                ) && 
                (
                    this.EducationOrganizationReference == input.EducationOrganizationReference ||
                    (this.EducationOrganizationReference != null &&
                    this.EducationOrganizationReference.Equals(input.EducationOrganizationReference))
                ) && 
                (
                    this.EmploymentStaffEducationOrganizationEmploymentAssociationReference == input.EmploymentStaffEducationOrganizationEmploymentAssociationReference ||
                    (this.EmploymentStaffEducationOrganizationEmploymentAssociationReference != null &&
                    this.EmploymentStaffEducationOrganizationEmploymentAssociationReference.Equals(input.EmploymentStaffEducationOrganizationEmploymentAssociationReference))
                ) && 
                (
                    this.StaffReference == input.StaffReference ||
                    (this.StaffReference != null &&
                    this.StaffReference.Equals(input.StaffReference))
                ) && 
                (
                    this.EndDate == input.EndDate ||
                    (this.EndDate != null &&
                    this.EndDate.Equals(input.EndDate))
                ) && 
                (
                    this.FullTimeEquivalency == input.FullTimeEquivalency ||
                    (this.FullTimeEquivalency != null &&
                    this.FullTimeEquivalency.Equals(input.FullTimeEquivalency))
                ) && 
                (
                    this.OrderOfAssignment == input.OrderOfAssignment ||
                    (this.OrderOfAssignment != null &&
                    this.OrderOfAssignment.Equals(input.OrderOfAssignment))
                ) && 
                (
                    this.PositionTitle == input.PositionTitle ||
                    (this.PositionTitle != null &&
                    this.PositionTitle.Equals(input.PositionTitle))
                ) && 
                (
                    this.Etag == input.Etag ||
                    (this.Etag != null &&
                    this.Etag.Equals(input.Etag))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                {
                    hashCode = (hashCode * 59) + this.Id.GetHashCode();
                }
                if (this.BeginDate != null)
                {
                    hashCode = (hashCode * 59) + this.BeginDate.GetHashCode();
                }
                if (this.StaffClassificationDescriptor != null)
                {
                    hashCode = (hashCode * 59) + this.StaffClassificationDescriptor.GetHashCode();
                }
                if (this.CredentialReference != null)
                {
                    hashCode = (hashCode * 59) + this.CredentialReference.GetHashCode();
                }
                if (this.EducationOrganizationReference != null)
                {
                    hashCode = (hashCode * 59) + this.EducationOrganizationReference.GetHashCode();
                }
                if (this.EmploymentStaffEducationOrganizationEmploymentAssociationReference != null)
                {
                    hashCode = (hashCode * 59) + this.EmploymentStaffEducationOrganizationEmploymentAssociationReference.GetHashCode();
                }
                if (this.StaffReference != null)
                {
                    hashCode = (hashCode * 59) + this.StaffReference.GetHashCode();
                }
                if (this.EndDate != null)
                {
                    hashCode = (hashCode * 59) + this.EndDate.GetHashCode();
                }
                if (this.FullTimeEquivalency != null)
                {
                    hashCode = (hashCode * 59) + this.FullTimeEquivalency.GetHashCode();
                }
                if (this.OrderOfAssignment != null)
                {
                    hashCode = (hashCode * 59) + this.OrderOfAssignment.GetHashCode();
                }
                if (this.PositionTitle != null)
                {
                    hashCode = (hashCode * 59) + this.PositionTitle.GetHashCode();
                }
                if (this.Etag != null)
                {
                    hashCode = (hashCode * 59) + this.Etag.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // StaffClassificationDescriptor (string) maxLength
            if (this.StaffClassificationDescriptor != null && this.StaffClassificationDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for StaffClassificationDescriptor, length must be less than 306.", new [] { "StaffClassificationDescriptor" });
            }

            // PositionTitle (string) maxLength
            if (this.PositionTitle != null && this.PositionTitle.Length > 100)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for PositionTitle, length must be less than 100.", new [] { "PositionTitle" });
            }

            yield break;
        }
    }

}
