/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiSurveyResponseSurveyLevel
    /// </summary>
    [DataContract(Name = "edFi_surveyResponseSurveyLevel")]
    public partial class EdFiSurveyResponseSurveyLevel : IEquatable<EdFiSurveyResponseSurveyLevel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiSurveyResponseSurveyLevel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiSurveyResponseSurveyLevel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiSurveyResponseSurveyLevel" /> class.
        /// </summary>
        /// <param name="surveyLevelDescriptor">Provides information about the respondents of a survey and how they can be grouped together. (required).</param>
        public EdFiSurveyResponseSurveyLevel(string surveyLevelDescriptor = default(string))
        {
            // to ensure "surveyLevelDescriptor" is required (not null)
            if (surveyLevelDescriptor == null)
            {
                throw new ArgumentNullException("surveyLevelDescriptor is a required property for EdFiSurveyResponseSurveyLevel and cannot be null");
            }
            this.SurveyLevelDescriptor = surveyLevelDescriptor;
        }

        /// <summary>
        /// Provides information about the respondents of a survey and how they can be grouped together.
        /// </summary>
        /// <value>Provides information about the respondents of a survey and how they can be grouped together.</value>
        [DataMember(Name = "surveyLevelDescriptor", IsRequired = true, EmitDefaultValue = true)]
        public string SurveyLevelDescriptor { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiSurveyResponseSurveyLevel {\n");
            sb.Append("  SurveyLevelDescriptor: ").Append(SurveyLevelDescriptor).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiSurveyResponseSurveyLevel);
        }

        /// <summary>
        /// Returns true if EdFiSurveyResponseSurveyLevel instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiSurveyResponseSurveyLevel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiSurveyResponseSurveyLevel input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.SurveyLevelDescriptor == input.SurveyLevelDescriptor ||
                    (this.SurveyLevelDescriptor != null &&
                    this.SurveyLevelDescriptor.Equals(input.SurveyLevelDescriptor))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.SurveyLevelDescriptor != null)
                {
                    hashCode = (hashCode * 59) + this.SurveyLevelDescriptor.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // SurveyLevelDescriptor (string) maxLength
            if (this.SurveyLevelDescriptor != null && this.SurveyLevelDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SurveyLevelDescriptor, length must be less than 306.", new [] { "SurveyLevelDescriptor" });
            }

            yield break;
        }
    }

}
