/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiXAssessmentRosterAssessmentAdministration
    /// </summary>
    [DataContract(Name = "edFiXAssessmentRoster_assessmentAdministration")]
    public partial class EdFiXAssessmentRosterAssessmentAdministration : IEquatable<EdFiXAssessmentRosterAssessmentAdministration>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXAssessmentRosterAssessmentAdministration" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiXAssessmentRosterAssessmentAdministration() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXAssessmentRosterAssessmentAdministration" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="administrationIdentifier">The title or name of the assessment in the context of it&#39;s administration. (required).</param>
        /// <param name="assessmentReference">assessmentReference (required).</param>
        /// <param name="assigningEducationOrganizationReference">assigningEducationOrganizationReference (required).</param>
        /// <param name="periods">An unordered collection of assessmentAdministrationPeriods. The anticipated dates or administration window.</param>
        /// <param name="etag">A unique system-generated value that identifies the version of the resource..</param>
        public EdFiXAssessmentRosterAssessmentAdministration(string id = default(string), string administrationIdentifier = default(string), EdFiAssessmentReference assessmentReference = default(EdFiAssessmentReference), EdFiEducationOrganizationReference assigningEducationOrganizationReference = default(EdFiEducationOrganizationReference), List<EdFiXAssessmentRosterAssessmentAdministrationPeriod> periods = default(List<EdFiXAssessmentRosterAssessmentAdministrationPeriod>), string etag = default(string))
        {
            // to ensure "administrationIdentifier" is required (not null)
            if (administrationIdentifier == null)
            {
                throw new ArgumentNullException("administrationIdentifier is a required property for EdFiXAssessmentRosterAssessmentAdministration and cannot be null");
            }
            this.AdministrationIdentifier = administrationIdentifier;
            // to ensure "assessmentReference" is required (not null)
            if (assessmentReference == null)
            {
                throw new ArgumentNullException("assessmentReference is a required property for EdFiXAssessmentRosterAssessmentAdministration and cannot be null");
            }
            this.AssessmentReference = assessmentReference;
            // to ensure "assigningEducationOrganizationReference" is required (not null)
            if (assigningEducationOrganizationReference == null)
            {
                throw new ArgumentNullException("assigningEducationOrganizationReference is a required property for EdFiXAssessmentRosterAssessmentAdministration and cannot be null");
            }
            this.AssigningEducationOrganizationReference = assigningEducationOrganizationReference;
            this.Id = id;
            this.Periods = periods;
            this.Etag = etag;
        }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public string Id { get; set; }

        /// <summary>
        /// The title or name of the assessment in the context of it&#39;s administration.
        /// </summary>
        /// <value>The title or name of the assessment in the context of it&#39;s administration.</value>
        [DataMember(Name = "administrationIdentifier", IsRequired = true, EmitDefaultValue = true)]
        public string AdministrationIdentifier { get; set; }

        /// <summary>
        /// Gets or Sets AssessmentReference
        /// </summary>
        [DataMember(Name = "assessmentReference", IsRequired = true, EmitDefaultValue = true)]
        public EdFiAssessmentReference AssessmentReference { get; set; }

        /// <summary>
        /// Gets or Sets AssigningEducationOrganizationReference
        /// </summary>
        [DataMember(Name = "assigningEducationOrganizationReference", IsRequired = true, EmitDefaultValue = true)]
        public EdFiEducationOrganizationReference AssigningEducationOrganizationReference { get; set; }

        /// <summary>
        /// An unordered collection of assessmentAdministrationPeriods. The anticipated dates or administration window
        /// </summary>
        /// <value>An unordered collection of assessmentAdministrationPeriods. The anticipated dates or administration window</value>
        [DataMember(Name = "periods", EmitDefaultValue = false)]
        public List<EdFiXAssessmentRosterAssessmentAdministrationPeriod> Periods { get; set; }

        /// <summary>
        /// A unique system-generated value that identifies the version of the resource.
        /// </summary>
        /// <value>A unique system-generated value that identifies the version of the resource.</value>
        [DataMember(Name = "_etag", EmitDefaultValue = false)]
        public string Etag { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiXAssessmentRosterAssessmentAdministration {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  AdministrationIdentifier: ").Append(AdministrationIdentifier).Append("\n");
            sb.Append("  AssessmentReference: ").Append(AssessmentReference).Append("\n");
            sb.Append("  AssigningEducationOrganizationReference: ").Append(AssigningEducationOrganizationReference).Append("\n");
            sb.Append("  Periods: ").Append(Periods).Append("\n");
            sb.Append("  Etag: ").Append(Etag).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiXAssessmentRosterAssessmentAdministration);
        }

        /// <summary>
        /// Returns true if EdFiXAssessmentRosterAssessmentAdministration instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiXAssessmentRosterAssessmentAdministration to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiXAssessmentRosterAssessmentAdministration input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.AdministrationIdentifier == input.AdministrationIdentifier ||
                    (this.AdministrationIdentifier != null &&
                    this.AdministrationIdentifier.Equals(input.AdministrationIdentifier))
                ) && 
                (
                    this.AssessmentReference == input.AssessmentReference ||
                    (this.AssessmentReference != null &&
                    this.AssessmentReference.Equals(input.AssessmentReference))
                ) && 
                (
                    this.AssigningEducationOrganizationReference == input.AssigningEducationOrganizationReference ||
                    (this.AssigningEducationOrganizationReference != null &&
                    this.AssigningEducationOrganizationReference.Equals(input.AssigningEducationOrganizationReference))
                ) && 
                (
                    this.Periods == input.Periods ||
                    this.Periods != null &&
                    input.Periods != null &&
                    this.Periods.SequenceEqual(input.Periods)
                ) && 
                (
                    this.Etag == input.Etag ||
                    (this.Etag != null &&
                    this.Etag.Equals(input.Etag))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                {
                    hashCode = (hashCode * 59) + this.Id.GetHashCode();
                }
                if (this.AdministrationIdentifier != null)
                {
                    hashCode = (hashCode * 59) + this.AdministrationIdentifier.GetHashCode();
                }
                if (this.AssessmentReference != null)
                {
                    hashCode = (hashCode * 59) + this.AssessmentReference.GetHashCode();
                }
                if (this.AssigningEducationOrganizationReference != null)
                {
                    hashCode = (hashCode * 59) + this.AssigningEducationOrganizationReference.GetHashCode();
                }
                if (this.Periods != null)
                {
                    hashCode = (hashCode * 59) + this.Periods.GetHashCode();
                }
                if (this.Etag != null)
                {
                    hashCode = (hashCode * 59) + this.Etag.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // AdministrationIdentifier (string) maxLength
            if (this.AdministrationIdentifier != null && this.AdministrationIdentifier.Length > 255)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for AdministrationIdentifier, length must be less than 255.", new [] { "AdministrationIdentifier" });
            }

            yield break;
        }
    }

}
