/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiXAssessmentRosterAssessmentAdministrationParticipation
    /// </summary>
    [DataContract(Name = "edFiXAssessmentRoster_assessmentAdministrationParticipation")]
    public partial class EdFiXAssessmentRosterAssessmentAdministrationParticipation : IEquatable<EdFiXAssessmentRosterAssessmentAdministrationParticipation>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXAssessmentRosterAssessmentAdministrationParticipation" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiXAssessmentRosterAssessmentAdministrationParticipation() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXAssessmentRosterAssessmentAdministrationParticipation" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="assessmentAdministrationReference">assessmentAdministrationReference (required).</param>
        /// <param name="participatingEducationOrganizationReference">participatingEducationOrganizationReference (required).</param>
        /// <param name="administrationContacts">An unordered collection of assessmentAdministrationParticipationAdministrationContacts. Pre-identified contacts for education organizations administering the assessment.</param>
        /// <param name="etag">A unique system-generated value that identifies the version of the resource..</param>
        public EdFiXAssessmentRosterAssessmentAdministrationParticipation(string id = default(string), EdFiXAssessmentRosterAssessmentAdministrationReference assessmentAdministrationReference = default(EdFiXAssessmentRosterAssessmentAdministrationReference), EdFiEducationOrganizationReference participatingEducationOrganizationReference = default(EdFiEducationOrganizationReference), List<EdFiXAssessmentRosterAssessmentAdministrationParticipationAdministrationContact> administrationContacts = default(List<EdFiXAssessmentRosterAssessmentAdministrationParticipationAdministrationContact>), string etag = default(string))
        {
            // to ensure "assessmentAdministrationReference" is required (not null)
            if (assessmentAdministrationReference == null)
            {
                throw new ArgumentNullException("assessmentAdministrationReference is a required property for EdFiXAssessmentRosterAssessmentAdministrationParticipation and cannot be null");
            }
            this.AssessmentAdministrationReference = assessmentAdministrationReference;
            // to ensure "participatingEducationOrganizationReference" is required (not null)
            if (participatingEducationOrganizationReference == null)
            {
                throw new ArgumentNullException("participatingEducationOrganizationReference is a required property for EdFiXAssessmentRosterAssessmentAdministrationParticipation and cannot be null");
            }
            this.ParticipatingEducationOrganizationReference = participatingEducationOrganizationReference;
            this.Id = id;
            this.AdministrationContacts = administrationContacts;
            this.Etag = etag;
        }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or Sets AssessmentAdministrationReference
        /// </summary>
        [DataMember(Name = "assessmentAdministrationReference", IsRequired = true, EmitDefaultValue = true)]
        public EdFiXAssessmentRosterAssessmentAdministrationReference AssessmentAdministrationReference { get; set; }

        /// <summary>
        /// Gets or Sets ParticipatingEducationOrganizationReference
        /// </summary>
        [DataMember(Name = "participatingEducationOrganizationReference", IsRequired = true, EmitDefaultValue = true)]
        public EdFiEducationOrganizationReference ParticipatingEducationOrganizationReference { get; set; }

        /// <summary>
        /// An unordered collection of assessmentAdministrationParticipationAdministrationContacts. Pre-identified contacts for education organizations administering the assessment
        /// </summary>
        /// <value>An unordered collection of assessmentAdministrationParticipationAdministrationContacts. Pre-identified contacts for education organizations administering the assessment</value>
        [DataMember(Name = "administrationContacts", EmitDefaultValue = false)]
        public List<EdFiXAssessmentRosterAssessmentAdministrationParticipationAdministrationContact> AdministrationContacts { get; set; }

        /// <summary>
        /// A unique system-generated value that identifies the version of the resource.
        /// </summary>
        /// <value>A unique system-generated value that identifies the version of the resource.</value>
        [DataMember(Name = "_etag", EmitDefaultValue = false)]
        public string Etag { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiXAssessmentRosterAssessmentAdministrationParticipation {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  AssessmentAdministrationReference: ").Append(AssessmentAdministrationReference).Append("\n");
            sb.Append("  ParticipatingEducationOrganizationReference: ").Append(ParticipatingEducationOrganizationReference).Append("\n");
            sb.Append("  AdministrationContacts: ").Append(AdministrationContacts).Append("\n");
            sb.Append("  Etag: ").Append(Etag).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiXAssessmentRosterAssessmentAdministrationParticipation);
        }

        /// <summary>
        /// Returns true if EdFiXAssessmentRosterAssessmentAdministrationParticipation instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiXAssessmentRosterAssessmentAdministrationParticipation to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiXAssessmentRosterAssessmentAdministrationParticipation input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.AssessmentAdministrationReference == input.AssessmentAdministrationReference ||
                    (this.AssessmentAdministrationReference != null &&
                    this.AssessmentAdministrationReference.Equals(input.AssessmentAdministrationReference))
                ) && 
                (
                    this.ParticipatingEducationOrganizationReference == input.ParticipatingEducationOrganizationReference ||
                    (this.ParticipatingEducationOrganizationReference != null &&
                    this.ParticipatingEducationOrganizationReference.Equals(input.ParticipatingEducationOrganizationReference))
                ) && 
                (
                    this.AdministrationContacts == input.AdministrationContacts ||
                    this.AdministrationContacts != null &&
                    input.AdministrationContacts != null &&
                    this.AdministrationContacts.SequenceEqual(input.AdministrationContacts)
                ) && 
                (
                    this.Etag == input.Etag ||
                    (this.Etag != null &&
                    this.Etag.Equals(input.Etag))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                {
                    hashCode = (hashCode * 59) + this.Id.GetHashCode();
                }
                if (this.AssessmentAdministrationReference != null)
                {
                    hashCode = (hashCode * 59) + this.AssessmentAdministrationReference.GetHashCode();
                }
                if (this.ParticipatingEducationOrganizationReference != null)
                {
                    hashCode = (hashCode * 59) + this.ParticipatingEducationOrganizationReference.GetHashCode();
                }
                if (this.AdministrationContacts != null)
                {
                    hashCode = (hashCode * 59) + this.AdministrationContacts.GetHashCode();
                }
                if (this.Etag != null)
                {
                    hashCode = (hashCode * 59) + this.Etag.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
