/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiXAssessmentRosterAssessmentAdministrationReference
    /// </summary>
    [DataContract(Name = "edFiXAssessmentRoster_assessmentAdministrationReference")]
    public partial class EdFiXAssessmentRosterAssessmentAdministrationReference : IEquatable<EdFiXAssessmentRosterAssessmentAdministrationReference>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXAssessmentRosterAssessmentAdministrationReference" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiXAssessmentRosterAssessmentAdministrationReference() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXAssessmentRosterAssessmentAdministrationReference" /> class.
        /// </summary>
        /// <param name="administrationIdentifier">The title or name of the assessment in the context of it&#39;s administration. (required).</param>
        /// <param name="assessmentIdentifier">A unique number or alphanumeric code assigned to an assessment. (required).</param>
        /// <param name="assigningEducationOrganizationId">The identifier assigned to an education organization. (required).</param>
        /// <param name="_namespace">Namespace for the assessment. (required).</param>
        /// <param name="link">link.</param>
        public EdFiXAssessmentRosterAssessmentAdministrationReference(string administrationIdentifier = default(string), string assessmentIdentifier = default(string), int assigningEducationOrganizationId = default(int), string _namespace = default(string), Link link = default(Link))
        {
            // to ensure "administrationIdentifier" is required (not null)
            if (administrationIdentifier == null)
            {
                throw new ArgumentNullException("administrationIdentifier is a required property for EdFiXAssessmentRosterAssessmentAdministrationReference and cannot be null");
            }
            this.AdministrationIdentifier = administrationIdentifier;
            // to ensure "assessmentIdentifier" is required (not null)
            if (assessmentIdentifier == null)
            {
                throw new ArgumentNullException("assessmentIdentifier is a required property for EdFiXAssessmentRosterAssessmentAdministrationReference and cannot be null");
            }
            this.AssessmentIdentifier = assessmentIdentifier;
            this.AssigningEducationOrganizationId = assigningEducationOrganizationId;
            // to ensure "_namespace" is required (not null)
            if (_namespace == null)
            {
                throw new ArgumentNullException("_namespace is a required property for EdFiXAssessmentRosterAssessmentAdministrationReference and cannot be null");
            }
            this.Namespace = _namespace;
            this.Link = link;
        }

        /// <summary>
        /// The title or name of the assessment in the context of it&#39;s administration.
        /// </summary>
        /// <value>The title or name of the assessment in the context of it&#39;s administration.</value>
        [DataMember(Name = "administrationIdentifier", IsRequired = true, EmitDefaultValue = true)]
        public string AdministrationIdentifier { get; set; }

        /// <summary>
        /// A unique number or alphanumeric code assigned to an assessment.
        /// </summary>
        /// <value>A unique number or alphanumeric code assigned to an assessment.</value>
        [DataMember(Name = "assessmentIdentifier", IsRequired = true, EmitDefaultValue = true)]
        public string AssessmentIdentifier { get; set; }

        /// <summary>
        /// The identifier assigned to an education organization.
        /// </summary>
        /// <value>The identifier assigned to an education organization.</value>
        [DataMember(Name = "assigningEducationOrganizationId", IsRequired = true, EmitDefaultValue = true)]
        public int AssigningEducationOrganizationId { get; set; }

        /// <summary>
        /// Namespace for the assessment.
        /// </summary>
        /// <value>Namespace for the assessment.</value>
        [DataMember(Name = "namespace", IsRequired = true, EmitDefaultValue = true)]
        public string Namespace { get; set; }

        /// <summary>
        /// Gets or Sets Link
        /// </summary>
        [DataMember(Name = "link", EmitDefaultValue = false)]
        public Link Link { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiXAssessmentRosterAssessmentAdministrationReference {\n");
            sb.Append("  AdministrationIdentifier: ").Append(AdministrationIdentifier).Append("\n");
            sb.Append("  AssessmentIdentifier: ").Append(AssessmentIdentifier).Append("\n");
            sb.Append("  AssigningEducationOrganizationId: ").Append(AssigningEducationOrganizationId).Append("\n");
            sb.Append("  Namespace: ").Append(Namespace).Append("\n");
            sb.Append("  Link: ").Append(Link).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiXAssessmentRosterAssessmentAdministrationReference);
        }

        /// <summary>
        /// Returns true if EdFiXAssessmentRosterAssessmentAdministrationReference instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiXAssessmentRosterAssessmentAdministrationReference to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiXAssessmentRosterAssessmentAdministrationReference input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.AdministrationIdentifier == input.AdministrationIdentifier ||
                    (this.AdministrationIdentifier != null &&
                    this.AdministrationIdentifier.Equals(input.AdministrationIdentifier))
                ) && 
                (
                    this.AssessmentIdentifier == input.AssessmentIdentifier ||
                    (this.AssessmentIdentifier != null &&
                    this.AssessmentIdentifier.Equals(input.AssessmentIdentifier))
                ) && 
                (
                    this.AssigningEducationOrganizationId == input.AssigningEducationOrganizationId ||
                    this.AssigningEducationOrganizationId.Equals(input.AssigningEducationOrganizationId)
                ) && 
                (
                    this.Namespace == input.Namespace ||
                    (this.Namespace != null &&
                    this.Namespace.Equals(input.Namespace))
                ) && 
                (
                    this.Link == input.Link ||
                    (this.Link != null &&
                    this.Link.Equals(input.Link))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.AdministrationIdentifier != null)
                {
                    hashCode = (hashCode * 59) + this.AdministrationIdentifier.GetHashCode();
                }
                if (this.AssessmentIdentifier != null)
                {
                    hashCode = (hashCode * 59) + this.AssessmentIdentifier.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.AssigningEducationOrganizationId.GetHashCode();
                if (this.Namespace != null)
                {
                    hashCode = (hashCode * 59) + this.Namespace.GetHashCode();
                }
                if (this.Link != null)
                {
                    hashCode = (hashCode * 59) + this.Link.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // AdministrationIdentifier (string) maxLength
            if (this.AdministrationIdentifier != null && this.AdministrationIdentifier.Length > 255)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for AdministrationIdentifier, length must be less than 255.", new [] { "AdministrationIdentifier" });
            }

            // AssessmentIdentifier (string) maxLength
            if (this.AssessmentIdentifier != null && this.AssessmentIdentifier.Length > 60)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for AssessmentIdentifier, length must be less than 60.", new [] { "AssessmentIdentifier" });
            }

            // Namespace (string) maxLength
            if (this.Namespace != null && this.Namespace.Length > 255)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Namespace, length must be less than 255.", new [] { "Namespace" });
            }

            yield break;
        }
    }

}
