/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiXAssessmentRosterStudentAssessmentRegistration
    /// </summary>
    [DataContract(Name = "edFiXAssessmentRoster_studentAssessmentRegistration")]
    public partial class EdFiXAssessmentRosterStudentAssessmentRegistration : IEquatable<EdFiXAssessmentRosterStudentAssessmentRegistration>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXAssessmentRosterStudentAssessmentRegistration" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiXAssessmentRosterStudentAssessmentRegistration() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXAssessmentRosterStudentAssessmentRegistration" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="assessmentAdministrationReference">assessmentAdministrationReference (required).</param>
        /// <param name="reportingEducationOrganizationReference">reportingEducationOrganizationReference.</param>
        /// <param name="studentEducationOrganizationAssociationReference">studentEducationOrganizationAssociationReference (required).</param>
        /// <param name="testingEducationOrganizationReference">testingEducationOrganizationReference.</param>
        /// <param name="assessmentCustomizations">An unordered collection of studentAssessmentRegistrationAssessmentCustomizations. Key/value pairs which may be used to facilitate customization of an assessment or to support vendor reporting/analysis.</param>
        /// <param name="platformTypeDescriptor">The environment or format in which the assessment is expected to be administred.</param>
        /// <param name="etag">A unique system-generated value that identifies the version of the resource..</param>
        public EdFiXAssessmentRosterStudentAssessmentRegistration(string id = default(string), EdFiXAssessmentRosterAssessmentAdministrationReference assessmentAdministrationReference = default(EdFiXAssessmentRosterAssessmentAdministrationReference), EdFiEducationOrganizationReference reportingEducationOrganizationReference = default(EdFiEducationOrganizationReference), EdFiStudentEducationOrganizationAssociationReference studentEducationOrganizationAssociationReference = default(EdFiStudentEducationOrganizationAssociationReference), EdFiEducationOrganizationReference testingEducationOrganizationReference = default(EdFiEducationOrganizationReference), List<EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization> assessmentCustomizations = default(List<EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization>), string platformTypeDescriptor = default(string), string etag = default(string))
        {
            // to ensure "assessmentAdministrationReference" is required (not null)
            if (assessmentAdministrationReference == null)
            {
                throw new ArgumentNullException("assessmentAdministrationReference is a required property for EdFiXAssessmentRosterStudentAssessmentRegistration and cannot be null");
            }
            this.AssessmentAdministrationReference = assessmentAdministrationReference;
            // to ensure "studentEducationOrganizationAssociationReference" is required (not null)
            if (studentEducationOrganizationAssociationReference == null)
            {
                throw new ArgumentNullException("studentEducationOrganizationAssociationReference is a required property for EdFiXAssessmentRosterStudentAssessmentRegistration and cannot be null");
            }
            this.StudentEducationOrganizationAssociationReference = studentEducationOrganizationAssociationReference;
            this.Id = id;
            this.ReportingEducationOrganizationReference = reportingEducationOrganizationReference;
            this.TestingEducationOrganizationReference = testingEducationOrganizationReference;
            this.AssessmentCustomizations = assessmentCustomizations;
            this.PlatformTypeDescriptor = platformTypeDescriptor;
            this.Etag = etag;
        }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or Sets AssessmentAdministrationReference
        /// </summary>
        [DataMember(Name = "assessmentAdministrationReference", IsRequired = true, EmitDefaultValue = true)]
        public EdFiXAssessmentRosterAssessmentAdministrationReference AssessmentAdministrationReference { get; set; }

        /// <summary>
        /// Gets or Sets ReportingEducationOrganizationReference
        /// </summary>
        [DataMember(Name = "reportingEducationOrganizationReference", EmitDefaultValue = false)]
        public EdFiEducationOrganizationReference ReportingEducationOrganizationReference { get; set; }

        /// <summary>
        /// Gets or Sets StudentEducationOrganizationAssociationReference
        /// </summary>
        [DataMember(Name = "studentEducationOrganizationAssociationReference", IsRequired = true, EmitDefaultValue = true)]
        public EdFiStudentEducationOrganizationAssociationReference StudentEducationOrganizationAssociationReference { get; set; }

        /// <summary>
        /// Gets or Sets TestingEducationOrganizationReference
        /// </summary>
        [DataMember(Name = "testingEducationOrganizationReference", EmitDefaultValue = false)]
        public EdFiEducationOrganizationReference TestingEducationOrganizationReference { get; set; }

        /// <summary>
        /// An unordered collection of studentAssessmentRegistrationAssessmentCustomizations. Key/value pairs which may be used to facilitate customization of an assessment or to support vendor reporting/analysis
        /// </summary>
        /// <value>An unordered collection of studentAssessmentRegistrationAssessmentCustomizations. Key/value pairs which may be used to facilitate customization of an assessment or to support vendor reporting/analysis</value>
        [DataMember(Name = "assessmentCustomizations", EmitDefaultValue = false)]
        public List<EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization> AssessmentCustomizations { get; set; }

        /// <summary>
        /// The environment or format in which the assessment is expected to be administred
        /// </summary>
        /// <value>The environment or format in which the assessment is expected to be administred</value>
        [DataMember(Name = "platformTypeDescriptor", EmitDefaultValue = true)]
        public string PlatformTypeDescriptor { get; set; }

        /// <summary>
        /// A unique system-generated value that identifies the version of the resource.
        /// </summary>
        /// <value>A unique system-generated value that identifies the version of the resource.</value>
        [DataMember(Name = "_etag", EmitDefaultValue = false)]
        public string Etag { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiXAssessmentRosterStudentAssessmentRegistration {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  AssessmentAdministrationReference: ").Append(AssessmentAdministrationReference).Append("\n");
            sb.Append("  ReportingEducationOrganizationReference: ").Append(ReportingEducationOrganizationReference).Append("\n");
            sb.Append("  StudentEducationOrganizationAssociationReference: ").Append(StudentEducationOrganizationAssociationReference).Append("\n");
            sb.Append("  TestingEducationOrganizationReference: ").Append(TestingEducationOrganizationReference).Append("\n");
            sb.Append("  AssessmentCustomizations: ").Append(AssessmentCustomizations).Append("\n");
            sb.Append("  PlatformTypeDescriptor: ").Append(PlatformTypeDescriptor).Append("\n");
            sb.Append("  Etag: ").Append(Etag).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiXAssessmentRosterStudentAssessmentRegistration);
        }

        /// <summary>
        /// Returns true if EdFiXAssessmentRosterStudentAssessmentRegistration instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiXAssessmentRosterStudentAssessmentRegistration to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiXAssessmentRosterStudentAssessmentRegistration input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.AssessmentAdministrationReference == input.AssessmentAdministrationReference ||
                    (this.AssessmentAdministrationReference != null &&
                    this.AssessmentAdministrationReference.Equals(input.AssessmentAdministrationReference))
                ) && 
                (
                    this.ReportingEducationOrganizationReference == input.ReportingEducationOrganizationReference ||
                    (this.ReportingEducationOrganizationReference != null &&
                    this.ReportingEducationOrganizationReference.Equals(input.ReportingEducationOrganizationReference))
                ) && 
                (
                    this.StudentEducationOrganizationAssociationReference == input.StudentEducationOrganizationAssociationReference ||
                    (this.StudentEducationOrganizationAssociationReference != null &&
                    this.StudentEducationOrganizationAssociationReference.Equals(input.StudentEducationOrganizationAssociationReference))
                ) && 
                (
                    this.TestingEducationOrganizationReference == input.TestingEducationOrganizationReference ||
                    (this.TestingEducationOrganizationReference != null &&
                    this.TestingEducationOrganizationReference.Equals(input.TestingEducationOrganizationReference))
                ) && 
                (
                    this.AssessmentCustomizations == input.AssessmentCustomizations ||
                    this.AssessmentCustomizations != null &&
                    input.AssessmentCustomizations != null &&
                    this.AssessmentCustomizations.SequenceEqual(input.AssessmentCustomizations)
                ) && 
                (
                    this.PlatformTypeDescriptor == input.PlatformTypeDescriptor ||
                    (this.PlatformTypeDescriptor != null &&
                    this.PlatformTypeDescriptor.Equals(input.PlatformTypeDescriptor))
                ) && 
                (
                    this.Etag == input.Etag ||
                    (this.Etag != null &&
                    this.Etag.Equals(input.Etag))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                {
                    hashCode = (hashCode * 59) + this.Id.GetHashCode();
                }
                if (this.AssessmentAdministrationReference != null)
                {
                    hashCode = (hashCode * 59) + this.AssessmentAdministrationReference.GetHashCode();
                }
                if (this.ReportingEducationOrganizationReference != null)
                {
                    hashCode = (hashCode * 59) + this.ReportingEducationOrganizationReference.GetHashCode();
                }
                if (this.StudentEducationOrganizationAssociationReference != null)
                {
                    hashCode = (hashCode * 59) + this.StudentEducationOrganizationAssociationReference.GetHashCode();
                }
                if (this.TestingEducationOrganizationReference != null)
                {
                    hashCode = (hashCode * 59) + this.TestingEducationOrganizationReference.GetHashCode();
                }
                if (this.AssessmentCustomizations != null)
                {
                    hashCode = (hashCode * 59) + this.AssessmentCustomizations.GetHashCode();
                }
                if (this.PlatformTypeDescriptor != null)
                {
                    hashCode = (hashCode * 59) + this.PlatformTypeDescriptor.GetHashCode();
                }
                if (this.Etag != null)
                {
                    hashCode = (hashCode * 59) + this.Etag.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // PlatformTypeDescriptor (string) maxLength
            if (this.PlatformTypeDescriptor != null && this.PlatformTypeDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for PlatformTypeDescriptor, length must be less than 306.", new [] { "PlatformTypeDescriptor" });
            }

            yield break;
        }
    }

}
