/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization
    /// </summary>
    [DataContract(Name = "edFiXAssessmentRoster_studentAssessmentRegistrationAssessmentCustomization")]
    public partial class EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization : IEquatable<EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization" /> class.
        /// </summary>
        /// <param name="identificationCode">An agreed upon code identifying the value for customization or reporting (required).</param>
        /// <param name="customizationValue">The value indicated for customization or reporting (required).</param>
        public EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization(string identificationCode = default(string), string customizationValue = default(string))
        {
            // to ensure "identificationCode" is required (not null)
            if (identificationCode == null)
            {
                throw new ArgumentNullException("identificationCode is a required property for EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization and cannot be null");
            }
            this.IdentificationCode = identificationCode;
            // to ensure "customizationValue" is required (not null)
            if (customizationValue == null)
            {
                throw new ArgumentNullException("customizationValue is a required property for EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization and cannot be null");
            }
            this.CustomizationValue = customizationValue;
        }

        /// <summary>
        /// An agreed upon code identifying the value for customization or reporting
        /// </summary>
        /// <value>An agreed upon code identifying the value for customization or reporting</value>
        [DataMember(Name = "identificationCode", IsRequired = true, EmitDefaultValue = true)]
        public string IdentificationCode { get; set; }

        /// <summary>
        /// The value indicated for customization or reporting
        /// </summary>
        /// <value>The value indicated for customization or reporting</value>
        [DataMember(Name = "customizationValue", IsRequired = true, EmitDefaultValue = true)]
        public string CustomizationValue { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization {\n");
            sb.Append("  IdentificationCode: ").Append(IdentificationCode).Append("\n");
            sb.Append("  CustomizationValue: ").Append(CustomizationValue).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization);
        }

        /// <summary>
        /// Returns true if EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.IdentificationCode == input.IdentificationCode ||
                    (this.IdentificationCode != null &&
                    this.IdentificationCode.Equals(input.IdentificationCode))
                ) && 
                (
                    this.CustomizationValue == input.CustomizationValue ||
                    (this.CustomizationValue != null &&
                    this.CustomizationValue.Equals(input.CustomizationValue))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.IdentificationCode != null)
                {
                    hashCode = (hashCode * 59) + this.IdentificationCode.GetHashCode();
                }
                if (this.CustomizationValue != null)
                {
                    hashCode = (hashCode * 59) + this.CustomizationValue.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // IdentificationCode (string) maxLength
            if (this.IdentificationCode != null && this.IdentificationCode.Length > 60)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for IdentificationCode, length must be less than 60.", new [] { "IdentificationCode" });
            }

            // CustomizationValue (string) maxLength
            if (this.CustomizationValue != null && this.CustomizationValue.Length > 1024)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for CustomizationValue, length must be less than 1024.", new [] { "CustomizationValue" });
            }

            yield break;
        }
    }

}
