/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// TrackedChangesEdFiInterventionPrescriptionKey
    /// </summary>
    [DataContract(Name = "trackedChanges_edFi_interventionPrescriptionKey")]
    public partial class TrackedChangesEdFiInterventionPrescriptionKey : IEquatable<TrackedChangesEdFiInterventionPrescriptionKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TrackedChangesEdFiInterventionPrescriptionKey" /> class.
        /// </summary>
        /// <param name="interventionPrescriptionIdentificationCode">A unique number or alphanumeric code assigned to an intervention prescription..</param>
        /// <param name="educationOrganizationId">The identifier assigned to an education organization..</param>
        public TrackedChangesEdFiInterventionPrescriptionKey(string interventionPrescriptionIdentificationCode = default(string), int educationOrganizationId = default(int))
        {
            this.InterventionPrescriptionIdentificationCode = interventionPrescriptionIdentificationCode;
            this.EducationOrganizationId = educationOrganizationId;
        }

        /// <summary>
        /// A unique number or alphanumeric code assigned to an intervention prescription.
        /// </summary>
        /// <value>A unique number or alphanumeric code assigned to an intervention prescription.</value>
        [DataMember(Name = "interventionPrescriptionIdentificationCode", EmitDefaultValue = false)]
        public string InterventionPrescriptionIdentificationCode { get; set; }

        /// <summary>
        /// The identifier assigned to an education organization.
        /// </summary>
        /// <value>The identifier assigned to an education organization.</value>
        [DataMember(Name = "educationOrganizationId", EmitDefaultValue = false)]
        public int EducationOrganizationId { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class TrackedChangesEdFiInterventionPrescriptionKey {\n");
            sb.Append("  InterventionPrescriptionIdentificationCode: ").Append(InterventionPrescriptionIdentificationCode).Append("\n");
            sb.Append("  EducationOrganizationId: ").Append(EducationOrganizationId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TrackedChangesEdFiInterventionPrescriptionKey);
        }

        /// <summary>
        /// Returns true if TrackedChangesEdFiInterventionPrescriptionKey instances are equal
        /// </summary>
        /// <param name="input">Instance of TrackedChangesEdFiInterventionPrescriptionKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TrackedChangesEdFiInterventionPrescriptionKey input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.InterventionPrescriptionIdentificationCode == input.InterventionPrescriptionIdentificationCode ||
                    (this.InterventionPrescriptionIdentificationCode != null &&
                    this.InterventionPrescriptionIdentificationCode.Equals(input.InterventionPrescriptionIdentificationCode))
                ) && 
                (
                    this.EducationOrganizationId == input.EducationOrganizationId ||
                    this.EducationOrganizationId.Equals(input.EducationOrganizationId)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.InterventionPrescriptionIdentificationCode != null)
                {
                    hashCode = (hashCode * 59) + this.InterventionPrescriptionIdentificationCode.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.EducationOrganizationId.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // InterventionPrescriptionIdentificationCode (string) maxLength
            if (this.InterventionPrescriptionIdentificationCode != null && this.InterventionPrescriptionIdentificationCode.Length > 60)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for InterventionPrescriptionIdentificationCode, length must be less than 60.", new [] { "InterventionPrescriptionIdentificationCode" });
            }

            yield break;
        }
    }

}
