/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// TrackedChangesEdFiLearningStandardEquivalenceAssociationKey
    /// </summary>
    [DataContract(Name = "trackedChanges_edFi_learningStandardEquivalenceAssociationKey")]
    public partial class TrackedChangesEdFiLearningStandardEquivalenceAssociationKey : IEquatable<TrackedChangesEdFiLearningStandardEquivalenceAssociationKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TrackedChangesEdFiLearningStandardEquivalenceAssociationKey" /> class.
        /// </summary>
        /// <param name="_namespace">The namespace of the organization that has created and owns the association..</param>
        /// <param name="sourceLearningStandardId">The identifier for the specific learning standard (e.g., 111.15.3.1.A)..</param>
        /// <param name="targetLearningStandardId">The identifier for the specific learning standard (e.g., 111.15.3.1.A)..</param>
        public TrackedChangesEdFiLearningStandardEquivalenceAssociationKey(string _namespace = default(string), string sourceLearningStandardId = default(string), string targetLearningStandardId = default(string))
        {
            this.Namespace = _namespace;
            this.SourceLearningStandardId = sourceLearningStandardId;
            this.TargetLearningStandardId = targetLearningStandardId;
        }

        /// <summary>
        /// The namespace of the organization that has created and owns the association.
        /// </summary>
        /// <value>The namespace of the organization that has created and owns the association.</value>
        [DataMember(Name = "namespace", EmitDefaultValue = false)]
        public string Namespace { get; set; }

        /// <summary>
        /// The identifier for the specific learning standard (e.g., 111.15.3.1.A).
        /// </summary>
        /// <value>The identifier for the specific learning standard (e.g., 111.15.3.1.A).</value>
        [DataMember(Name = "sourceLearningStandardId", EmitDefaultValue = false)]
        public string SourceLearningStandardId { get; set; }

        /// <summary>
        /// The identifier for the specific learning standard (e.g., 111.15.3.1.A).
        /// </summary>
        /// <value>The identifier for the specific learning standard (e.g., 111.15.3.1.A).</value>
        [DataMember(Name = "targetLearningStandardId", EmitDefaultValue = false)]
        public string TargetLearningStandardId { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class TrackedChangesEdFiLearningStandardEquivalenceAssociationKey {\n");
            sb.Append("  Namespace: ").Append(Namespace).Append("\n");
            sb.Append("  SourceLearningStandardId: ").Append(SourceLearningStandardId).Append("\n");
            sb.Append("  TargetLearningStandardId: ").Append(TargetLearningStandardId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TrackedChangesEdFiLearningStandardEquivalenceAssociationKey);
        }

        /// <summary>
        /// Returns true if TrackedChangesEdFiLearningStandardEquivalenceAssociationKey instances are equal
        /// </summary>
        /// <param name="input">Instance of TrackedChangesEdFiLearningStandardEquivalenceAssociationKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TrackedChangesEdFiLearningStandardEquivalenceAssociationKey input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Namespace == input.Namespace ||
                    (this.Namespace != null &&
                    this.Namespace.Equals(input.Namespace))
                ) && 
                (
                    this.SourceLearningStandardId == input.SourceLearningStandardId ||
                    (this.SourceLearningStandardId != null &&
                    this.SourceLearningStandardId.Equals(input.SourceLearningStandardId))
                ) && 
                (
                    this.TargetLearningStandardId == input.TargetLearningStandardId ||
                    (this.TargetLearningStandardId != null &&
                    this.TargetLearningStandardId.Equals(input.TargetLearningStandardId))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Namespace != null)
                {
                    hashCode = (hashCode * 59) + this.Namespace.GetHashCode();
                }
                if (this.SourceLearningStandardId != null)
                {
                    hashCode = (hashCode * 59) + this.SourceLearningStandardId.GetHashCode();
                }
                if (this.TargetLearningStandardId != null)
                {
                    hashCode = (hashCode * 59) + this.TargetLearningStandardId.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // Namespace (string) maxLength
            if (this.Namespace != null && this.Namespace.Length > 255)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Namespace, length must be less than 255.", new [] { "Namespace" });
            }

            // SourceLearningStandardId (string) maxLength
            if (this.SourceLearningStandardId != null && this.SourceLearningStandardId.Length > 60)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SourceLearningStandardId, length must be less than 60.", new [] { "SourceLearningStandardId" });
            }

            // TargetLearningStandardId (string) maxLength
            if (this.TargetLearningStandardId != null && this.TargetLearningStandardId.Length > 60)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for TargetLearningStandardId, length must be less than 60.", new [] { "TargetLearningStandardId" });
            }

            yield break;
        }
    }

}
