/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// TrackedChangesEdFiPostSecondaryEventKey
    /// </summary>
    [DataContract(Name = "trackedChanges_edFi_postSecondaryEventKey")]
    public partial class TrackedChangesEdFiPostSecondaryEventKey : IEquatable<TrackedChangesEdFiPostSecondaryEventKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TrackedChangesEdFiPostSecondaryEventKey" /> class.
        /// </summary>
        /// <param name="postSecondaryEventCategoryDescriptor">The post secondary event that is logged..</param>
        /// <param name="eventDate">The date the event occurred or was recorded..</param>
        /// <param name="studentUniqueId">A unique alphanumeric code assigned to a student..</param>
        public TrackedChangesEdFiPostSecondaryEventKey(string postSecondaryEventCategoryDescriptor = default(string), DateTime eventDate = default(DateTime), string studentUniqueId = default(string))
        {
            this.PostSecondaryEventCategoryDescriptor = postSecondaryEventCategoryDescriptor;
            this.EventDate = eventDate;
            this.StudentUniqueId = studentUniqueId;
        }

        /// <summary>
        /// The post secondary event that is logged.
        /// </summary>
        /// <value>The post secondary event that is logged.</value>
        [DataMember(Name = "postSecondaryEventCategoryDescriptor", EmitDefaultValue = false)]
        public string PostSecondaryEventCategoryDescriptor { get; set; }

        /// <summary>
        /// The date the event occurred or was recorded.
        /// </summary>
        /// <value>The date the event occurred or was recorded.</value>
        [DataMember(Name = "eventDate", EmitDefaultValue = false)]
        [JsonConverter(typeof(OpenAPIDateConverter))]
        public DateTime EventDate { get; set; }

        /// <summary>
        /// A unique alphanumeric code assigned to a student.
        /// </summary>
        /// <value>A unique alphanumeric code assigned to a student.</value>
        [DataMember(Name = "studentUniqueId", EmitDefaultValue = false)]
        public string StudentUniqueId { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class TrackedChangesEdFiPostSecondaryEventKey {\n");
            sb.Append("  PostSecondaryEventCategoryDescriptor: ").Append(PostSecondaryEventCategoryDescriptor).Append("\n");
            sb.Append("  EventDate: ").Append(EventDate).Append("\n");
            sb.Append("  StudentUniqueId: ").Append(StudentUniqueId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TrackedChangesEdFiPostSecondaryEventKey);
        }

        /// <summary>
        /// Returns true if TrackedChangesEdFiPostSecondaryEventKey instances are equal
        /// </summary>
        /// <param name="input">Instance of TrackedChangesEdFiPostSecondaryEventKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TrackedChangesEdFiPostSecondaryEventKey input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.PostSecondaryEventCategoryDescriptor == input.PostSecondaryEventCategoryDescriptor ||
                    (this.PostSecondaryEventCategoryDescriptor != null &&
                    this.PostSecondaryEventCategoryDescriptor.Equals(input.PostSecondaryEventCategoryDescriptor))
                ) && 
                (
                    this.EventDate == input.EventDate ||
                    (this.EventDate != null &&
                    this.EventDate.Equals(input.EventDate))
                ) && 
                (
                    this.StudentUniqueId == input.StudentUniqueId ||
                    (this.StudentUniqueId != null &&
                    this.StudentUniqueId.Equals(input.StudentUniqueId))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.PostSecondaryEventCategoryDescriptor != null)
                {
                    hashCode = (hashCode * 59) + this.PostSecondaryEventCategoryDescriptor.GetHashCode();
                }
                if (this.EventDate != null)
                {
                    hashCode = (hashCode * 59) + this.EventDate.GetHashCode();
                }
                if (this.StudentUniqueId != null)
                {
                    hashCode = (hashCode * 59) + this.StudentUniqueId.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // PostSecondaryEventCategoryDescriptor (string) maxLength
            if (this.PostSecondaryEventCategoryDescriptor != null && this.PostSecondaryEventCategoryDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for PostSecondaryEventCategoryDescriptor, length must be less than 306.", new [] { "PostSecondaryEventCategoryDescriptor" });
            }

            // StudentUniqueId (string) maxLength
            if (this.StudentUniqueId != null && this.StudentUniqueId.Length > 32)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for StudentUniqueId, length must be less than 32.", new [] { "StudentUniqueId" });
            }

            yield break;
        }
    }

}
