/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// WiStudentCTEProgramAssociationExtension
    /// </summary>
    [DataContract(Name = "wi_studentCTEProgramAssociationExtension")]
    public partial class WiStudentCTEProgramAssociationExtension : IEquatable<WiStudentCTEProgramAssociationExtension>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="WiStudentCTEProgramAssociationExtension" /> class.
        /// </summary>
        /// <param name="certificatedProgramStatusDescriptor">Indicator of Certificated Program Status.</param>
        /// <param name="cteConcentrationCteProgramAreas">An unordered collection of studentCTEProgramAssociationCTEConcentrationCteProgramAreas. WI Program areas of concentration..</param>
        public WiStudentCTEProgramAssociationExtension(string certificatedProgramStatusDescriptor = default(string), List<WiStudentCTEProgramAssociationCTEConcentrationCteProgramArea> cteConcentrationCteProgramAreas = default(List<WiStudentCTEProgramAssociationCTEConcentrationCteProgramArea>))
        {
            this.CertificatedProgramStatusDescriptor = certificatedProgramStatusDescriptor;
            this.CteConcentrationCteProgramAreas = cteConcentrationCteProgramAreas;
        }

        /// <summary>
        /// Indicator of Certificated Program Status
        /// </summary>
        /// <value>Indicator of Certificated Program Status</value>
        [DataMember(Name = "certificatedProgramStatusDescriptor", EmitDefaultValue = true)]
        public string CertificatedProgramStatusDescriptor { get; set; }

        /// <summary>
        /// An unordered collection of studentCTEProgramAssociationCTEConcentrationCteProgramAreas. WI Program areas of concentration.
        /// </summary>
        /// <value>An unordered collection of studentCTEProgramAssociationCTEConcentrationCteProgramAreas. WI Program areas of concentration.</value>
        [DataMember(Name = "cteConcentrationCteProgramAreas", EmitDefaultValue = false)]
        public List<WiStudentCTEProgramAssociationCTEConcentrationCteProgramArea> CteConcentrationCteProgramAreas { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class WiStudentCTEProgramAssociationExtension {\n");
            sb.Append("  CertificatedProgramStatusDescriptor: ").Append(CertificatedProgramStatusDescriptor).Append("\n");
            sb.Append("  CteConcentrationCteProgramAreas: ").Append(CteConcentrationCteProgramAreas).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as WiStudentCTEProgramAssociationExtension);
        }

        /// <summary>
        /// Returns true if WiStudentCTEProgramAssociationExtension instances are equal
        /// </summary>
        /// <param name="input">Instance of WiStudentCTEProgramAssociationExtension to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(WiStudentCTEProgramAssociationExtension input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.CertificatedProgramStatusDescriptor == input.CertificatedProgramStatusDescriptor ||
                    (this.CertificatedProgramStatusDescriptor != null &&
                    this.CertificatedProgramStatusDescriptor.Equals(input.CertificatedProgramStatusDescriptor))
                ) && 
                (
                    this.CteConcentrationCteProgramAreas == input.CteConcentrationCteProgramAreas ||
                    this.CteConcentrationCteProgramAreas != null &&
                    input.CteConcentrationCteProgramAreas != null &&
                    this.CteConcentrationCteProgramAreas.SequenceEqual(input.CteConcentrationCteProgramAreas)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CertificatedProgramStatusDescriptor != null)
                {
                    hashCode = (hashCode * 59) + this.CertificatedProgramStatusDescriptor.GetHashCode();
                }
                if (this.CteConcentrationCteProgramAreas != null)
                {
                    hashCode = (hashCode * 59) + this.CteConcentrationCteProgramAreas.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // CertificatedProgramStatusDescriptor (string) maxLength
            if (this.CertificatedProgramStatusDescriptor != null && this.CertificatedProgramStatusDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for CertificatedProgramStatusDescriptor, length must be less than 306.", new [] { "CertificatedProgramStatusDescriptor" });
            }

            yield break;
        }
    }

}
