/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// WiStudentDisciplineIncidentBehaviorAssociationExtension
    /// </summary>
    [DataContract(Name = "wi_studentDisciplineIncidentBehaviorAssociationExtension")]
    public partial class WiStudentDisciplineIncidentBehaviorAssociationExtension : IEquatable<WiStudentDisciplineIncidentBehaviorAssociationExtension>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="WiStudentDisciplineIncidentBehaviorAssociationExtension" /> class.
        /// </summary>
        /// <param name="seriousBodilyInjury">Incident resulted in serious bodily injury. Serious Bodily Injury involves a substantial risk of death; extreme physical pain; protracted and obvious disfigurement; or protracted loss or impairment of the function of a bodily member, organ, or faculty (18 USC Section 1365 (3)(h))..</param>
        public WiStudentDisciplineIncidentBehaviorAssociationExtension(bool? seriousBodilyInjury = default(bool?))
        {
            this.SeriousBodilyInjury = seriousBodilyInjury;
        }

        /// <summary>
        /// Incident resulted in serious bodily injury. Serious Bodily Injury involves a substantial risk of death; extreme physical pain; protracted and obvious disfigurement; or protracted loss or impairment of the function of a bodily member, organ, or faculty (18 USC Section 1365 (3)(h)).
        /// </summary>
        /// <value>Incident resulted in serious bodily injury. Serious Bodily Injury involves a substantial risk of death; extreme physical pain; protracted and obvious disfigurement; or protracted loss or impairment of the function of a bodily member, organ, or faculty (18 USC Section 1365 (3)(h)).</value>
        [DataMember(Name = "seriousBodilyInjury", EmitDefaultValue = true)]
        public bool? SeriousBodilyInjury { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class WiStudentDisciplineIncidentBehaviorAssociationExtension {\n");
            sb.Append("  SeriousBodilyInjury: ").Append(SeriousBodilyInjury).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as WiStudentDisciplineIncidentBehaviorAssociationExtension);
        }

        /// <summary>
        /// Returns true if WiStudentDisciplineIncidentBehaviorAssociationExtension instances are equal
        /// </summary>
        /// <param name="input">Instance of WiStudentDisciplineIncidentBehaviorAssociationExtension to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(WiStudentDisciplineIncidentBehaviorAssociationExtension input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.SeriousBodilyInjury == input.SeriousBodilyInjury ||
                    (this.SeriousBodilyInjury != null &&
                    this.SeriousBodilyInjury.Equals(input.SeriousBodilyInjury))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.SeriousBodilyInjury != null)
                {
                    hashCode = (hashCode * 59) + this.SeriousBodilyInjury.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
