/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// WiStudentSchoolAssociationExtension
    /// </summary>
    [DataContract(Name = "wi_studentSchoolAssociationExtension")]
    public partial class WiStudentSchoolAssociationExtension : IEquatable<WiStudentSchoolAssociationExtension>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="WiStudentSchoolAssociationExtension" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected WiStudentSchoolAssociationExtension() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="WiStudentSchoolAssociationExtension" /> class.
        /// </summary>
        /// <param name="enrollmentTypeDescriptor">enrollmentTypeDescriptor (required).</param>
        /// <param name="actualDaysAttendance">actualDaysAttendance.</param>
        /// <param name="partTimeInstructionalMinutes">Instructional minutes for up to two classes for part-time students.</param>
        /// <param name="possibleDaysAttendance">possibleDaysAttendance.</param>
        /// <param name="privateSchoolChoiceProgramParticipant">privateSchoolChoiceProgramParticipant.</param>
        /// <param name="expectedTransferLocalEducationAgencyReference">expectedTransferLocalEducationAgencyReference.</param>
        /// <param name="expectedTransferSchoolReference">expectedTransferSchoolReference.</param>
        /// <param name="receivingServices">An unordered collection of studentSchoolAssociationReceivingServices. The status of a student during a specific count date.</param>
        /// <param name="residencyPeriods">An unordered collection of studentSchoolAssociationResidencyPeriods. The Residency Status of a student for a given portion of a StudentSchoolAssociation when other than a full-time resident for the entire StudentSchoolAssociation..</param>
        public WiStudentSchoolAssociationExtension(string enrollmentTypeDescriptor = default(string), double? actualDaysAttendance = default(double?), int? partTimeInstructionalMinutes = default(int?), double? possibleDaysAttendance = default(double?), bool? privateSchoolChoiceProgramParticipant = default(bool?), EdFiLocalEducationAgencyReference expectedTransferLocalEducationAgencyReference = default(EdFiLocalEducationAgencyReference), EdFiSchoolReference expectedTransferSchoolReference = default(EdFiSchoolReference), List<WiStudentSchoolAssociationReceivingService> receivingServices = default(List<WiStudentSchoolAssociationReceivingService>), List<WiStudentSchoolAssociationResidencyPeriod> residencyPeriods = default(List<WiStudentSchoolAssociationResidencyPeriod>))
        {
            // to ensure "enrollmentTypeDescriptor" is required (not null)
            if (enrollmentTypeDescriptor == null)
            {
                throw new ArgumentNullException("enrollmentTypeDescriptor is a required property for WiStudentSchoolAssociationExtension and cannot be null");
            }
            this.EnrollmentTypeDescriptor = enrollmentTypeDescriptor;
            this.ActualDaysAttendance = actualDaysAttendance;
            this.PartTimeInstructionalMinutes = partTimeInstructionalMinutes;
            this.PossibleDaysAttendance = possibleDaysAttendance;
            this.PrivateSchoolChoiceProgramParticipant = privateSchoolChoiceProgramParticipant;
            this.ExpectedTransferLocalEducationAgencyReference = expectedTransferLocalEducationAgencyReference;
            this.ExpectedTransferSchoolReference = expectedTransferSchoolReference;
            this.ReceivingServices = receivingServices;
            this.ResidencyPeriods = residencyPeriods;
        }

        /// <summary>
        /// Gets or Sets EnrollmentTypeDescriptor
        /// </summary>
        [DataMember(Name = "enrollmentTypeDescriptor", IsRequired = true, EmitDefaultValue = true)]
        public string EnrollmentTypeDescriptor { get; set; }

        /// <summary>
        /// Gets or Sets ActualDaysAttendance
        /// </summary>
        [DataMember(Name = "actualDaysAttendance", EmitDefaultValue = true)]
        public double? ActualDaysAttendance { get; set; }

        /// <summary>
        /// Instructional minutes for up to two classes for part-time students
        /// </summary>
        /// <value>Instructional minutes for up to two classes for part-time students</value>
        [DataMember(Name = "partTimeInstructionalMinutes", EmitDefaultValue = true)]
        public int? PartTimeInstructionalMinutes { get; set; }

        /// <summary>
        /// Gets or Sets PossibleDaysAttendance
        /// </summary>
        [DataMember(Name = "possibleDaysAttendance", EmitDefaultValue = true)]
        public double? PossibleDaysAttendance { get; set; }

        /// <summary>
        /// Gets or Sets PrivateSchoolChoiceProgramParticipant
        /// </summary>
        [DataMember(Name = "privateSchoolChoiceProgramParticipant", EmitDefaultValue = true)]
        public bool? PrivateSchoolChoiceProgramParticipant { get; set; }

        /// <summary>
        /// Gets or Sets ExpectedTransferLocalEducationAgencyReference
        /// </summary>
        [DataMember(Name = "expectedTransferLocalEducationAgencyReference", EmitDefaultValue = false)]
        public EdFiLocalEducationAgencyReference ExpectedTransferLocalEducationAgencyReference { get; set; }

        /// <summary>
        /// Gets or Sets ExpectedTransferSchoolReference
        /// </summary>
        [DataMember(Name = "expectedTransferSchoolReference", EmitDefaultValue = false)]
        public EdFiSchoolReference ExpectedTransferSchoolReference { get; set; }

        /// <summary>
        /// An unordered collection of studentSchoolAssociationReceivingServices. The status of a student during a specific count date
        /// </summary>
        /// <value>An unordered collection of studentSchoolAssociationReceivingServices. The status of a student during a specific count date</value>
        [DataMember(Name = "receivingServices", EmitDefaultValue = false)]
        public List<WiStudentSchoolAssociationReceivingService> ReceivingServices { get; set; }

        /// <summary>
        /// An unordered collection of studentSchoolAssociationResidencyPeriods. The Residency Status of a student for a given portion of a StudentSchoolAssociation when other than a full-time resident for the entire StudentSchoolAssociation.
        /// </summary>
        /// <value>An unordered collection of studentSchoolAssociationResidencyPeriods. The Residency Status of a student for a given portion of a StudentSchoolAssociation when other than a full-time resident for the entire StudentSchoolAssociation.</value>
        [DataMember(Name = "residencyPeriods", EmitDefaultValue = false)]
        public List<WiStudentSchoolAssociationResidencyPeriod> ResidencyPeriods { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class WiStudentSchoolAssociationExtension {\n");
            sb.Append("  EnrollmentTypeDescriptor: ").Append(EnrollmentTypeDescriptor).Append("\n");
            sb.Append("  ActualDaysAttendance: ").Append(ActualDaysAttendance).Append("\n");
            sb.Append("  PartTimeInstructionalMinutes: ").Append(PartTimeInstructionalMinutes).Append("\n");
            sb.Append("  PossibleDaysAttendance: ").Append(PossibleDaysAttendance).Append("\n");
            sb.Append("  PrivateSchoolChoiceProgramParticipant: ").Append(PrivateSchoolChoiceProgramParticipant).Append("\n");
            sb.Append("  ExpectedTransferLocalEducationAgencyReference: ").Append(ExpectedTransferLocalEducationAgencyReference).Append("\n");
            sb.Append("  ExpectedTransferSchoolReference: ").Append(ExpectedTransferSchoolReference).Append("\n");
            sb.Append("  ReceivingServices: ").Append(ReceivingServices).Append("\n");
            sb.Append("  ResidencyPeriods: ").Append(ResidencyPeriods).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as WiStudentSchoolAssociationExtension);
        }

        /// <summary>
        /// Returns true if WiStudentSchoolAssociationExtension instances are equal
        /// </summary>
        /// <param name="input">Instance of WiStudentSchoolAssociationExtension to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(WiStudentSchoolAssociationExtension input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.EnrollmentTypeDescriptor == input.EnrollmentTypeDescriptor ||
                    (this.EnrollmentTypeDescriptor != null &&
                    this.EnrollmentTypeDescriptor.Equals(input.EnrollmentTypeDescriptor))
                ) && 
                (
                    this.ActualDaysAttendance == input.ActualDaysAttendance ||
                    (this.ActualDaysAttendance != null &&
                    this.ActualDaysAttendance.Equals(input.ActualDaysAttendance))
                ) && 
                (
                    this.PartTimeInstructionalMinutes == input.PartTimeInstructionalMinutes ||
                    (this.PartTimeInstructionalMinutes != null &&
                    this.PartTimeInstructionalMinutes.Equals(input.PartTimeInstructionalMinutes))
                ) && 
                (
                    this.PossibleDaysAttendance == input.PossibleDaysAttendance ||
                    (this.PossibleDaysAttendance != null &&
                    this.PossibleDaysAttendance.Equals(input.PossibleDaysAttendance))
                ) && 
                (
                    this.PrivateSchoolChoiceProgramParticipant == input.PrivateSchoolChoiceProgramParticipant ||
                    (this.PrivateSchoolChoiceProgramParticipant != null &&
                    this.PrivateSchoolChoiceProgramParticipant.Equals(input.PrivateSchoolChoiceProgramParticipant))
                ) && 
                (
                    this.ExpectedTransferLocalEducationAgencyReference == input.ExpectedTransferLocalEducationAgencyReference ||
                    (this.ExpectedTransferLocalEducationAgencyReference != null &&
                    this.ExpectedTransferLocalEducationAgencyReference.Equals(input.ExpectedTransferLocalEducationAgencyReference))
                ) && 
                (
                    this.ExpectedTransferSchoolReference == input.ExpectedTransferSchoolReference ||
                    (this.ExpectedTransferSchoolReference != null &&
                    this.ExpectedTransferSchoolReference.Equals(input.ExpectedTransferSchoolReference))
                ) && 
                (
                    this.ReceivingServices == input.ReceivingServices ||
                    this.ReceivingServices != null &&
                    input.ReceivingServices != null &&
                    this.ReceivingServices.SequenceEqual(input.ReceivingServices)
                ) && 
                (
                    this.ResidencyPeriods == input.ResidencyPeriods ||
                    this.ResidencyPeriods != null &&
                    input.ResidencyPeriods != null &&
                    this.ResidencyPeriods.SequenceEqual(input.ResidencyPeriods)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.EnrollmentTypeDescriptor != null)
                {
                    hashCode = (hashCode * 59) + this.EnrollmentTypeDescriptor.GetHashCode();
                }
                if (this.ActualDaysAttendance != null)
                {
                    hashCode = (hashCode * 59) + this.ActualDaysAttendance.GetHashCode();
                }
                if (this.PartTimeInstructionalMinutes != null)
                {
                    hashCode = (hashCode * 59) + this.PartTimeInstructionalMinutes.GetHashCode();
                }
                if (this.PossibleDaysAttendance != null)
                {
                    hashCode = (hashCode * 59) + this.PossibleDaysAttendance.GetHashCode();
                }
                if (this.PrivateSchoolChoiceProgramParticipant != null)
                {
                    hashCode = (hashCode * 59) + this.PrivateSchoolChoiceProgramParticipant.GetHashCode();
                }
                if (this.ExpectedTransferLocalEducationAgencyReference != null)
                {
                    hashCode = (hashCode * 59) + this.ExpectedTransferLocalEducationAgencyReference.GetHashCode();
                }
                if (this.ExpectedTransferSchoolReference != null)
                {
                    hashCode = (hashCode * 59) + this.ExpectedTransferSchoolReference.GetHashCode();
                }
                if (this.ReceivingServices != null)
                {
                    hashCode = (hashCode * 59) + this.ReceivingServices.GetHashCode();
                }
                if (this.ResidencyPeriods != null)
                {
                    hashCode = (hashCode * 59) + this.ResidencyPeriods.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // EnrollmentTypeDescriptor (string) maxLength
            if (this.EnrollmentTypeDescriptor != null && this.EnrollmentTypeDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for EnrollmentTypeDescriptor, length must be less than 306.", new [] { "EnrollmentTypeDescriptor" });
            }

            yield break;
        }
    }

}
