/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// WiStudentSchoolAssociationResidencyPeriod
    /// </summary>
    [DataContract(Name = "wi_studentSchoolAssociationResidencyPeriod")]
    public partial class WiStudentSchoolAssociationResidencyPeriod : IEquatable<WiStudentSchoolAssociationResidencyPeriod>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="WiStudentSchoolAssociationResidencyPeriod" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected WiStudentSchoolAssociationResidencyPeriod() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="WiStudentSchoolAssociationResidencyPeriod" /> class.
        /// </summary>
        /// <param name="residencyStatusDescriptor">An indication of the location of a persons legal residence relative to (within or outside of) the boundaries of the public school attended and its administrative unit. (required).</param>
        /// <param name="beginDate">The month, day, and year on which the student entered the residency status. (required).</param>
        /// <param name="endDate">The month, day, and year on which the student exited the residency status..</param>
        /// <param name="residentLocalEducationAgencyReference">residentLocalEducationAgencyReference.</param>
        public WiStudentSchoolAssociationResidencyPeriod(string residencyStatusDescriptor = default(string), DateTime beginDate = default(DateTime), DateTime? endDate = default(DateTime?), EdFiLocalEducationAgencyReference residentLocalEducationAgencyReference = default(EdFiLocalEducationAgencyReference))
        {
            // to ensure "residencyStatusDescriptor" is required (not null)
            if (residencyStatusDescriptor == null)
            {
                throw new ArgumentNullException("residencyStatusDescriptor is a required property for WiStudentSchoolAssociationResidencyPeriod and cannot be null");
            }
            this.ResidencyStatusDescriptor = residencyStatusDescriptor;
            this.BeginDate = beginDate;
            this.EndDate = endDate;
            this.ResidentLocalEducationAgencyReference = residentLocalEducationAgencyReference;
        }

        /// <summary>
        /// An indication of the location of a persons legal residence relative to (within or outside of) the boundaries of the public school attended and its administrative unit.
        /// </summary>
        /// <value>An indication of the location of a persons legal residence relative to (within or outside of) the boundaries of the public school attended and its administrative unit.</value>
        [DataMember(Name = "residencyStatusDescriptor", IsRequired = true, EmitDefaultValue = true)]
        public string ResidencyStatusDescriptor { get; set; }

        /// <summary>
        /// The month, day, and year on which the student entered the residency status.
        /// </summary>
        /// <value>The month, day, and year on which the student entered the residency status.</value>
        [DataMember(Name = "beginDate", IsRequired = true, EmitDefaultValue = true)]
        [JsonConverter(typeof(OpenAPIDateConverter))]
        public DateTime BeginDate { get; set; }

        /// <summary>
        /// The month, day, and year on which the student exited the residency status.
        /// </summary>
        /// <value>The month, day, and year on which the student exited the residency status.</value>
        [DataMember(Name = "endDate", EmitDefaultValue = true)]
        [JsonConverter(typeof(OpenAPIDateConverter))]
        public DateTime? EndDate { get; set; }

        /// <summary>
        /// Gets or Sets ResidentLocalEducationAgencyReference
        /// </summary>
        [DataMember(Name = "residentLocalEducationAgencyReference", EmitDefaultValue = false)]
        public EdFiLocalEducationAgencyReference ResidentLocalEducationAgencyReference { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class WiStudentSchoolAssociationResidencyPeriod {\n");
            sb.Append("  ResidencyStatusDescriptor: ").Append(ResidencyStatusDescriptor).Append("\n");
            sb.Append("  BeginDate: ").Append(BeginDate).Append("\n");
            sb.Append("  EndDate: ").Append(EndDate).Append("\n");
            sb.Append("  ResidentLocalEducationAgencyReference: ").Append(ResidentLocalEducationAgencyReference).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as WiStudentSchoolAssociationResidencyPeriod);
        }

        /// <summary>
        /// Returns true if WiStudentSchoolAssociationResidencyPeriod instances are equal
        /// </summary>
        /// <param name="input">Instance of WiStudentSchoolAssociationResidencyPeriod to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(WiStudentSchoolAssociationResidencyPeriod input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.ResidencyStatusDescriptor == input.ResidencyStatusDescriptor ||
                    (this.ResidencyStatusDescriptor != null &&
                    this.ResidencyStatusDescriptor.Equals(input.ResidencyStatusDescriptor))
                ) && 
                (
                    this.BeginDate == input.BeginDate ||
                    (this.BeginDate != null &&
                    this.BeginDate.Equals(input.BeginDate))
                ) && 
                (
                    this.EndDate == input.EndDate ||
                    (this.EndDate != null &&
                    this.EndDate.Equals(input.EndDate))
                ) && 
                (
                    this.ResidentLocalEducationAgencyReference == input.ResidentLocalEducationAgencyReference ||
                    (this.ResidentLocalEducationAgencyReference != null &&
                    this.ResidentLocalEducationAgencyReference.Equals(input.ResidentLocalEducationAgencyReference))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ResidencyStatusDescriptor != null)
                {
                    hashCode = (hashCode * 59) + this.ResidencyStatusDescriptor.GetHashCode();
                }
                if (this.BeginDate != null)
                {
                    hashCode = (hashCode * 59) + this.BeginDate.GetHashCode();
                }
                if (this.EndDate != null)
                {
                    hashCode = (hashCode * 59) + this.EndDate.GetHashCode();
                }
                if (this.ResidentLocalEducationAgencyReference != null)
                {
                    hashCode = (hashCode * 59) + this.ResidentLocalEducationAgencyReference.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // ResidencyStatusDescriptor (string) maxLength
            if (this.ResidencyStatusDescriptor != null && this.ResidencyStatusDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ResidencyStatusDescriptor, length must be less than 306.", new [] { "ResidencyStatusDescriptor" });
            }

            yield break;
        }
    }

}
