/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// WiStudentSectionAssociationExtension
    /// </summary>
    [DataContract(Name = "wi_studentSectionAssociationExtension")]
    public partial class WiStudentSectionAssociationExtension : IEquatable<WiStudentSectionAssociationExtension>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="WiStudentSectionAssociationExtension" /> class.
        /// </summary>
        /// <param name="programs">An unordered collection of studentSectionAssociationPrograms. Programs that the student is participating for this section.</param>
        public WiStudentSectionAssociationExtension(List<WiStudentSectionAssociationProgram> programs = default(List<WiStudentSectionAssociationProgram>))
        {
            this.Programs = programs;
        }

        /// <summary>
        /// An unordered collection of studentSectionAssociationPrograms. Programs that the student is participating for this section
        /// </summary>
        /// <value>An unordered collection of studentSectionAssociationPrograms. Programs that the student is participating for this section</value>
        [DataMember(Name = "programs", EmitDefaultValue = false)]
        public List<WiStudentSectionAssociationProgram> Programs { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class WiStudentSectionAssociationExtension {\n");
            sb.Append("  Programs: ").Append(Programs).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as WiStudentSectionAssociationExtension);
        }

        /// <summary>
        /// Returns true if WiStudentSectionAssociationExtension instances are equal
        /// </summary>
        /// <param name="input">Instance of WiStudentSectionAssociationExtension to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(WiStudentSectionAssociationExtension input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Programs == input.Programs ||
                    this.Programs != null &&
                    input.Programs != null &&
                    this.Programs.SequenceEqual(input.Programs)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Programs != null)
                {
                    hashCode = (hashCode * 59) + this.Programs.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
