/*
 * Validations API Endpoint
 *
 * L2 data validation from WI DPI.
 *
 * The version of the OpenAPI document: 1.0.0
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Validations
{
    /// <summary>
    /// AdditionalContext
    /// </summary>
    [DataContract(Name = "AdditionalContext")]
    public partial class AdditionalContext : IEquatable<AdditionalContext>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AdditionalContext" /> class.
        /// </summary>
        /// <param name="identificationCode">Custom data element which provides additional context for the result..</param>
        /// <param name="customizationValue">Additional context for the result..</param>
        public AdditionalContext(string identificationCode = default(string), string customizationValue = default(string))
        {
            this.IdentificationCode = identificationCode;
            this.CustomizationValue = customizationValue;
        }

        /// <summary>
        /// Custom data element which provides additional context for the result.
        /// </summary>
        /// <value>Custom data element which provides additional context for the result.</value>
        [DataMember(Name = "identificationCode", EmitDefaultValue = false)]
        public string IdentificationCode { get; set; }

        /// <summary>
        /// Additional context for the result.
        /// </summary>
        /// <value>Additional context for the result.</value>
        [DataMember(Name = "customizationValue", EmitDefaultValue = false)]
        public string CustomizationValue { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class AdditionalContext {\n");
            sb.Append("  IdentificationCode: ").Append(IdentificationCode).Append("\n");
            sb.Append("  CustomizationValue: ").Append(CustomizationValue).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as AdditionalContext);
        }

        /// <summary>
        /// Returns true if AdditionalContext instances are equal
        /// </summary>
        /// <param name="input">Instance of AdditionalContext to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(AdditionalContext input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.IdentificationCode == input.IdentificationCode ||
                    (this.IdentificationCode != null &&
                    this.IdentificationCode.Equals(input.IdentificationCode))
                ) && 
                (
                    this.CustomizationValue == input.CustomizationValue ||
                    (this.CustomizationValue != null &&
                    this.CustomizationValue.Equals(input.CustomizationValue))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.IdentificationCode != null)
                {
                    hashCode = (hashCode * 59) + this.IdentificationCode.GetHashCode();
                }
                if (this.CustomizationValue != null)
                {
                    hashCode = (hashCode * 59) + this.CustomizationValue.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // IdentificationCode (string) maxLength
            if (this.IdentificationCode != null && this.IdentificationCode.Length > 1024)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for IdentificationCode, length must be less than 1024.", new [] { "IdentificationCode" });
            }

            // CustomizationValue (string) maxLength
            if (this.CustomizationValue != null && this.CustomizationValue.Length > 4000)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for CustomizationValue, length must be less than 4000.", new [] { "CustomizationValue" });
            }

            yield break;
        }
    }

}
