/*
 * Validations API Endpoint
 *
 * L2 data validation from WI DPI.
 *
 * The version of the OpenAPI document: 1.0.0
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Validations
{
    /// <summary>
    /// This is the actual results from the validation rule.
    /// </summary>
    [DataContract(Name = "ValidationResult")]
    public partial class ValidationResult : IEquatable<ValidationResult>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ValidationResult" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ValidationResult() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ValidationResult" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="resultIdentifier">This is a unique id for the validation result. (required).</param>
        /// <param name="validationRuleReference">validationRuleReference (required).</param>
        /// <param name="validationRuleRunReference">validationRuleRunReference.</param>
        /// <param name="resourceId">This is the unique identifier in the ODS that is used to reference a specific resource.  Examples include an Id, StudentUniqueId or EducationOrganizationId..</param>
        /// <param name="resourceType">This is the resource associated with the validation rule. This is denormalized from the validation rule, every instance of a given RuleId will have the same Ed-Fi resource.</param>
        /// <param name="educationOrganizationReference">educationOrganizationReference (required).</param>
        /// <param name="studentReference">studentReference.</param>
        /// <param name="staffReference">staffReference.</param>
        /// <param name="_namespace">Along with EducationOrganization, this can be used for limiting what systems can consume the validation results and routing the validation results within the consuming system..</param>
        /// <param name="additionalContext">Includes the details that were used in the evaluation of the validation rule..</param>
        public ValidationResult(string id = default(string), string resultIdentifier = default(string), ValidationResultValidationRuleReference validationRuleReference = default(ValidationResultValidationRuleReference), ValidationResultValidationRuleRunReference validationRuleRunReference = default(ValidationResultValidationRuleRunReference), string resourceId = default(string), string resourceType = default(string), ValidationResultEducationOrganizationReference educationOrganizationReference = default(ValidationResultEducationOrganizationReference), ValidationResultStudentReference studentReference = default(ValidationResultStudentReference), ValidationResultStaffReference staffReference = default(ValidationResultStaffReference), string _namespace = default(string), List<AdditionalContext> additionalContext = default(List<AdditionalContext>))
        {
            // to ensure "resultIdentifier" is required (not null)
            if (resultIdentifier == null)
            {
                throw new ArgumentNullException("resultIdentifier is a required property for ValidationResult and cannot be null");
            }
            this.ResultIdentifier = resultIdentifier;
            // to ensure "validationRuleReference" is required (not null)
            if (validationRuleReference == null)
            {
                throw new ArgumentNullException("validationRuleReference is a required property for ValidationResult and cannot be null");
            }
            this.ValidationRuleReference = validationRuleReference;
            // to ensure "educationOrganizationReference" is required (not null)
            if (educationOrganizationReference == null)
            {
                throw new ArgumentNullException("educationOrganizationReference is a required property for ValidationResult and cannot be null");
            }
            this.EducationOrganizationReference = educationOrganizationReference;
            this.Id = id;
            this.ValidationRuleRunReference = validationRuleRunReference;
            this.ResourceId = resourceId;
            this.ResourceType = resourceType;
            this.StudentReference = studentReference;
            this.StaffReference = staffReference;
            this.Namespace = _namespace;
            this.AdditionalContext = additionalContext;
        }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public string Id { get; set; }

        /// <summary>
        /// This is a unique id for the validation result.
        /// </summary>
        /// <value>This is a unique id for the validation result.</value>
        [DataMember(Name = "resultIdentifier", IsRequired = true, EmitDefaultValue = true)]
        public string ResultIdentifier { get; set; }

        /// <summary>
        /// Gets or Sets ValidationRuleReference
        /// </summary>
        [DataMember(Name = "validationRuleReference", IsRequired = true, EmitDefaultValue = true)]
        public ValidationResultValidationRuleReference ValidationRuleReference { get; set; }

        /// <summary>
        /// Gets or Sets ValidationRuleRunReference
        /// </summary>
        [DataMember(Name = "validationRuleRunReference", EmitDefaultValue = false)]
        public ValidationResultValidationRuleRunReference ValidationRuleRunReference { get; set; }

        /// <summary>
        /// This is the unique identifier in the ODS that is used to reference a specific resource.  Examples include an Id, StudentUniqueId or EducationOrganizationId.
        /// </summary>
        /// <value>This is the unique identifier in the ODS that is used to reference a specific resource.  Examples include an Id, StudentUniqueId or EducationOrganizationId.</value>
        [DataMember(Name = "resourceId", EmitDefaultValue = false)]
        public string ResourceId { get; set; }

        /// <summary>
        /// This is the resource associated with the validation rule. This is denormalized from the validation rule, every instance of a given RuleId will have the same Ed-Fi resource
        /// </summary>
        /// <value>This is the resource associated with the validation rule. This is denormalized from the validation rule, every instance of a given RuleId will have the same Ed-Fi resource</value>
        [DataMember(Name = "resourceType", EmitDefaultValue = false)]
        public string ResourceType { get; set; }

        /// <summary>
        /// Gets or Sets EducationOrganizationReference
        /// </summary>
        [DataMember(Name = "educationOrganizationReference", IsRequired = true, EmitDefaultValue = true)]
        public ValidationResultEducationOrganizationReference EducationOrganizationReference { get; set; }

        /// <summary>
        /// Gets or Sets StudentReference
        /// </summary>
        [DataMember(Name = "studentReference", EmitDefaultValue = false)]
        public ValidationResultStudentReference StudentReference { get; set; }

        /// <summary>
        /// Gets or Sets StaffReference
        /// </summary>
        [DataMember(Name = "staffReference", EmitDefaultValue = false)]
        public ValidationResultStaffReference StaffReference { get; set; }

        /// <summary>
        /// Along with EducationOrganization, this can be used for limiting what systems can consume the validation results and routing the validation results within the consuming system.
        /// </summary>
        /// <value>Along with EducationOrganization, this can be used for limiting what systems can consume the validation results and routing the validation results within the consuming system.</value>
        [DataMember(Name = "namespace", EmitDefaultValue = false)]
        public string Namespace { get; set; }

        /// <summary>
        /// Includes the details that were used in the evaluation of the validation rule.
        /// </summary>
        /// <value>Includes the details that were used in the evaluation of the validation rule.</value>
        [DataMember(Name = "additionalContext", EmitDefaultValue = false)]
        public List<AdditionalContext> AdditionalContext { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ValidationResult {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  ResultIdentifier: ").Append(ResultIdentifier).Append("\n");
            sb.Append("  ValidationRuleReference: ").Append(ValidationRuleReference).Append("\n");
            sb.Append("  ValidationRuleRunReference: ").Append(ValidationRuleRunReference).Append("\n");
            sb.Append("  ResourceId: ").Append(ResourceId).Append("\n");
            sb.Append("  ResourceType: ").Append(ResourceType).Append("\n");
            sb.Append("  EducationOrganizationReference: ").Append(EducationOrganizationReference).Append("\n");
            sb.Append("  StudentReference: ").Append(StudentReference).Append("\n");
            sb.Append("  StaffReference: ").Append(StaffReference).Append("\n");
            sb.Append("  Namespace: ").Append(Namespace).Append("\n");
            sb.Append("  AdditionalContext: ").Append(AdditionalContext).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ValidationResult);
        }

        /// <summary>
        /// Returns true if ValidationResult instances are equal
        /// </summary>
        /// <param name="input">Instance of ValidationResult to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ValidationResult input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.ResultIdentifier == input.ResultIdentifier ||
                    (this.ResultIdentifier != null &&
                    this.ResultIdentifier.Equals(input.ResultIdentifier))
                ) && 
                (
                    this.ValidationRuleReference == input.ValidationRuleReference ||
                    (this.ValidationRuleReference != null &&
                    this.ValidationRuleReference.Equals(input.ValidationRuleReference))
                ) && 
                (
                    this.ValidationRuleRunReference == input.ValidationRuleRunReference ||
                    (this.ValidationRuleRunReference != null &&
                    this.ValidationRuleRunReference.Equals(input.ValidationRuleRunReference))
                ) && 
                (
                    this.ResourceId == input.ResourceId ||
                    (this.ResourceId != null &&
                    this.ResourceId.Equals(input.ResourceId))
                ) && 
                (
                    this.ResourceType == input.ResourceType ||
                    (this.ResourceType != null &&
                    this.ResourceType.Equals(input.ResourceType))
                ) && 
                (
                    this.EducationOrganizationReference == input.EducationOrganizationReference ||
                    (this.EducationOrganizationReference != null &&
                    this.EducationOrganizationReference.Equals(input.EducationOrganizationReference))
                ) && 
                (
                    this.StudentReference == input.StudentReference ||
                    (this.StudentReference != null &&
                    this.StudentReference.Equals(input.StudentReference))
                ) && 
                (
                    this.StaffReference == input.StaffReference ||
                    (this.StaffReference != null &&
                    this.StaffReference.Equals(input.StaffReference))
                ) && 
                (
                    this.Namespace == input.Namespace ||
                    (this.Namespace != null &&
                    this.Namespace.Equals(input.Namespace))
                ) && 
                (
                    this.AdditionalContext == input.AdditionalContext ||
                    this.AdditionalContext != null &&
                    input.AdditionalContext != null &&
                    this.AdditionalContext.SequenceEqual(input.AdditionalContext)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                {
                    hashCode = (hashCode * 59) + this.Id.GetHashCode();
                }
                if (this.ResultIdentifier != null)
                {
                    hashCode = (hashCode * 59) + this.ResultIdentifier.GetHashCode();
                }
                if (this.ValidationRuleReference != null)
                {
                    hashCode = (hashCode * 59) + this.ValidationRuleReference.GetHashCode();
                }
                if (this.ValidationRuleRunReference != null)
                {
                    hashCode = (hashCode * 59) + this.ValidationRuleRunReference.GetHashCode();
                }
                if (this.ResourceId != null)
                {
                    hashCode = (hashCode * 59) + this.ResourceId.GetHashCode();
                }
                if (this.ResourceType != null)
                {
                    hashCode = (hashCode * 59) + this.ResourceType.GetHashCode();
                }
                if (this.EducationOrganizationReference != null)
                {
                    hashCode = (hashCode * 59) + this.EducationOrganizationReference.GetHashCode();
                }
                if (this.StudentReference != null)
                {
                    hashCode = (hashCode * 59) + this.StudentReference.GetHashCode();
                }
                if (this.StaffReference != null)
                {
                    hashCode = (hashCode * 59) + this.StaffReference.GetHashCode();
                }
                if (this.Namespace != null)
                {
                    hashCode = (hashCode * 59) + this.Namespace.GetHashCode();
                }
                if (this.AdditionalContext != null)
                {
                    hashCode = (hashCode * 59) + this.AdditionalContext.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // ResultIdentifier (string) maxLength
            if (this.ResultIdentifier != null && this.ResultIdentifier.Length > 100)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ResultIdentifier, length must be less than 100.", new [] { "ResultIdentifier" });
            }

            // ResourceId (string) maxLength
            if (this.ResourceId != null && this.ResourceId.Length > 100)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ResourceId, length must be less than 100.", new [] { "ResourceId" });
            }

            // ResourceType (string) maxLength
            if (this.ResourceType != null && this.ResourceType.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ResourceType, length must be less than 128.", new [] { "ResourceType" });
            }

            // Namespace (string) maxLength
            if (this.Namespace != null && this.Namespace.Length > 255)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Namespace, length must be less than 255.", new [] { "Namespace" });
            }

            yield break;
        }
    }

}
