/*
 * Validations API Endpoint
 *
 * L2 data validation from WI DPI.
 *
 * The version of the OpenAPI document: 1.0.0
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Validations
{
    /// <summary>
    /// This refers (foreign key) back up to the validation rule run.
    /// </summary>
    [DataContract(Name = "ValidationResult_validationRuleReference")]
    public partial class ValidationResultValidationRuleReference : IEquatable<ValidationResultValidationRuleReference>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ValidationResultValidationRuleReference" /> class.
        /// </summary>
        /// <param name="ruleIdentifier">The unique Id for a validation rule..</param>
        /// <param name="ruleSource">The source or origin of the rule..</param>
        /// <param name="link">link.</param>
        public ValidationResultValidationRuleReference(string ruleIdentifier = default(string), string ruleSource = default(string), ValidationRuleReferenceLink link = default(ValidationRuleReferenceLink))
        {
            this.RuleIdentifier = ruleIdentifier;
            this.RuleSource = ruleSource;
            this.Link = link;
        }

        /// <summary>
        /// The unique Id for a validation rule.
        /// </summary>
        /// <value>The unique Id for a validation rule.</value>
        [DataMember(Name = "ruleIdentifier", EmitDefaultValue = false)]
        public string RuleIdentifier { get; set; }

        /// <summary>
        /// The source or origin of the rule.
        /// </summary>
        /// <value>The source or origin of the rule.</value>
        [DataMember(Name = "ruleSource", EmitDefaultValue = false)]
        public string RuleSource { get; set; }

        /// <summary>
        /// Gets or Sets Link
        /// </summary>
        [DataMember(Name = "link", EmitDefaultValue = false)]
        public ValidationRuleReferenceLink Link { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ValidationResultValidationRuleReference {\n");
            sb.Append("  RuleIdentifier: ").Append(RuleIdentifier).Append("\n");
            sb.Append("  RuleSource: ").Append(RuleSource).Append("\n");
            sb.Append("  Link: ").Append(Link).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ValidationResultValidationRuleReference);
        }

        /// <summary>
        /// Returns true if ValidationResultValidationRuleReference instances are equal
        /// </summary>
        /// <param name="input">Instance of ValidationResultValidationRuleReference to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ValidationResultValidationRuleReference input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.RuleIdentifier == input.RuleIdentifier ||
                    (this.RuleIdentifier != null &&
                    this.RuleIdentifier.Equals(input.RuleIdentifier))
                ) && 
                (
                    this.RuleSource == input.RuleSource ||
                    (this.RuleSource != null &&
                    this.RuleSource.Equals(input.RuleSource))
                ) && 
                (
                    this.Link == input.Link ||
                    (this.Link != null &&
                    this.Link.Equals(input.Link))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.RuleIdentifier != null)
                {
                    hashCode = (hashCode * 59) + this.RuleIdentifier.GetHashCode();
                }
                if (this.RuleSource != null)
                {
                    hashCode = (hashCode * 59) + this.RuleSource.GetHashCode();
                }
                if (this.Link != null)
                {
                    hashCode = (hashCode * 59) + this.Link.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
