/*
 * Validations API Endpoint
 *
 * L2 data validation from WI DPI.
 *
 * The version of the OpenAPI document: 1.0.0
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Validations
{
    /// <summary>
    /// This is a unique id that points back to the validation rule that caused the result to be produced.
    /// </summary>
    [DataContract(Name = "ValidationResult_validationRuleRunReference")]
    public partial class ValidationResultValidationRuleRunReference : IEquatable<ValidationResultValidationRuleRunReference>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ValidationResultValidationRuleRunReference" /> class.
        /// </summary>
        /// <param name="runIdentifier">This is a unique Id for each run.</param>
        /// <param name="link">link.</param>
        public ValidationResultValidationRuleRunReference(string runIdentifier = default(string), ValidationRuleReferenceLink link = default(ValidationRuleReferenceLink))
        {
            this.RunIdentifier = runIdentifier;
            this.Link = link;
        }

        /// <summary>
        /// This is a unique Id for each run
        /// </summary>
        /// <value>This is a unique Id for each run</value>
        [DataMember(Name = "runIdentifier", EmitDefaultValue = false)]
        public string RunIdentifier { get; set; }

        /// <summary>
        /// Gets or Sets Link
        /// </summary>
        [DataMember(Name = "link", EmitDefaultValue = false)]
        public ValidationRuleReferenceLink Link { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ValidationResultValidationRuleRunReference {\n");
            sb.Append("  RunIdentifier: ").Append(RunIdentifier).Append("\n");
            sb.Append("  Link: ").Append(Link).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ValidationResultValidationRuleRunReference);
        }

        /// <summary>
        /// Returns true if ValidationResultValidationRuleRunReference instances are equal
        /// </summary>
        /// <param name="input">Instance of ValidationResultValidationRuleRunReference to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ValidationResultValidationRuleRunReference input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.RunIdentifier == input.RunIdentifier ||
                    (this.RunIdentifier != null &&
                    this.RunIdentifier.Equals(input.RunIdentifier))
                ) && 
                (
                    this.Link == input.Link ||
                    (this.Link != null &&
                    this.Link.Equals(input.Link))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.RunIdentifier != null)
                {
                    hashCode = (hashCode * 59) + this.RunIdentifier.GetHashCode();
                }
                if (this.Link != null)
                {
                    hashCode = (hashCode * 59) + this.Link.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
