/*
 * Validations API Endpoint
 *
 * L2 data validation from WI DPI.
 *
 * The version of the OpenAPI document: 1.0.0
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Validations
{
    /// <summary>
    /// ValidationRuleReferenceLink
    /// </summary>
    [DataContract(Name = "ValidationRuleReference_link")]
    public partial class ValidationRuleReferenceLink : IEquatable<ValidationRuleReferenceLink>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ValidationRuleReferenceLink" /> class.
        /// </summary>
        /// <param name="rel">Describes the nature of the relationship to the referenced resource.</param>
        /// <param name="href">The URL to the related resource.</param>
        public ValidationRuleReferenceLink(string rel = default(string), string href = default(string))
        {
            this.Rel = rel;
            this.Href = href;
        }

        /// <summary>
        /// Describes the nature of the relationship to the referenced resource
        /// </summary>
        /// <value>Describes the nature of the relationship to the referenced resource</value>
        [DataMember(Name = "rel", EmitDefaultValue = false)]
        public string Rel { get; set; }

        /// <summary>
        /// The URL to the related resource
        /// </summary>
        /// <value>The URL to the related resource</value>
        [DataMember(Name = "href", EmitDefaultValue = false)]
        public string Href { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ValidationRuleReferenceLink {\n");
            sb.Append("  Rel: ").Append(Rel).Append("\n");
            sb.Append("  Href: ").Append(Href).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ValidationRuleReferenceLink);
        }

        /// <summary>
        /// Returns true if ValidationRuleReferenceLink instances are equal
        /// </summary>
        /// <param name="input">Instance of ValidationRuleReferenceLink to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ValidationRuleReferenceLink input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Rel == input.Rel ||
                    (this.Rel != null &&
                    this.Rel.Equals(input.Rel))
                ) && 
                (
                    this.Href == input.Href ||
                    (this.Href != null &&
                    this.Href.Equals(input.Href))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Rel != null)
                {
                    hashCode = (hashCode * 59) + this.Rel.GetHashCode();
                }
                if (this.Href != null)
                {
                    hashCode = (hashCode * 59) + this.Href.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
