/*
 * Validations API Endpoint
 *
 * L2 data validation from WI DPI.
 *
 * The version of the OpenAPI document: 1.0.0
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Validations
{
    /// <summary>
    /// This element will track the runs of the validation rules.
    /// </summary>
    [DataContract(Name = "ValidationRuleRun")]
    public partial class ValidationRuleRun : IEquatable<ValidationRuleRun>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ValidationRuleRun" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ValidationRuleRun() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ValidationRuleRun" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="runIdentifier">This is a unique Id for each run (required).</param>
        /// <param name="runStartDateTime">This is time that the validation run was started. (required).</param>
        /// <param name="runFinishDateTime">This is the time the validation run finished..</param>
        /// <param name="runStatusDescriptor">This will denote the status of the validation run.  Possible values include &#39;Running&#39;,&#39;Finished&#39;,&#39;Stopped-manual&#39;,&#39;Stopped-Error&#39; (required).</param>
        /// <param name="host">The name of the Host or ODS that was evaluated in this run.</param>
        /// <param name="validationEngine">A reference to the validation engine that was responsible for this run.</param>
        /// <param name="educationOrganizationReference">educationOrganizationReference.</param>
        public ValidationRuleRun(string id = default(string), string runIdentifier = default(string), DateTime runStartDateTime = default(DateTime), DateTime runFinishDateTime = default(DateTime), string runStatusDescriptor = default(string), string host = default(string), string validationEngine = default(string), ValidationRuleRunEducationOrganizationReference educationOrganizationReference = default(ValidationRuleRunEducationOrganizationReference))
        {
            // to ensure "runIdentifier" is required (not null)
            if (runIdentifier == null)
            {
                throw new ArgumentNullException("runIdentifier is a required property for ValidationRuleRun and cannot be null");
            }
            this.RunIdentifier = runIdentifier;
            this.RunStartDateTime = runStartDateTime;
            // to ensure "runStatusDescriptor" is required (not null)
            if (runStatusDescriptor == null)
            {
                throw new ArgumentNullException("runStatusDescriptor is a required property for ValidationRuleRun and cannot be null");
            }
            this.RunStatusDescriptor = runStatusDescriptor;
            this.Id = id;
            this.RunFinishDateTime = runFinishDateTime;
            this.Host = host;
            this.ValidationEngine = validationEngine;
            this.EducationOrganizationReference = educationOrganizationReference;
        }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public string Id { get; set; }

        /// <summary>
        /// This is a unique Id for each run
        /// </summary>
        /// <value>This is a unique Id for each run</value>
        [DataMember(Name = "runIdentifier", IsRequired = true, EmitDefaultValue = true)]
        public string RunIdentifier { get; set; }

        /// <summary>
        /// This is time that the validation run was started.
        /// </summary>
        /// <value>This is time that the validation run was started.</value>
        [DataMember(Name = "runStartDateTime", IsRequired = true, EmitDefaultValue = true)]
        public DateTime RunStartDateTime { get; set; }

        /// <summary>
        /// This is the time the validation run finished.
        /// </summary>
        /// <value>This is the time the validation run finished.</value>
        [DataMember(Name = "runFinishDateTime", EmitDefaultValue = false)]
        public DateTime RunFinishDateTime { get; set; }

        /// <summary>
        /// This will denote the status of the validation run.  Possible values include &#39;Running&#39;,&#39;Finished&#39;,&#39;Stopped-manual&#39;,&#39;Stopped-Error&#39;
        /// </summary>
        /// <value>This will denote the status of the validation run.  Possible values include &#39;Running&#39;,&#39;Finished&#39;,&#39;Stopped-manual&#39;,&#39;Stopped-Error&#39;</value>
        [DataMember(Name = "runStatusDescriptor", IsRequired = true, EmitDefaultValue = true)]
        public string RunStatusDescriptor { get; set; }

        /// <summary>
        /// The name of the Host or ODS that was evaluated in this run
        /// </summary>
        /// <value>The name of the Host or ODS that was evaluated in this run</value>
        [DataMember(Name = "host", EmitDefaultValue = false)]
        public string Host { get; set; }

        /// <summary>
        /// A reference to the validation engine that was responsible for this run
        /// </summary>
        /// <value>A reference to the validation engine that was responsible for this run</value>
        [DataMember(Name = "validationEngine", EmitDefaultValue = false)]
        public string ValidationEngine { get; set; }

        /// <summary>
        /// Gets or Sets EducationOrganizationReference
        /// </summary>
        [DataMember(Name = "educationOrganizationReference", EmitDefaultValue = false)]
        public ValidationRuleRunEducationOrganizationReference EducationOrganizationReference { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ValidationRuleRun {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  RunIdentifier: ").Append(RunIdentifier).Append("\n");
            sb.Append("  RunStartDateTime: ").Append(RunStartDateTime).Append("\n");
            sb.Append("  RunFinishDateTime: ").Append(RunFinishDateTime).Append("\n");
            sb.Append("  RunStatusDescriptor: ").Append(RunStatusDescriptor).Append("\n");
            sb.Append("  Host: ").Append(Host).Append("\n");
            sb.Append("  ValidationEngine: ").Append(ValidationEngine).Append("\n");
            sb.Append("  EducationOrganizationReference: ").Append(EducationOrganizationReference).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ValidationRuleRun);
        }

        /// <summary>
        /// Returns true if ValidationRuleRun instances are equal
        /// </summary>
        /// <param name="input">Instance of ValidationRuleRun to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ValidationRuleRun input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.RunIdentifier == input.RunIdentifier ||
                    (this.RunIdentifier != null &&
                    this.RunIdentifier.Equals(input.RunIdentifier))
                ) && 
                (
                    this.RunStartDateTime == input.RunStartDateTime ||
                    (this.RunStartDateTime != null &&
                    this.RunStartDateTime.Equals(input.RunStartDateTime))
                ) && 
                (
                    this.RunFinishDateTime == input.RunFinishDateTime ||
                    (this.RunFinishDateTime != null &&
                    this.RunFinishDateTime.Equals(input.RunFinishDateTime))
                ) && 
                (
                    this.RunStatusDescriptor == input.RunStatusDescriptor ||
                    (this.RunStatusDescriptor != null &&
                    this.RunStatusDescriptor.Equals(input.RunStatusDescriptor))
                ) && 
                (
                    this.Host == input.Host ||
                    (this.Host != null &&
                    this.Host.Equals(input.Host))
                ) && 
                (
                    this.ValidationEngine == input.ValidationEngine ||
                    (this.ValidationEngine != null &&
                    this.ValidationEngine.Equals(input.ValidationEngine))
                ) && 
                (
                    this.EducationOrganizationReference == input.EducationOrganizationReference ||
                    (this.EducationOrganizationReference != null &&
                    this.EducationOrganizationReference.Equals(input.EducationOrganizationReference))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                {
                    hashCode = (hashCode * 59) + this.Id.GetHashCode();
                }
                if (this.RunIdentifier != null)
                {
                    hashCode = (hashCode * 59) + this.RunIdentifier.GetHashCode();
                }
                if (this.RunStartDateTime != null)
                {
                    hashCode = (hashCode * 59) + this.RunStartDateTime.GetHashCode();
                }
                if (this.RunFinishDateTime != null)
                {
                    hashCode = (hashCode * 59) + this.RunFinishDateTime.GetHashCode();
                }
                if (this.RunStatusDescriptor != null)
                {
                    hashCode = (hashCode * 59) + this.RunStatusDescriptor.GetHashCode();
                }
                if (this.Host != null)
                {
                    hashCode = (hashCode * 59) + this.Host.GetHashCode();
                }
                if (this.ValidationEngine != null)
                {
                    hashCode = (hashCode * 59) + this.ValidationEngine.GetHashCode();
                }
                if (this.EducationOrganizationReference != null)
                {
                    hashCode = (hashCode * 59) + this.EducationOrganizationReference.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // RunIdentifier (string) maxLength
            if (this.RunIdentifier != null && this.RunIdentifier.Length > 100)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for RunIdentifier, length must be less than 100.", new [] { "RunIdentifier" });
            }

            // RunStatusDescriptor (string) maxLength
            if (this.RunStatusDescriptor != null && this.RunStatusDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for RunStatusDescriptor, length must be less than 306.", new [] { "RunStatusDescriptor" });
            }

            // Host (string) maxLength
            if (this.Host != null && this.Host.Length > 100)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Host, length must be less than 100.", new [] { "Host" });
            }

            // ValidationEngine (string) maxLength
            if (this.ValidationEngine != null && this.ValidationEngine.Length > 100)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ValidationEngine, length must be less than 100.", new [] { "ValidationEngine" });
            }

            yield break;
        }
    }

}
